#include "stdafx.h"
#include "MsgList.h"

CMsgList::CMsgList() {
    mutex.reset(new boost::mutex);
}

CMsgList::~CMsgList() {
}

void CMsgList::Clear() {
    boost::mutex::scoped_lock lock(*mutex);
    m_vctMsg.clear();
}

namespace {
    bool IsLess(const CMsgList::SMsg& a, const CMsgList::SMsg& b) {
        if (a.nPID < b.nPID) return true;
        if (b.nPID < a.nPID) return false;
        return (a.nNum < b.nNum);
    }
    int InnerAdd(boost::ptr_vector<CMsgList::SMsg>& vct, CMsgList::SMsg* ps) {
        auto_ptr<CMsgList::SMsg> s(ps); //  O΍ɔÔauto_ptr
        for (size_t i = 0, n = vct.size(); i < n; i++) {
            if (IsLess(vct[i], *s)) {
                // 
            }
            else {
                // ǉďI
                vct.insert(vct.begin() + i, s.release());
                return int(i);
            }
        }
        // ɒǉďI
        vct.push_back(s.release());
        return int(vct.size() - 1);
    }
}
int CMsgList::Add(int nPID, int nNum, const string& msg) {
    boost::mutex::scoped_lock lock(*mutex);
    return InnerAdd(m_vctMsg, new CMsgList::SMsg(nPID, nNum, msg));
}

void CMsgList::Delete(int i) {
    boost::mutex::scoped_lock lock(*mutex);
    if (IsValidIndex(i)) {
        m_vctMsg.erase(m_vctMsg.begin() + i);
    }
}
