#pragma once
#include "CommonArchiverDll.h"
#include "../Windows/Dll.h"
namespace Themis {

/**
    A[JCo[DLL̒Pȃbp[B

    g Archiver.cpp ƂQƁB
*/
class CArchiverDll : private boost::noncopyable {
public:
    /// t@C̃XgAbvƂB
    class CFindFile : private boost::noncopyable {
    public:
        ~CFindFile();
        inline bool ToNext() {
            typedef int (WINAPI* FnArcFindNext)(void* hArc, Detail::INDIVIDUALINFO* lpSubInfo);
            return static_cast<FnArcFindNext>(m_fnNext)(m_hArc, &m_info) == 0;
        }
        const Detail::INDIVIDUALINFO& GetInfo() const { return m_info; }

    private:
        friend class CArchiverDll;
        CFindFile(boost::recursive_mutex& e, void* hArc, Detail::INDIVIDUALINFO& info, void* fnToNext, void* fnClose);
        boost::recursive_mutex::scoped_lock m_lock;
        Detail::INDIVIDUALINFO  m_info;
        void*   m_hArc;
        void*   m_fnNext;
        void*   m_fnClose;
    };

    BOOST_STATIC_CONSTANT(int, FNAME_MAX32 = 512);
    typedef struct {
        DWORD   dwFileSize;
        DWORD   dwWriteSize;
        char    szSourceFileName[FNAME_MAX32 + 1];
        char    dummy1[3];
        char    szDestFileName[FNAME_MAX32 + 1];
        char    dummy[3];
    } EXTRACTINGINFO;
    typedef struct {
        EXTRACTINGINFO exinfo;
        DWORD   dwCompressedSize;
        DWORD   dwCRC;
        UINT    uOSType;
        WORD    wRatio;
        WORD    wDate;
        WORD    wTime;
        char    szAttribute[8];
        char    szMode[8];
    }  EXTRACTINGINFOEX;
    typedef BOOL (CALLBACK* FnArchiverProc)(HWND hWnd, UINT uMsg, UINT nState, EXTRACTINGINFOEX* pInfo);

private:
    CArchiverDll(const string& strDllName, const string& strFuncPrefix);

public:
    ~CArchiverDll();

    /// DLL肭ǂݍ߂ꂽȂtrue
    bool IsReady() const { return m_pDll.get() != NULL; }

    //@{ DLL̓샂[h̐ݒB
    void SetCursorMode(bool b);
    void SetBackGroundMode(bool b);
    //@}

    /// DLL쒆ȂtrueBUNLHA32.DLLȏꍇA̎̑sƃG[oۂB
    bool IsRunning();
    /// DLL쒆Ȃ҂
    bool WaitForEndRunning(int nMaxSleep = 10);

    /// ɂƂĐ`FbN
    bool CheckArchive(const string& strFileName, int nMode);

    /// t@C̃XgAbvƂBsNULL
    std::tr1::shared_ptr<CFindFile> FindFile(HWND hWnd, const string& strFileName, DWORD dwMode);

    /// 7-zip32.dll̃\bhɂǂ̔ʗpBłWrapperBڂAPIhLgȂǂQ
    bool GetArcCompressedSizeEx(CFindFile& findFile, Detail::ULHA_INT64& size);
    /// k@̎擾
    string GetMethod(CFindFile& findFile);

    /// R}h̑MBsO΂B
    void Command(HWND hWnd, const string& strCmd);

    /// ։𓀁Bsfalse
    bool ExtractMem(HWND hWnd, const string& strCmd, void* p, size_t n, time_t* pTime = NULL, WORD* pwAttr = NULL, DWORD* pdwWriteSize = NULL);

    /// RtBO_CAO̕\BsOH
    void ConfigDialog(HWND hWnd, char* pszCmdBuf);

    /// R[obN֐̐ݒ
    void SetOwner(HWND hWnd, FnArchiverProc fn);

    /// DLL֐̎擾
    void* GetProc(const string& strProcName) const { return m_pDll->GetProc(strProcName); }

    //@{ CX^X̎擾
    static CArchiverDll& GetUnZip();
    static CArchiverDll& GetUnLha();
    static CArchiverDll& GetUnRar();
    static CArchiverDll& Get7Zip();
    static CArchiverDll& GetUnGca();
    //@}

private:
    const string            m_strDllName;
    const string            m_strFuncPrefix;  //L"UnZip", L"Unlha"ƂB
    auto_ptr<CDll>          m_pDll;
    auto_ptr<boost::recursive_mutex>  mutex;
};

}
