#pragma once
#include "Archiver.h"
namespace Themis {

/**
    SPIpďɂׂ̃NX
*/
class CSpiArchiver: public IArchiver {
public:
    CSpiArchiver(const std::tr1::shared_ptr<CSpi>& pSpi);
    ~CSpiArchiver();

private:
    virtual vector<string> InnerGetSupportedSuffixes() const;
    virtual bool InnerOpen(vector<SFile>& rList);
    virtual void InnerExtractFile(int nFileIndex, const CFileName& oDirName);
    virtual void InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData);
    virtual EType InnerGetType() const { return eTypeLoadable; }

    std::tr1::shared_ptr<CSpi>         m_pSpi;
    int                     m_nSpiIndex;
    vector<unsigned long>   m_vctPositions;
};

/**
    CSpiArchiverFactoryB

    ̃NX̃CX^XĂ΁A
    IɌfBNgς邱Ƃ\B
*/
class CSpiArchiverFactory: public IFactory<IArchiver> {
public:
    CSpiArchiverFactory() {}
    CSpiArchiverFactory(const CFileName& oSpiDir) { SetDir(oSpiDir); }
    CSpiArchiverFactory(const std::tr1::shared_ptr<CSpi>& p): m_pPluginList(p) {}
    ~CSpiArchiverFactory() {}
    /// CX^X̍쐬
    virtual std::tr1::shared_ptr<IArchiver> CreateInstance();
    /// SPIt@CfBNgݒ
    void SetDir(const CFileName& oSpiDir);
    /// fBNg̎擾
    const CFileName& GetDir() const { return m_pPluginList->GetDir(); }

private:
    std::tr1::shared_ptr<CSpi> m_pPluginList;
};

}
