#pragma once
namespace Themis {

class CCalculator;

/// ֐̃C^[tF[X
class ICalculatorFunc : private boost::noncopyable {
public:
    virtual ~ICalculatorFunc() {}
    virtual bool Exec(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) = 0;
};

/// ʏ̊֐pICalculatorFunc
class CCalculatorFunc : public ICalculatorFunc {
public:
    typedef bool (* TFunc)(CCalculator& o, const string& f, CVariable& r, const CVariableArray& p);
    CCalculatorFunc(TFunc fn) : m_fn(fn) {}
    bool Exec(CCalculator& o, const string& f, CVariable& r, const CVariableArray& p) { return m_fn(o, f, r, p); }
private:
    TFunc   m_fn;
};

/// o֐pICalculatorFunc
template<class TObj> class CCalculatorFuncMemFn : public ICalculatorFunc {
public:
    typedef bool (TObj::* TFunc)(CCalculator& o, const string& f, CVariable& r, const CVariableArray& p);
    CCalculatorFuncMemFn(TObj* pThis, TFunc fn) : m_pThis(pThis), m_fn(fn) {}
    bool Exec(CCalculator& o, const string& f, CVariable& r, const CVariableArray& p) { return (m_pThis->*m_fn)(o, f, r, p); }
private:
    TObj*   m_pThis;
    TFunc   m_fn;
};

}
