#pragma once
namespace Themis {

class WorkerThreadController;

/**
    t@CEtH_̕ύXĎIuWFNg
*/
class CDirObserver {
public:
    /// ύXʒm̃C^[tF[X
    class IListener {
    public:
        virtual void OnChanged(CDirObserver&) = 0;
    };

    CDirObserver();
    CDirObserver(const std::tr1::shared_ptr<IListener>& p);
    ~CDirObserver();

    /// ύXʒmIuWFNgݒ
    void SetListener(const std::tr1::shared_ptr<IListener>& p) { m_pListener = p; }

    /// ĎJn
    void Begin(const CFileName& oDirName, bool bSubFolder = true);

    /// ĎĂtH_̎擾
    const CFileName& GetDirName() const { return m_oDirName; }

    /// ύXǂ
    bool IsChanged() const { return 0 < GetChangeCount(); }
    /// ύX񐔂̎擾
    int GetChangeCount() const { return m_nChange; }
    /// ύX񐔂̃Zbg
    void ResetChangeCount() { m_nChange = 0; }

    /// ĎI
    void End();

private:
    void OnThread();

private:
    std::tr1::shared_ptr<IListener> m_pListener;
    CFileName m_oDirName;
    HANDLE m_hFolder;
    volatile int m_nChange;

    volatile bool threadValid;
    std::tr1::shared_ptr<WorkerThreadController> thread;
};

}
