#include "stdafx.h"
#include "Display.h"
namespace Themis {

bool CDisplay::changed = false;

bool CDisplay::SVideo::operator == (const SVideo& v) const {
    if (oSize.cx != nDefault && oSize.cx != nDefault && oSize.cx != v.oSize.cx) return false;
    if (oSize.cy != nDefault && oSize.cy != nDefault && oSize.cy != v.oSize.cy) return false;
    if (nBpp   != nDefault && nBpp     != nDefault && nBpp   != v.nBpp  ) return false;
    if (nRRate != nDefault && v.nRRate != nDefault && nRRate != v.nRRate) return false;
    return true;
}

bool CDisplay::SVideo::operator == (const DEVMODE& dm) const {
    if (oSize.cx != nDefault && static_cast<DWORD>(oSize.cx) != dm.dmPelsWidth   ) return false;
    if (oSize.cy != nDefault && static_cast<DWORD>(oSize.cy) != dm.dmPelsHeight  ) return false;
    if (nBpp   != nDefault && static_cast<DWORD>(nBpp)   != dm.dmBitsPerPel      ) return false;
    if (nRRate != nDefault && static_cast<DWORD>(nRRate) != dm.dmDisplayFrequency) return false;
    return true;
}

bool CDisplay::IsSupportedMode(const SVideo& rv) {
    return (0 < FindModeIndex(rv));
}

void CDisplay::Set(const SVideo& rv) {
    if (rv != CDisplay::GetCurrentMode()) {
        changed = true;

        DEVMODE dm = {0};
        dm.dmSize = sizeof(DEVMODE);
        int nDef = SVideo::nDefault;
        if (rv.oSize.cx != nDef) { dm.dmPelsWidth  = rv.oSize.cx;  dm.dmFields |= DM_PELSWIDTH;  }
        if (rv.oSize.cy != nDef) { dm.dmPelsHeight = rv.oSize.cy;  dm.dmFields |= DM_PELSHEIGHT; }
        if (rv.nBpp != nDef) { dm.dmBitsPerPel = rv.nBpp;  dm.dmFields |= DM_BITSPERPEL; }
        if (rv.nRRate != nDef) {
            dm.dmDisplayFrequency = rv.nRRate;
            dm.dmFields |= DM_DISPLAYFREQUENCY;
            LONG l = ::ChangeDisplaySettings(&dm, CDS_UPDATEREGISTRY);
            if (l != DISP_CHANGE_SUCCESSFUL) {
                throw RuntimeException(L"fBXvC[h̕ύXɎs܂");
            }
        } else {
            //Aݒ肵ĂƏɂUOɂȂ肷BBB
            dm.dmDisplayFrequency = GetCurrentMode().nRRate;
            dm.dmFields |= DM_DISPLAYFREQUENCY;
            LONG l = ::ChangeDisplaySettings(&dm, CDS_UPDATEREGISTRY);
            if (l != DISP_CHANGE_SUCCESSFUL) {
                dm.dmFields &= ~DM_DISPLAYFREQUENCY;
                LONG l = ::ChangeDisplaySettings(&dm, CDS_UPDATEREGISTRY);
                if (l != DISP_CHANGE_SUCCESSFUL) {
                    throw RuntimeException(L"fBXvC[h̕ύXɎs܂");
                }
            }
        }
    }
}

void CDisplay::SetTmp(const SVideo& rv) {
    // SetRsyCDS_FULLSCREENɕς
    if (rv != CDisplay::GetCurrentMode()) {
        changed = true;

        DEVMODE dm = {0};
        dm.dmSize = sizeof(DEVMODE);
        int nDef = SVideo::nDefault;
        if (rv.oSize.cx != nDef) { dm.dmPelsWidth  = rv.oSize.cx;  dm.dmFields |= DM_PELSWIDTH;  }
        if (rv.oSize.cy != nDef) { dm.dmPelsHeight = rv.oSize.cy;  dm.dmFields |= DM_PELSHEIGHT; }
        if (rv.nBpp != nDef) { dm.dmBitsPerPel = rv.nBpp;  dm.dmFields |= DM_BITSPERPEL; }
        if (rv.nRRate != nDef) {
            dm.dmDisplayFrequency = rv.nRRate;
            dm.dmFields |= DM_DISPLAYFREQUENCY;
            LONG l = ::ChangeDisplaySettings(&dm, CDS_FULLSCREEN);
            if (l != DISP_CHANGE_SUCCESSFUL) {
                throw RuntimeException(L"fBXvC[h̕ύXɎs܂");
            }
        } else {
            //Aݒ肵ĂƏɂUOɂȂ肷BBB
            dm.dmDisplayFrequency = GetCurrentMode().nRRate;
            dm.dmFields |= DM_DISPLAYFREQUENCY;
            LONG l = ::ChangeDisplaySettings(&dm, CDS_FULLSCREEN);
            if (l != DISP_CHANGE_SUCCESSFUL) {
                dm.dmFields &= ~DM_DISPLAYFREQUENCY;
                LONG l = ::ChangeDisplaySettings(&dm, CDS_FULLSCREEN);
                if (l != DISP_CHANGE_SUCCESSFUL) {
                    throw RuntimeException(L"fBXvC[h̕ύXɎs܂");
                }
            }
        }
    }
}

bool CDisplay::Restore() {
    if (changed) {
        ::ChangeDisplaySettings(NULL, 0);
        changed = false;
        return true;
    }
    return false;
}

CDisplay::SVideo CDisplay::GetCurrentMode() {
    DEVMODE dm;
    BOOL ret = ::EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &dm);
    if (ret == FALSE) return SVideo();
    return dm;
}

bool CDisplay::GetMode(SVideo* pv, int nIndex) {
    DEVMODE dm;
    BOOL ret = ::EnumDisplaySettings(NULL, nIndex, &dm);
    if (ret == FALSE) return false;
    *pv = dm;
    return true;
}

int CDisplay::GetModeSum() {
    int n = 0;
    for (;; n++) {
        DEVMODE dm;
        if (::EnumDisplaySettings(NULL, n, &dm) == FALSE) {
            break;
        }
    }
    return n;
}

int CDisplay::FindModeIndex(const SVideo& rv) {
    for (int n=0; ; n++ ) {
        DEVMODE dm;
        if (::EnumDisplaySettings(NULL, n, &dm) == FALSE) {
            break;
        } else if (rv == dm) {
            return n;
        }
    }
    return -1;
}

}
