#include "stdafx.h"
#include "Exception.h"
#include "String/Encoding.h"
#include "Utility/Algorithm.h"
#include "Utility/StringUtility.h"
#include <stdio.h>
namespace Themis {

namespace {
    static bool useDebugWarning = false;
}

/// DebugWarningĝ
bool Exception::IsUseDebugWarning() { return useDebugWarning; }
/// DebugWarningĝ
void Exception::SetUseDebugWarning(bool b) { useDebugWarning = b; }

namespace {
#ifdef NDEBUG
#   define ___Themis_ExceptionWarning(msg) ((void)0)
#else
    static inline void ___Themis_ExceptionWarning(const string& msg) {
        if (Exception::IsUseDebugWarning()) {
            Themis_DebugWarning(msg);
        } else {
            Themis_DebugLog(msg);
        }
    }
#endif
}

namespace {
    static char s_szException[0x200];
}

Exception::Exception() {
    ___Themis_ExceptionWarning(L"sȃG[܂");
 // StrCopy(s_szException, lengthof(s_szException), L"sȃG[܂");
}

Exception::Exception(const string& str) {
    ___Themis_ExceptionWarning(L"OF" + str);
    StrCopy(s_szException, lengthof(s_szException), str);
}

const char* Exception::what() const {
    return s_szException;
}

Win32Exception::Win32Exception(const string& str) {
    DWORD nErrorCode = ::GetLastError();
    if (nErrorCode == 0) {
        Themis_DebugWarning(string() + L"sAPIOF" + str);
        StrCopy(s_szException, lengthof(s_szException), str);
    } else {
        void* pMsgBuf;
        ::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
            NULL, nErrorCode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), reinterpret_cast<LPTSTR>(&pMsgBuf), 0, NULL);
        sprintf_s(s_szException, sizeof(s_szException), "%s : %s",
            Encoding::GetDefault().GetBytes(str).c_str(), pMsgBuf);
        ::LocalFree(pMsgBuf);
        ___Themis_ExceptionWarning(string() + L"APIOF" + Encoding::GetDefault().GetString(s_szException));
    }
}

}
