#pragma once
#include "../../Fint.h"
#include "../../MakeUniqueToken.h"
#include "../../Utility/StringUtility.h"
namespace Themis {

/*
    摜֌W̎̂߂̃}NƂ֐ƂB
*/


/*
    \̎gƍœKɂȂ邩_A
    ƂĈϐ͖̂ʓ|Ȃ̂Ń}NB
*/
#ifdef NDEBUG
    /// 8bppLock
    #define Themis_PlaneLock1(_plane, _pt, _ptr, _pitch) \
        Themis::CPlane::CLock Themis_MakeUniqueToken(_lc)(_plane); \
        uint8_t* _ptr = Themis_MakeUniqueToken(_lc).GetByte(_pt); \
        const int _pitch = Themis_MakeUniqueToken(_lc).GetPitch() / sizeof(*_ptr);
    /// 16bppLock
    #define Themis_PlaneLock2(_plane, _pt, _ptr, _pitch) \
        Themis::CPlane::CLock Themis_MakeUniqueToken(_lc)(_plane); \
        uint16_t* _ptr = Themis_MakeUniqueToken(_lc).GetWord(_pt); \
        const int _pitch = Themis_MakeUniqueToken(_lc).GetPitch() / sizeof(*_ptr);
    /// 32bppLock
    #define Themis_PlaneLock4(_plane, _pt, _ptr, _pitch) \
        Themis::CPlane::CLock Themis_MakeUniqueToken(_lc)(_plane); \
        uint32_t* _ptr = Themis_MakeUniqueToken(_lc).GetDWord(_pt); \
        const int _pitch = Themis_MakeUniqueToken(_lc).GetPitch() / sizeof(*_ptr);
    /// CSize  const intBPlane֌WȂǁBB
    #define Themis_PlaneGetSize(_size, _cx, _cy) \
        const CSize Themis_MakeUniqueToken(_sz) = (_size); \
        const int _cx = Themis_MakeUniqueToken(_sz).cx; \
        const int _cy = Themis_MakeUniqueToken(_sz).cy;
#else
    #define Themis_PlaneLock1(_plane, _pt, _ptr, _pitch) \
        uint8_t* _ptr; int _pitch; { \
        Themis::CPlane::CLock oLock(_plane); \
        _ptr = oLock.GetByte(_pt); \
        _pitch = oLock.GetPitch() / sizeof(*_ptr); }
    #define Themis_PlaneLock2(_plane, _pt, _ptr, _pitch) \
        uint16_t* _ptr; int _pitch; { \
        Themis::CPlane::CLock oLock(_plane); \
        _ptr = oLock.GetWord(_pt); \
        _pitch = oLock.GetPitch() / sizeof(*_ptr); }
    #define Themis_PlaneLock4(_plane, _pt, _ptr, _pitch) \
        uint32_t* _ptr; int _pitch; { \
        Themis::CPlane::CLock oLock(_plane); \
        _ptr = oLock.GetDWord(_pt); \
        _pitch = oLock.GetPitch() / sizeof(*_ptr); }
    #define Themis_PlaneGetSize(_size, _cx, _cy) \
        const int _cx = (_size).cx; \
        const int _cy = (_size).cy;
#endif
/// TCY̎擾
#define Themis_PlaneSize(_plane, _cx, _cy) \
    Themis_PlaneGetSize((_plane).GetSize(), _cx, _cy)
/// COLORREF  const unsigned r, g, b;
#define Themis_PlaneGetRGB(_rgb, _r, _g, _b) \
    const unsigned _r = GetRValue(_rgb); \
    const unsigned _g = GetGValue(_rgb); \
    const unsigned _b = GetBValue(_rgb);
/// uint32_t  const unsigned r, g, b;
#define Themis_PlaneGetBGR32(_dw, _r, _g, _b) \
    const unsigned _r = ((_dw) >> 16) & 0xff; \
    const unsigned _g = ((_dw) >> 8) & 0xff; \
    const unsigned _b = (_dw) & 0xff;
/// uint32_t  const unsigned a, r, g, b;
#define Themis_PlaneGetBGRA32(_dw, _a, _r, _g, _b) \
    const unsigned _a = ((_dw) >> 24) & 0xff; \
    const unsigned _r = ((_dw) >> 16) & 0xff; \
    const unsigned _g = ((_dw) >> 8) & 0xff; \
    const unsigned _b = (_dw) & 0xff;
///   MMXȉCPPȉ
#define Themis_PlaneGetMMXWidth32(_w, _m, _c) \
    int _m = (_w) / 2, _c = (_w) % 2; \
    if (!CPlane::IsUseMMX() || !CCpuId::IsMMX() || _m < 4) { \
        _m = 0; \
        _c = (_w); \
    } \

namespace Detail {

    #ifdef NDEBUG
        #define Themis_PlaneCheckByte(n) ((void)0)
        #define Themis_PlaneCheckByteRGB(r, g, b) ((void)0)
    #else
        #define Themis_PlaneCheckByte(n) do { \
            if (n < 0 || 0xff < n) { \
                Themis_DebugWarning(L"RGBvZl͈͊Oۂ F" + ItoA(n)); \
            } \
        } while (false)
        #define Themis_PlaneCheckByteRGB(r, g, b) \
            Themis_PlaneCheckByte(r);  Themis_PlaneCheckByte(g);  Themis_PlaneCheckByte(b)
    #endif

    inline uint32_t RGBtoBGR32(COLORREF rgb) {
        //(static_cast<uint32_t>(GetAValue(rgb)) << 24) |
        return ((static_cast<uint32_t>(GetRValue(rgb)) << 16) |
                (static_cast<uint32_t>(GetGValue(rgb)) << 8) |
                 static_cast<uint32_t>(GetBValue(rgb)));
    }

    //@{ RGB}N݂ȁB
    inline uint32_t BGR32(unsigned r, unsigned g, unsigned b) {
        return (r << 16) | (g << 8) | b;
    }
    inline uint32_t BGRA32(unsigned a, unsigned r, unsigned g, unsigned b) {
        return (a << 24) | (r << 16) | (g << 8) | b;
    }
    //@}
    /// 0x00 ` 0xff͈̔͊OȂ͈͓̒lɂB
    inline int GetFixByte(int i) {
        return i < 0? 0: (i < 0x100? i: 0xff);
    }
    /// abcdFE㍶EAxyFEƉ̏d(Wl̏_ȉ̕BFintDecimal()Ŏ擾)
    inline uint32_t GetMidPoint(uint32_t a, uint32_t b, uint32_t c, uint32_t d, fint x, fint y) {
        //
        // r = (1 - x)(1 - y)a + x(1 - y)b + (1 - x)yc + xyd
        //   = x(y(d - b) + b - (y(c - a) + a)) + y(c - a) + a
        // āA
        // t = y(c - a) + a ƒu
        // r = x(y(d - b) + b - t) + t
        //
        Themis_DebugAssert(x < c_nFint_1);
        Themis_DebugAssert(y < c_nFint_1);
        Themis_PlaneGetBGR32(a, ar, ag, ab);
        Themis_PlaneGetBGR32(b, br, bg, bb);
        Themis_PlaneGetBGR32(c, cr, cg, cb);
        Themis_PlaneGetBGR32(d, dr, dg, db);
        const fint tr = y * (cr - ar) + ToFint(ar);
        const fint tg = y * (cg - ag) + ToFint(ag);
        const fint tb = y * (cb - ab) + ToFint(ab);
        const int rr = FintToInt(FintMul(x, (y * (dr - br) + ToFint(br) - tr)) + tr);
        const int rg = FintToInt(FintMul(x, (y * (dg - bg) + ToFint(bg) - tg)) + tg);
        const int rb = FintToInt(FintMul(x, (y * (db - bb) + ToFint(bb) - tb)) + tb);
        Themis_PlaneCheckByteRGB(rr, rg, rb); // ͈͓ǂassert
        return BGR32(rr, rg, rb);
    }
    // 2sNZ̒ԒlBxb̏d݁B
    inline uint32_t GetMidPoint(uint32_t a, uint32_t b, fint x) {
        //
        // r = (1 - x)a + xb
        //   = a - xa + xb
        //   = x(b - a) + a
        //
        Themis_DebugAssert(x < c_nFint_1);
        Themis_PlaneGetBGR32(a, ar, ag, ab);
        Themis_PlaneGetBGR32(b, br, bg, bb);
        const int rr = FintToInt(x * (br - ar) + ToFint(ar));
        const int rg = FintToInt(x * (bg - ag) + ToFint(ag));
        const int rb = FintToInt(x * (bb - ab) + ToFint(ab));
        Themis_PlaneCheckByteRGB(rr, rg, rb); // ͈͓ǂassert
        return BGR32(rr, rg, rb);
    }
    // cx * cy̕ϐFBnSpace = cx * cyB[v̊OɏoƎv̂ŁB
    inline uint32_t GetAverage(uint32_t* pBits, int nPitch, int cx, int cy, int nSpace) {
        unsigned rr = 0, rg = 0, rb = 0;
        for (int y = 0; y < cy; y++) {
            for (int x = 0; x < cx; x++) {
                Themis_PlaneGetBGR32(pBits[x], r, g, b);
                rr += r;
                rg += g;
                rb += b;
            }
        }
        rr /= nSpace;
        rg /= nSpace;
        rb /= nSpace;
        Themis_PlaneCheckByteRGB(rr, rg, rb); // ͈͓ǂassert
        return BGR32(rr, rg, rb);
    }
    /// Q̕ϐF
    inline uint32_t GetAverage(uint32_t a, uint32_t b) {
        return (((a ^ b) & 0xfefefefe) >> 1) + (a & b);
    }
    /// R̕ϐF
    inline uint32_t GetAverage(uint32_t a, uint32_t b, uint32_t c) {
        enum { t = (1 << 8) / 3 };
        const uint32_t dwRB = ((a & 0xff00ff) + (b & 0xff00ff) + (c & 0xff00ff)) * t >> 8;
        const uint32_t dwG = ((a & 0xff00) + (b & 0xff00) + (c & 0xff00)) * t >> 8;
        return (dwRB & 0xff00ff) | (dwG & 0xff00);
    }
    /// S̕ϐF
    inline uint32_t GetAverage(uint32_t a, uint32_t b, uint32_t c, uint32_t d) {
        const uint32_t dwRB = ((a & 0xff00ff) + (b & 0xff00ff) + (c & 0xff00ff) + (d & 0xff00ff)) >> 2;
        const uint32_t dwG = ((a & 0xff00) + (b & 0xff00) + (c & 0xff00) + (d & 0xff00)) >> 2;
        return (dwRB & 0xff00ff) | (dwG & 0xff00);
    }

    /// 邳Zope[u̍쐬
    template<class T> inline void CreateBrightnessTable(T tr[0x100], T tg[0x100], T tb[0x100]) {
        Themis_DebugAssert(2 <= sizeof(T));
        for (int i = 0; i < 0x100; i++) {
            tr[i] = static_cast<T>(i * 77);
            tg[i] = static_cast<T>(i * 151);
            tb[i] = static_cast<T>(i * 28);
        }
    }
    /// 16rbgȖ邳l擾
    template<class T> inline uint32_t GetBrightness16(uint32_t p, T tr[0x100], T tg[0x100], T tb[0x100]) {
        Themis_DebugAssert(2 <= sizeof(T));
        Themis_PlaneGetBGR32(p, r, g, b);
        uint32_t pp = static_cast<uint32_t>(tr[r]) + tg[g] + tb[b];
        Themis_PlaneCheckByte(pp / 0x100);
        return pp;
    }
    /// 8rbgȖ邳l擾
    template<class T> inline uint32_t GetBrightness8(uint32_t p, T tr[0x100], T tg[0x100], T tb[0x100]) {
        uint32_t pp = GetBrightness16(p, tr, tg, tb);
        pp /= 0x100;
        Themis_PlaneCheckByte(pp);
        return pp;
    }

    static void Blt24to32(uint32_t* pDst, int nDstPitch, const uint8_t* pSrc, int nSrcPitch, int nDstW, int nDstH) {
    #if 1
        Themis_DebugAssert(uint32_t(0xffffffff) >> 24 == 0xff);
        const int nDstW4 = nDstW & ~3;
        const int nDstW1 = nDstW % 4;
        if (nDstW1 == 0) {
            for (int y = 0; y < nDstH; y++) {
                const uint32_t* const pdwSrc = reinterpret_cast<const uint32_t*>(pSrc);
                for (int x3 = 0, x4 = 0; x4 < nDstW4; x3 += 3, x4 += 4) {
                #if 0
                    pDst[x4] = pdwSrc[x3] & 0xffffff;
                #else
                    pDst[x4] = pdwSrc[x3]; // lςɂȂ
                #endif
                    pDst[x4 + 1] = ((pdwSrc[x3 + 1] << 8) & 0xffff00) | (pdwSrc[x3] >> 24);
                    pDst[x4 + 2] = ((pdwSrc[x3 + 2] << 16) & 0xff0000) | (pdwSrc[x3 + 1] >> 16);
                    pDst[x4 + 3] = (pdwSrc[x3 + 2] >> 8);
                }
                pDst += nDstPitch;
                pSrc += nSrcPitch;
            }
        } else {
            const int nSrcPos = nDstW4 * 3;
            for (int y = 0; y < nDstH; y++) {
                const uint32_t* const pdwSrc = reinterpret_cast<const uint32_t*>(pSrc);
                for (int x3 = 0, x4 = 0; x4 < nDstW4; x3 += 3, x4 += 4) {
                    pDst[x4] = pdwSrc[x3] & 0xffffff;
                    pDst[x4 + 1] = ((pdwSrc[x3 + 1] << 8) & 0xffff00) | (pdwSrc[x3] >> 24);
                    pDst[x4 + 2] = ((pdwSrc[x3 + 2] << 16) & 0xff0000) | (pdwSrc[x3 + 1] >> 16);
                    pDst[x4 + 3] = (pdwSrc[x3 + 2] >> 8);
                }
                for (int x = 0, x3 = 0; x < nDstW1; x++, x3 += 3) {
                    pDst[nDstW4 + x] = (uint32_t(pSrc[nSrcPos + x3 + 2]) << 16) | (uint32_t(pSrc[nSrcPos + x3 + 1]) << 8) | pSrc[nSrcPos + x3];
                }
                pDst += nDstPitch;
                pSrc += nSrcPitch;
            }
        }
    #else
        for (int y = 0; y < nDstH; y++) {
            for (int x = 0, x3 = 0; x < nDstW; x++, x3 += 3) {
                pDst[x] = (uint32_t(pSrc[x3 + 2]) << 16) | (uint32_t(pSrc[x3 + 1]) << 8) | pSrc[x3];
            }
            pDst += nDstPitch;
            pSrc += nSrcPitch;
        }
    #endif
    }

}//namespace Detail
}
