#pragma once
#include "../Clipper.h"
#include "../Bitmap/Plane.h"
namespace Themis {

/**
    HDCɑ΂APIbsO
*/
class CDC : private boost::noncopyable {
public:
    CDC(HDC hdc);
    CDC(HDC hdc, const CSize& szPlane);
    CDC(CPlane::CGdiLock& r);
    ~CDC();
    /// HDC̎擾
    HDC GetHandle() const { return m_hdc; }
    /// v[̑傫̎擾
    CSize GetSize() const { return m_szPlane; }
    /// v[̃rbg[x
    int GetBpp() const;
    /// PFhԂ
    void Fill(COLORREF rgb);
    /// PFhԂ
    void Fill(COLORREF rgb, const CRect& rc);
    /// FhԂ
    void FillBlack();
    /// FhԂ
    void FillWhite();
    /// FhԂ
    void FillBlack(const CRect& rc);
    /// FhԂ
    void FillWhite(const CRect& rc);
    /// F]
    void ReverseFill(const CRect& rc);
    /// CDC̓]
    void Blt(const CDC& rSrc, const CClipper& rClip = CClipper());
    /// CDC̓]
    void Blt(const CDC& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
    /// CDC̓]AƂʂ
    void CaptureBlt(const CDC& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());
/*  /// CPlane̓]
    void Blt(const CPlane& rSrc, const CClipper& rClip = CClipper());
    /// CPlane̓]
    void Blt(const CPlane& rSrc, CPoint ptDst, CRect rcSrc, const CClipper& rClip = CClipper());  */
    /// ̕`
    void Line(const CPoint& pt1, const CPoint& pt2, COLORREF rgb=RGB(0, 0, 0), int nFat=1);
    /// k](ƂpɃ[hw)
    void StretchBltIndirect(const CDC& rSrc, const CRect& rcDst, const CRect& rcSrc, const CClipper& rClip = CClipper());
    /// k]
    void StretchBltNearest(const CDC& rSrc, const CRect& rcDst, const CRect& rcSrc, const CClipper& rClip = CClipper());
    /// k](2kȍ~NTnŃn[tg[)
    void StretchBlt(const CDC& rSrc, const CRect& rcDst, const CRect& rcSrc, const CClipper& rClip = CClipper());
    /// k](NTnȊOƏdǊSɃn[tg[)
 // void StretchBltHalftone(const CDC& rSrc, const CRect& rcDst, const CRect& rcSrc, const CClipper& rClip = CClipper());

    /// ƂpAStretchBltg邩ǂB
    bool IsStretchBltSupport() const;

private:
    HDC     m_hdc;
    CSize   m_szPlane;
};

/**
    RXgN^::GetDC()A
    fXgN^::ReleaseDC()CDCB
*/
class CAutoDC : public CDC {
public:
    CAutoDC(HWND hWnd): CDC(::GetDC(hWnd)), m_hWnd(hWnd) {}
    ~CAutoDC() { ::ReleaseDC(m_hWnd, GetHandle()); }
private:
    HWND    m_hWnd;
};

/**
    RXgN^::GetDC()A
    fXgN^::ReleaseDC()CDCB
*/
class CCompatiDC : public CDC {
public:
    CCompatiDC(HDC hdc = NULL): CDC(::CreateCompatibleDC(hdc)) {}
    ~CCompatiDC() { ::DeleteDC(GetHandle()); }
};

}
