#pragma once
#include "../Bitmap/Plane32.h"
namespace Themis {

/**
    APIDIBSectionbsOB
*/
class CDibImpl : public IPlaneImpl {
public:
    CDibImpl();
    virtual ~CDibImpl();

    bool IsCreated() const;
    void Create(const CSize& sz, int nBpp);
    void Delete();
    CSize GetSize() const;
    bool IsReAllocatable() const { return false; }
    bool IsGdiSupport() const { return true; }
    bool IsDirectX() const { return false; }
    pair<void*, int> Lock();
    void Unlock(const pair<void*, int>& p) {}
    HDC GdiLock();
    void GdiUnlock(HDC hdc) {}

private:
    virtual BITMAPINFO* CreateBMPINFO();
    virtual void DeleteBMPINFO(BITMAPINFO* pBmpInfo);
    virtual void FillBmiHeader(BITMAPINFOHEADER& rh, const CSize& sz, int nBpp);    //BMPINFOHɓKȒlZbg

private:
    HDC         m_hdc;
    HBITMAP     m_hbmp;
    HBITMAP     m_hbmpOld;
    BITMAPINFO* m_pBmpInfo;
    void*       m_pBits;
    int         m_nWidth;   //BITMAPINFObiWidth͊ۂ߂lȂ̂ŁAۂ߂ĂȂlB
};

class CDib : public CPlane {
public:
    /// TopDownDIBĝ
    static bool IsUseTopDownDIB();
    /// TopDownDIBĝ
    static void SetUseTopDownDIB(bool b);

    CDib(int nBpp): CPlane(std::tr1::shared_ptr<IPlaneImpl>(new CDibImpl), nBpp) {}
};

class CDib32: public CPlane32 {
public:
    CDib32(): CPlane32(std::tr1::shared_ptr<IPlaneImpl>(new CDibImpl)) {}
    CDib32(const CSize& sz): CPlane32(std::tr1::shared_ptr<IPlaneImpl>(new CDibImpl)) { SetSize(sz); }
};

}
