#include "stdafx.h"
#include "Http.h"
#include "Socket.h"
#include "Rand.h"
#include "StringScanner.h"
#include "Windows/Registry.h"
#include "String/Encoding.h"
#include "Utility/Algorithm.h"
#include "Utility/StringUtility.h"
#include <time.h>
namespace Themis {

string SHttpReceiveData::GetHeaderValue(const string& str) const {
    const string strHeaderName = str.ToLower();
    for (size_t i = 0, n = vctHeader.size(); i < n; i++) {
        if (vctHeader[i].first.ToLower() == strHeaderName) { // 啶ʖŔrׂۂB
            return vctHeader[i].second;
        }
    }
    Themis_DebugLog(L"HTTPwb_ '" + str +L"'܂ł");
    return string();
}

string SHttpReceiveData::GetDataAsStr() const {
    return Encoding::GetDefault().GetString(std::string(vctData.begin(), vctData.end()));
}

namespace {
    // WWWC̃\[XRsyďX
    void DateAdd(SYSTEMTIME *sTime, int time) {
        struct tm ltime;
        memset(&ltime, 0, sizeof(struct tm));
        ltime.tm_year = sTime->wYear - 1900;
        ltime.tm_mon = sTime->wMonth - 1;
        ltime.tm_mday = sTime->wDay;
        ltime.tm_hour = sTime->wHour + time;
        ltime.tm_min = sTime->wMinute;
        ltime.tm_sec = sTime->wSecond;
        mktime(&ltime);
        sTime->wYear = ltime.tm_year + 1900;
        sTime->wMonth = ltime.tm_mon + 1;
        sTime->wDay = ltime.tm_mday;
        sTime->wHour = ltime.tm_hour;
        sTime->wMinute = ltime.tm_min;
        sTime->wSecond = ltime.tm_sec;
    }
    inline bool IS_ALNUM(char c) {
        return (isdigit((unsigned char)c) || isalpha((unsigned char)c) || c == '+' || c == '-');
    }
    int FormatDateConv(const char *format, const char *buf, SYSTEMTIME *gTime) {
        int i;
        const char *p;
        const char *r;
        char *t;
        char tmp[0x100];
        char tz[0x100];
        char month[12][4] = {
            {"Jan"}, {"Feb"}, {"Mar"}, {"Apr"},
            {"May"}, {"Jun"}, {"Jul"}, {"Aug"},
            {"Sep"}, {"Oct"}, {"Nov"}, {"Dec"},
        };
        memset(gTime, 0, sizeof(SYSTEMTIME));
        *tz = '\0';
        p = format;
        r = buf;
        while (*p != '\0') {
            switch(*p) {
            case 'w':   //j
                for(; isalpha((unsigned char)*r); r++);
                break;
            case 'd':   //
                for(t = tmp; isdigit((unsigned char)*r); r++) {
                    *(t++) = *r;
                }
                *t = '\0';
                gTime->wDay = atoi(tmp);
                if (gTime->wDay == 0) {
                    return -1;
                }
                break;
            case 'm':   //
                for(t = tmp; isalpha((unsigned char)*r); r++) {
                    *(t++) = *r;
                }
                *t = '\0';
                for(i = 0; i < 12; i++) {
                    if (_strnicmp(*(month + i), tmp, lstrlen(tmp) + 1) == 0) {
                        break;
                    }
                }
                if (i >= 12) {
                    return -1;
                }
                gTime->wMonth = i + 1;
                break;
            case 'y':   //N
                for(t = tmp; isdigit((unsigned char)*r); r++) {
                    *(t++) = *r;
                }
                *t = '\0';
                gTime->wYear = atoi(tmp);
                if (gTime->wYear < 1900) {
                    if (gTime->wYear > 70) {
                        gTime->wYear += 1900;
                    }else{
                        gTime->wYear += 2000;
                    }
                }
                break;
            case 'h':   //
                for(t = tmp; isdigit((unsigned char)*r); r++) {
                    *(t++) = *r;
                }
                *t = '\0';
                gTime->wHour = atoi(tmp);
                break;
            case 'n':   //
                for(t = tmp; isdigit((unsigned char)*r); r++) {
                    *(t++) = *r;
                }
                *t = '\0';
                gTime->wMinute = atoi(tmp);
                break;
            case 's':   //b
                for(t = tmp; isdigit((unsigned char)*r); r++) {
                    *(t++) = *r;
                }
                *t = '\0';
                gTime->wSecond = atoi(tmp);
                break;
            case 't':   //TZ
                for(t = tz; IS_ALNUM(*r); r++) {
                    *(t++) = *r;
                }
                *t = '\0';
                break;
            case ' ':   //Space
                for(; *r == ' '; r++);
                break;
            default:
                if (*p == *r) {
                    r++;
                } else {
                    return -1;
                }
                break;
            }
            p++;
        }

        if (lstrcmpi(tz, "GMT") == 0) {
            DateAdd(gTime, 9);
        }
        return 0;
    }
    int DateConv(const char *buf, char *ret) {
        SYSTEMTIME gTime;
        if (lstrlen(buf) > 0x100 - 1) {
            return -1;
        }
        //RFC 1123
        int i = FormatDateConv("w, d m y h:n:s t", buf, &gTime);
        if (i == -1) {
            //RFC 1036
            i = FormatDateConv("w, d-m-y h:n:s t", buf, &gTime);
        }
        if (i == -1) {
            //ANSI C's asctime() format
            i = FormatDateConv("w m d h:n:s y", buf, &gTime);
            if (i == 0) {
                DateAdd(&gTime, 9);
            }
        }
        if (i == -1) {
            return -1;
        }
        char fDay[0x100];
        if (::GetDateFormat(0, 0, &gTime, "yyyy'/'MM'/'dd", fDay, 0x100 - 1) == 0) {
            return -1;
        }
        char fTime[0x100];
        if (::GetTimeFormat(0, 0, &gTime, "HH':'mm':'ss", fTime, 0x100 - 1) == 0) {
            return -1;
        }
        wsprintf(ret, "%s %s", fDay, fTime);
        return 0;
    }
}
string SHttpReceiveData::GetLastModified() const {
    string str = GetHeaderValue(L"Last-Modified");
    char sz[0x100];
    if (DateConv(Encoding::GetDefault().GetBytes(str).c_str(), sz) == 0) {
        return Encoding::GetDefault().GetString(sz);
    }
    return string();
}

string SHttpReceiveData::GetHeaderAsStr() const {
    string strHead;
    for (size_t i = 0, n = vctHeader.size(); i < n; i++) {
        strHead += vctHeader[i].first;
        strHead += L": ";
        strHead += vctHeader[i].second;
        strHead += L"\r\n";
    }
    strHead += L"\r\n";
    return strHead;
}

//------------------------------------------------------------------//

CHttp::CHttp() : m_bNoCache(false) {
}

CHttp::~CHttp() {
}

void CHttp::SetProxy(const string& strProxy) {
    m_strProxy = strProxy;
}

// IÊ擾Bo̕ӂ͖ʓ|疳ŁBgĂ͖őɖƎvBB
void CHttp::SetDefaultProxy() {
/*
    Ⴛ̂P

    [HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings]
    "ProxyEnable"=uint32_t:00000001
    "ProxyServer"="www5.ipc.akita-nct.ac.jp:8080"

    Ⴛ̂Q

    [HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings]
    "ProxyEnable"=uint32_t:00000001
    "ProxyServer"="ftp=www3.ipc.akita-nct.ac.jp:8080;gopher=www2.ipc.akita-nct.ac.jp:8080;http=www5.ipc.akita-nct.ac.jp:8080;https=www4.ipc.akita-nct.ac.jp:8080"

     MigrateProxyAAutoConfigProxyAProxyOverride͖ʓ|Ȃ̂ŖB

    "AutoConfigProxy"="wininet.dll" ĉH
*/
    try {
        CRegistry oReg;
        oReg.Open(HKEY_CURRENT_USER, L"Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", false);
        int nProxyEnable = oReg.Num(L"ProxyEnable");
        string strProxyServer = oReg.Str(L"ProxyServer");
        if (nProxyEnable == 1) {
            List<string> vct = strProxyServer.Split(Array(L';'));
            if (vct.size() == 1) {
                SetProxy(vct[0]);
                return;
            } else {
                for (size_t i = 0, n = vct.size(); i < n; i++) {
                    if (vct[i].StartsWith(L"http=")) {
                        SetProxy(vct[i].Substring(5));
                        return;
                    }
                }
                Themis_DebugWarning(L"tH[}bg");
            }
        }
        SetProxy(string());
    } catch (std::exception& e) {
        Themis_DebugLog(e.what()); e;
        SetProxy(string()); // Ƃ肠ڐڑɂĂ܂B
    }
}

void CHttp::Head(const string& strUrl) {
    string strServer, strPath;
    Connect(strUrl, strServer, strPath);
    // NGXg쐬đM
    std::string strRequest = "HEAD " +  Encoding::GetDefault().GetBytes(strPath) + " HTTP/1.0\r\n";
        // HTTP/1.1 Transfer-Encoding: chunked ̏ɂȂ̂ŁBB
    strRequest += "Host: " + Encoding::GetDefault().GetBytes(strServer) + "\r\n";
    strRequest += "Accept-Encoding: \r\n";
    if (!string::IsNullOrEmpty(m_strUserAgent)) {
        strRequest += "User-Agent: " + Encoding::GetDefault().GetBytes(m_strUserAgent) + "\r\n";
    }
    if (m_bNoCache) {
        strRequest += "Pragma: no-cache\r\n";
    }
    strRequest += "Connection: close\r\n"; //HTTP1.1pH
    strRequest += "\r\n";
    m_pSocket->Send(strRequest);
}

void CHttp::Get(const string& strUrl) {
    string strServer, strPath;
    Connect(strUrl, strServer, strPath);
    // NGXg쐬đM
    std::string strRequest = "GET " + Encoding::GetDefault().GetBytes(strPath) + " HTTP/1.0\r\n";
        // HTTP/1.1 Transfer-Encoding: chunked ̏ɂȂ̂ŁBB
    strRequest += "Host: " + Encoding::GetDefault().GetBytes(strServer) + "\r\n";
    strRequest += "Accept-Encoding: \r\n";
    if (!string::IsNullOrEmpty(m_strUserAgent)) {
        strRequest += "User-Agent: " + Encoding::GetDefault().GetBytes(m_strUserAgent) + "\r\n";
    }
    if (m_bNoCache) {
        strRequest += "Pragma: no-cache\r\n";
    }
    strRequest += "Connection: close\r\n"; //HTTP1.1pH
    strRequest += "\r\n";
    m_pSocket->Send(strRequest);
}

void CHttp::Post(const string& strUrl, const vector<pair<string, string> >& vctParams) {
    string strServer, strPath;
    Connect(strUrl, strServer, strPath);
    // POSTf[^̐`
    std::string strContent = MakePostContent(vctParams);
    // NGXg쐬đM
    std::string strRequest = "POST " + Encoding::GetDefault().GetBytes(strPath) + " HTTP/1.0\r\n"; // HTTP/1.1 Transfer-Encoding: chunked ̏ɂȂ̂ŁBB
    strRequest += "Host: " + Encoding::GetDefault().GetBytes(strServer) + "\r\n";
    strRequest += "Accept-Encoding: \r\n";
    if (!string::IsNullOrEmpty(m_strUserAgent)) {
        strRequest += "User-Agent: " + Encoding::GetDefault().GetBytes(m_strUserAgent) + "\r\n";
    }
    if (m_bNoCache) {
        strRequest += "Pragma: no-cache\r\n";
    }
    strRequest += "Content-Type: application/x-www-form-urlencoded\r\n";
    strRequest += "Content-Length: " + Encoding::GetDefault().GetBytes(ItoA(static_cast<int>(strContent.length()))) + "\r\n";
    strRequest += "Connection: close\r\n"; //HTTP1.1pH
    strRequest += "\r\n";
    strRequest += strContent;
    m_pSocket->Send(strRequest);
}

void CHttp::Post(const string& strUrl, const vector<SHttpPartData>& vctParams) {
    string strServer, strPath;
    Connect(strUrl, strServer, strPath);
    // POSTf[^̐`
    std::string strBoundary;
    std::string strContent = MakePostContent(vctParams, strBoundary);
    // NGXg쐬đM
    std::string strRequest = "POST " + Encoding::GetDefault().GetBytes(strPath) + " HTTP/1.0\r\n"; // HTTP/1.1 Transfer-Encoding: chunked ̏ɂȂ̂ŁBB
    strRequest += "Host: " + Encoding::GetDefault().GetBytes(strServer) + "\r\n";
    strRequest += "Accept-Encoding: \r\n";
    if (!string::IsNullOrEmpty(m_strUserAgent)) {
        strRequest += "User-Agent: " + Encoding::GetDefault().GetBytes(m_strUserAgent) + "\r\n";
    }
    if (m_bNoCache) {
        strRequest += "Pragma: no-cache\r\n";
    }
    strRequest += "Content-Type: multipart/form-data; boundary=" + strBoundary + "\r\n";
    strRequest += "Content-Length: " + Encoding::GetDefault().GetBytes(ItoA(static_cast<int>(strContent.length()))) + "\r\n";
    strRequest += "Connection: close\r\n"; //HTTP1.1pH
    strRequest += "\r\n";
    strRequest += strContent;
    m_pSocket->Send(strRequest);
}

void CHttp::Post(const string& strUrl, const vector<SHttpPartData>& vctParams, IProgressListener& rListener) {
    string strServer, strPath;
    Connect(strUrl, strServer, strPath);
    // POSTf[^̐`
    std::string strBoundary;
    std::string strContent = MakePostContent(vctParams, strBoundary);
    // NGXg쐬đM
    std::string strRequest = "POST " + Encoding::GetDefault().GetBytes(strPath) + " HTTP/1.0\r\n"; // HTTP/1.1 Transfer-Encoding: chunked ̏ɂȂ̂ŁBB
    strRequest += "Host: " + Encoding::GetDefault().GetBytes(strServer) + "\r\n";
    strRequest += "Accept-Encoding: \r\n";
    if (!string::IsNullOrEmpty(m_strUserAgent)) {
        strRequest += "User-Agent: " + Encoding::GetDefault().GetBytes(m_strUserAgent) + "\r\n";
    }
    if (m_bNoCache) {
        strRequest += "Pragma: no-cache\r\n";
    }
    strRequest += "Content-Type: multipart/form-data; boundary=" + strBoundary + "\r\n";
    strRequest += "Content-Length: " + Encoding::GetDefault().GetBytes(ItoA(static_cast<int>(strContent.length()))) + "\r\n";
    strRequest += "Connection: close\r\n"; //HTTP1.1pH
    strRequest += "\r\n";
    strRequest += strContent;
 /* // i\̂ߓKɕđMBc񓯊\PbgƂgׂȂ̂񂯂ǁBB
    const size_t nPartSize = 4096;
 /*/const size_t nPartSize = 512;   // eXgpɏ؂Ă݂
 //*/
    size_t nSent = 0;
    while (nSent < strRequest.size()) {
        size_t n = Min(strRequest.size() - nSent, nPartSize);
        m_pSocket->Send(strRequest.c_str() + nSent, n);
        nSent += n;
        // iR[obNB
        // MTCŶŁAƂ肠ɔ{ɂĂB
        // MTCYMTCYƑMJnɐîŒӁB
        rListener.OnProgress(unsigned(nSent), unsigned(nPartSize * 2));
    }
}

namespace {
    inline std::string UrlEncode(const string& str, const bool abNoEsc[0x100]) {
        std::string mb = Encoding::GetDefault().GetBytes(str);
        std::string result;
        for (size_t i = 0, n = mb.length(); i < n; ) {
            if (CChar::Is2Byte(mb[i])) {
                result += '%';
                result += "0123456789ABCDEF"[(uint8_t(mb[i]) >> 4) & 0xf];
                result += "0123456789ABCDEF"[mb[i++] & 0xf];
                if (n <= i) { // oCiȏꍇƂł̂͂蓾̂ŁBB
                    break;
                }
                result += '%';
                result += "0123456789ABCDEF"[(uint8_t(mb[i]) >> 4) & 0xf];
                result += "0123456789ABCDEF"[mb[i++] & 0xf];
            } else if (abNoEsc[uint8_t(mb[i])]) {
                result += mb[i++];
            } else {
                result += '%';
                result += "0123456789ABCDEF"[(uint8_t(mb[i]) >> 4) & 0xf];
                result += "0123456789ABCDEF"[mb[i++] & 0xf];
            }
        }
     // Themis_DebugLog(L"UrlEncode: " + str + L" => " + strRet);
        return result;
    }
    std::string UrlEncode(const string& str) {
        static bool s_abNoEsc[0x100] = {false};
        static bool s_bInit = false;
        if (!s_bInit) {
            // GXP[vȂėǂȕ̃e[u쐬
            // http://www.mars.dti.ne.jp/~torao/rfc/rfc2068-ja.txt ӂQlɁAKɎ
            for (int i = L'a'; i <= L'z'; i++) { s_abNoEsc[i] = true; }
            for (int i = L'A'; i <= L'Z'; i++) { s_abNoEsc[i] = true; }
            for (int i = L'0'; i <= L'9'; i++) { s_abNoEsc[i] = true; }
            s_abNoEsc[L'-'] = true;
            s_abNoEsc[L'_'] = true;
            s_abNoEsc[L'.'] = true;
            // 
            s_bInit = true;
        }
        return UrlEncode(str, s_abNoEsc);
    }
}
/// Oƃf[^̑g𐮌`
std::string CHttp::MakePostContent(const vector<pair<string, string> >& vctParams) {
    if (vctParams.empty()) {
        return std::string();
    } else {
        // f[^̃GR[hƍ\z
        std::string content = UrlEncode(vctParams[0].first);
        content += '=';
        content += UrlEncode(vctParams[0].second);
        for (size_t i = 0 + 1, n = vctParams.size(); i < n; i++) {
            content += '&';
            content += UrlEncode(vctParams[i].first);
            content += '=';
            content += UrlEncode(vctParams[i].second);
        }
        return content;
    }
}

namespace {
    inline bool ContainsBoundary(const vector<SHttpPartData>& vctParams, const std::string& strBoundary) {
        string boundary = Encoding::GetDefault().GetString(strBoundary);
        for (size_t i = 0, n = vctParams.size(); i < n; i++) {
            // f[^ꍇ邾낵xȂBB
            if (vctParams[i].strData.Contains(boundary)) {
                return true;
            }
        }
        return false;
    }
}
/// f[^̐`
std::string CHttp::MakePostContent(const vector<SHttpPartData>& vctParams, std::string& strBoundary) {
    CRand& rRand = CRand::GetInstance();
    do {
        strBoundary += Encoding::GetDefault().GetBytes(string::Format(L"%x", rRand(0x4000, rRand.GetMax())));
    } while (ContainsBoundary(vctParams, strBoundary));
    // f[^̍\z
    std::string content;
    for (size_t i = 0, n = vctParams.size(); i < n; i++) {
        content += "--" + strBoundary + "\r\n";
        content += "Content-Disposition: form-data); name=\"" + Encoding::GetDefault().GetBytes(vctParams[i].strName) + "\"";
        if (!string::IsNullOrEmpty(vctParams[i].strFileName)) {
            content += "); filename=\"" + Encoding::GetDefault().GetBytes(vctParams[i].strFileName) + "\"";
        }
        content += "\r\n";
        if (!string::IsNullOrEmpty(vctParams[i].strContentType)) {
            content += "Content-Type: " + Encoding::GetDefault().GetBytes(vctParams[i].strContentType) + "\r\n";
        }
        content += "\r\n";
        content += Encoding::GetDefault().GetBytes(vctParams[i].strData);
        content += "\r\n"; // Rv͂BB
    }
    // f[^I[
    content += "--" + strBoundary + "--\r\n";
    return content;
}

/// f[^̎M
void CHttp::ReceiveData(SHttpReceiveData& rData) {
    Themis_DebugAssert(m_pSocket.get() != NULL);
    uint8_t by[4096];
    while (true) {
        int nLen = m_pSocket->Receive(by, sizeof(by) - 1);
        if (nLen <= 0) {
            break;
        } else {
            rData.vctData.insert(rData.vctData.end(), by, by + nLen);
        }
    }
    m_pSocket.reset();
    // wb_̍\͂ۂ̂ƂB
    size_t nHeader = GetHeaderSize(rData.vctData);
    if (nHeader != 0) {
        rData.vctHeader = SplitHeader(Encoding::GetDefault().GetString(
            std::string(rData.vctData.begin(), rData.vctData.begin() + nHeader)));
        rData.vctData.erase(rData.vctData.begin(), rData.vctData.begin() + nHeader);
    }
}

/// f[^̎M
void CHttp::ReceiveData(SHttpReceiveData& rData, IProgressListener& rListener) {
    Themis_DebugAssert(m_pSocket.get() != NULL);
    uint8_t by[4096];
    unsigned nMaxFileSize = static_cast<unsigned>(-1);
    unsigned nHeaderSize = static_cast<unsigned>(-1);
    unsigned nReceivedSize = 0;
    while (true) {
        int nLen = m_pSocket->Receive(by, sizeof(by) - 1);
        if (nLen <= 0) {
            break;
        } else {
            nReceivedSize += nLen;
            rData.vctData.insert(rData.vctData.end(), by, by + nLen);
        }
        if (nHeaderSize == static_cast<unsigned>(-1)) {
            // wb_̍\͂ۂ̂ƂB
            size_t nHeader = GetHeaderSize(rData.vctData);
            if (nHeader != 0) {
                rData.vctHeader = SplitHeader(Encoding::GetDefault().GetString(
                    std::string(rData.vctData.begin(), rData.vctData.begin() + nHeader)));
                rData.vctData.erase(rData.vctData.begin(), rData.vctData.begin() + nHeader);
                string strCL = rData.GetHeaderValue(L"Content-Length");
                if (!string::IsNullOrEmpty(strCL)) {
                    nMaxFileSize = AtoI(strCL);
                }
                nHeaderSize = static_cast<unsigned>(nHeader);
            }
        }
        if (nMaxFileSize != static_cast<unsigned>(-1)) {
            // wb_Ƀt@CTCYΐi󋵕\Ƃ
            rListener.OnProgress(nReceivedSize, nMaxFileSize + nHeaderSize);
            // ŏIĂ܂CBB
         // if (nMaxFileSize <= nReceivedSize - nHeaderSize) {
         //     break;
         // }
        }
    }
    // IR[
    if (nMaxFileSize == static_cast<unsigned>(-1)) {
        rListener.OnProgress(1, 1);
    } else {
        rListener.OnProgress(nMaxFileSize + nHeaderSize, nMaxFileSize + nHeaderSize);
    }
    // nB
    m_pSocket.reset();
}

/// URL̕ƃT[o[ւ̐ڑ
void CHttp::Connect(const string& strUrl, string& strServer, string& strPath) {
    Themis_DebugAssert(m_pSocket.get() == NULL);
    /// URL̕
    {
        string str = strUrl.Trim();
        // XL[̃`FbN
        if (str.StartsWith(L"http://")) {
            str = str.Substring(7);
        } else {
            //throw RuntimeException(strUrl + L" httpURLł͂܂");
        }
        // T[o[F|[gԍ̎擾
        List<string> sp = str.Split(Array(L'/'), 2);
        strServer = sp[0];
        // t@CpX̎擾
        strPath = L"/" + sp[1];
    }
    // I֐ڑ
    m_pSocket.reset(new CTcpSocket());
    if (string::IsNullOrEmpty(m_strProxy)) {
        m_pSocket->Connect(strServer, 80);
    } else {
        strPath = strUrl; //EscapeChar(strUrl);
        m_pSocket->Connect(m_strProxy, 80);
    }
}

size_t CHttp::GetHeaderSize(vector<uint8_t>& vctData) {
    const char* p = reinterpret_cast<const char*>(&vctData[0]);
    size_t n = 0;
    while (strncmp(p + n, "\r\n\r\n", 4) != 0) {
        n++;
        if (vctData.size() < n + 4) {
            return 0; // wb_I[Ȃꍇ
        }
    }
    return n + 4;
}

vector<pair<string, string> > CHttp::SplitHeader(const string& strHeader) {
    vector<pair<string, string> > vctRet;
    vector<string> vct = strHeader.Split(Array<string>(L"\r\n", L"\n", L"\r"));
    for (size_t i = 0, n = vct.size(); i < n; i++) {
        int pos = vct[i].IndexOf(L": ");
        if (0 <= pos) {
            vctRet.push_back(make_pair(vct[i].Substring(0, pos), vct[i].Substring(pos + 2)));
        }
    }
    return vctRet;
}

}
