#pragma once
#include "ProgressListener.h"
namespace Themis {

class CTcpSocket;

/**
    }`p[gPOSTp̃f[^B
*/
struct SHttpPartData {
    string  strName;            // tH[
    string  strFileName;        // t@C(ȂtH[A͂΃t@CƂĈۂ)
    string  strContentType;     // t@Cꍇ̂݁H text/plain, zip, text/xml, application/xml ȂǂȂǁAKɁB
    string  strData;
 // vector<uint8_t> vctData;       // f[^B
    //@{ Bf[^ƂĕgꍇƎv̂ŁAϊpӂĂB
    SHttpPartData() {}
 // SHttpPartData(const string& n, const vector<uint8_t>& d) : strName(n), vctData(d) {}
    SHttpPartData(const string& n, const string& d) : strName(n), strData(d) {}
 // SHttpPartData(const string& n, const string& f, const string& c, const vector<uint8_t>& d) : strName(n), strFileName(f), strContentType(c), vctData(d) {}
    SHttpPartData(const string& n, const string& f, const string& c, const string& d) : strName(n), strFileName(f), strContentType(c), strData(d) {}
    //@}
};

/**
    Mf[^B
*/
struct SHttpReceiveData {
    vector<pair<string, string> > vctHeader;   // Oƒl̃yA
    vector<uint8_t> vctData;
    /// wb_l擾
    string GetHeaderValue(const string& str) const;
    /// GetHeaderValue(L"Last-Modified") yyyy/mm/dd hh:mm ɐ`ĕԂB
    string GetLastModified() const;
    /// wb_܂Ƃ߂Ď擾
    string GetHeaderAsStr() const;
    /// f[^std::stringƂĎ擾
    string GetDataAsStr() const;
    /// wb_ƃf[^܂Ƃ߂Ď擾
    string GetRawData() const { return GetHeaderAsStr() + GetDataAsStr(); }
};

/**
    HTTPȃNCAgB
*/
class CHttp : private boost::noncopyable {
public:
    CHttp();
    ~CHttp();

    //@{ 
    const string& GetProxy() const { return m_strProxy; }
    void SetProxy(const string& strProxy);
    void SetDefaultProxy();
    //@}

    //@{ [U[G[WFg
    const string& GetUserAgent() const { return m_strUserAgent; }
    void SetUserAgent(const string& str) { m_strUserAgent = str; }
    //@}

    //@{ LbVgȂǂ
    bool IsNoCache() const { return m_bNoCache; }
    void SetNoCache(bool b) { m_bNoCache = b; }
    //@}

    //@{ NGXg̑M
    /// HEADNGXg̑M
    void Head(const string& strUrl);
    /// GETNGXg̑M
    void Get(const string& strUrl);
    /// POSTNGXg̑M
    void Post(const string& strUrl, const vector<pair<string, string> >& vctParams);
    /// }`p[gPOSTNGXg̑M
    void Post(const string& strUrl, const vector<SHttpPartData>& vctParams);
    /// }`p[gPOSTNGXg̑MAi\tB
    void Post(const string& strUrl, const vector<SHttpPartData>& vctParams, IProgressListener& rListener);
    //@}

    //@{ f[^̎MiGet()/Post()pj
    void ReceiveData(SHttpReceiveData& rData);
    void ReceiveData(SHttpReceiveData& rData, IProgressListener& rListener);
    //@}

private:
    std::string MakePostContent(const vector<pair<string, string> >& vctParams);
    std::string MakePostContent(const vector<SHttpPartData>& vctParams, std::string& strBoundary);
    void Connect(const string& strUrl, string& strServer, string& strPath);
    string EscapeChar(const string& strUrl);

    static size_t GetHeaderSize(vector<uint8_t>& vctData);
    static vector<pair<string, string> > SplitHeader(const string& strHeader);

private:
    auto_ptr<CTcpSocket>        m_pSocket;
    string                      m_strProxy;
    unsigned short              m_nProxyPort;
    string                      m_strUserAgent;
    bool                        m_bNoCache;
};

}
