#include "stdafx.h"
#include "Modifiable.h"
namespace Themis {

CModifiableList::CModifiableList() {
}

CModifiableList::~CModifiableList() {
}

/// Sč폜
void CModifiableList::Clear() {
    m_vctList.clear();
}

/// IModifiable̒ǉ
void CModifiableList::Add(const std::tr1::shared_ptr<IModifiable>& pMod) {
    m_vctList.push_back(pMod);
}

/// ύXĂtrue
bool CModifiableList::IsModified() const {
    for (size_t i = 0, n = m_vctList.size(); i < n; i++) {
        if (m_vctList[i]->IsModified()) { // łtrueȂtrue
            return true;
        }
    }
    return false;
}

/// Ă΂ꂽ_ł̏ԂAύXĂȂɂ
void CModifiableList::ClearModified() {
    for (size_t i = 0, n = m_vctList.size(); i < n; i++) {
        m_vctList[i]->ClearModified();
    }
}

//------------------------------------------------------------------//

CModifiableEdit::CModifiableEdit(HWND hCtrl) : m_oCtrl(hCtrl) {
    ClearModified();
}
bool CModifiableEdit::IsModified() const {
    return m_str != m_oCtrl.GetText();
}
void CModifiableEdit::ClearModified() {
    m_str = m_oCtrl.GetText();
}

CModifiableCombo::CModifiableCombo(HWND hCtrl) : m_oCtrl(hCtrl) {
    ClearModified();
}
bool CModifiableCombo::IsModified() const {
    return m_str != m_oCtrl.Get();
}
void CModifiableCombo::ClearModified() {
    m_str = m_oCtrl.Get();
}

CModifiableCheck::CModifiableCheck(HWND hCtrl) : m_oCtrl(hCtrl) {
    ClearModified();
}
bool CModifiableCheck::IsModified() const {
    return m_b != m_oCtrl.GetCheck();
}
void CModifiableCheck::ClearModified() {
    m_b = m_oCtrl.GetCheck();
}

CModifiableListCheck::CModifiableListCheck(HWND hCtrl) : m_oCtrl(hCtrl) {
    ClearModified();
}
bool CModifiableListCheck::IsModified() const {
    if (m_vct.size() != m_oCtrl.GetCount()) {
        Themis_DebugWarning(L"`FbN{bNXtXgr[̍ڐςĂۂ");
        return true;
    }
    for (size_t i = 0, n = m_vct.size(); i < n; i++) {
        if (m_vct[i] != m_oCtrl.GetCheck(int(i))) {
            return true;
        }
    }
    return false;
}
void CModifiableListCheck::ClearModified() {
    m_vct.resize(m_oCtrl.GetCount());
    for (size_t i = 0, n = m_vct.size(); i < n; i++) {
        m_vct[i] = m_oCtrl.GetCheck(int(i));
    }
}


CModifiableCtrlList::CModifiableCtrlList(CWindow& rWindow) : m_rWindow(rWindow) {
}

CModifiableCtrlList::~CModifiableCtrlList() {
}

void CModifiableCtrlList::Add(int nCtrlId) {
    CWnd oCtrl(m_rWindow.GetCtrl(nCtrlId));
    switch (oCtrl.GetCtrlType()) {
    case eWndCtrlTypeEditbox:   Add(new CModifiableEdit(oCtrl.GetHandle())); break;
    case eWndCtrlTypeCombobox:  Add(new CModifiableCombo(oCtrl.GetHandle())); break;
    case eWndCtrlTypeButton:    Add(new CModifiableCheck(oCtrl.GetHandle())); break;
    case eWndCtrlTypeListview:  Add(new CModifiableListCheck(oCtrl.GetHandle())); break;
    default: Themis_DebugWarning(L"`ȃRg[^Cv"); break;
    }
}

}
