#include "stdafx.h"
#include "Rect.h"
#include "Utility/Algorithm.h"
namespace Themis {

CSize CSize::GetUnion(const CSize& sz) const {
    return CSize(Max(this->cx, sz.cx), Max(this->cy, sz.cy));
}
CSize CSize::GetIntersect(const CSize& sz) const {
    return CSize(Min(this->cx, sz.cx), Min(this->cy, sz.cy));
}

/// ̋`ݍލŏ̋`
void CRect::SetUnion(const RECT& s) {
    // ::UnionRect(this, this, &s);
    if (s.right <= s.left || s.bottom <= s.top) {
    } else if (!IsValid()) {
        *this = s;
    } else {
        this->left = Min(this->left, s.left);
        this->top = Min(this->top, s.top);
        this->right = Max(this->right, s.right);
        this->bottom = Max(this->bottom, s.bottom);
    }
}

/// Q̋`̌Ă`
void CRect::SetIntersect(const RECT& s) {
    // ::IntersectRect(this, this, &s);
    this->left = Max(this->left, s.left);
    this->top = Max(this->top, s.top);
    this->right = Min(this->right, s.right);
    this->bottom = Min(this->bottom, s.bottom);
}

vector<CRect> CRect::GetBlanks(const CRect& rcRect) const {
    vector<CRect> vct;
    //㑤
    if (this->top < rcRect.top) {
        CRect rc;
        rc.top = this->top;
        rc.left = this->left;
        rc.right = this->right;
        rc.bottom = rcRect.top;
        vct.push_back(rc);
    }
    //
    if (this->left < rcRect.left) {
        CRect rc;
        rc.top = rcRect.top;
        rc.left = this->left;
        rc.right = rcRect.left;
        rc.bottom = rcRect.bottom;
        vct.push_back(rc);
    }
    //E
    if (rcRect.right < this->right) {
        CRect rc;
        rc.top = rcRect.top;
        rc.left = rcRect.right;
        rc.right = this->right;
        rc.bottom = rcRect.bottom;
        vct.push_back(rc);
    }
    //
    if (rcRect.bottom < this->bottom) {
        CRect rc;
        rc.top = rcRect.bottom;
        rc.left = this->left;
        rc.right = this->right;
        rc.bottom = this->bottom;
        vct.push_back(rc);
    }
    return vct;
}

}
