#include "stdafx.h"
#include <richedit.h>
#include <olectl.h>
#include <richole.h>
#include "Windows/Dll.h"
#include "MsgHook.h"
#include "FileBase.h"
#include "RichEdit.h"
namespace Themis {

/**
    CRichEditŉ摜Ƃ悤ɂ邽߂́B

    cڍׂ͓䕗B_no
*/
class REOLECallback : public ::IRichEditOleCallback {
public:
    REOLECallback() {
        m_nRefCount = 0;
    }
    ~REOLECallback() {
    }
    // IUnknown
    STDMETHOD_(ULONG, AddRef)() {
        m_nRefCount++;
        return m_nRefCount;
    }
    STDMETHOD_(ULONG, Release)() {
        if (--m_nRefCount == 0) {
            delete this;
        }
        return m_nRefCount;
    }
    STDMETHOD(QueryInterface)(REFIID iid, void** ppvObject) {
        if (iid == IID_IUnknown || iid == IID_IRichEditOleCallback) {
            *ppvObject = this;
            AddRef();
            return S_OK;
        }
        return E_NOINTERFACE;
    }
    // Methods of the IRichEditOleCallback interface
    STDMETHOD(ContextSensitiveHelp)(BOOL fEnterMode) {
        return E_NOTIMPL;
    }
    STDMETHOD(DeleteObject)(LPOLEOBJECT lpoleobj) {
        return E_NOTIMPL;
    }
    STDMETHOD(GetClipboardData)(CHARRANGE FAR *lpchrg, DWORD reco, LPDATAOBJECT FAR *lplpdataobj) {
        return E_NOTIMPL;
    }
    STDMETHOD(GetContextMenu)(WORD seltype, LPOLEOBJECT lpoleobj, CHARRANGE FAR *lpchrg, HMENU FAR *lphmenu) {
        return E_NOTIMPL;
    }
    STDMETHOD(GetDragDropEffect)(BOOL fDrag, DWORD grfKeyState, LPDWORD pdwEffect) {
        return E_NOTIMPL;
    }
    STDMETHOD(GetInPlaceContext)(LPOLEINPLACEFRAME FAR *lplpFrame, LPOLEINPLACEUIWINDOW FAR *lplpDoc, LPOLEINPLACEFRAMEINFO lpFrameInfo) {
        return E_NOTIMPL;
    }
    STDMETHOD(GetNewStorage)(LPSTORAGE FAR *lplpstg) {
        // Initialize a Storage Object from a DocFile in memory
        LPLOCKBYTES lpLockBytes = NULL;
        SCODE sc  = ::CreateILockBytesOnHGlobal(NULL, TRUE, &lpLockBytes);
        if (sc != S_OK) {
            return sc;
        }
        sc = ::StgCreateDocfileOnILockBytes(lpLockBytes, STGM_SHARE_EXCLUSIVE|STGM_CREATE|STGM_READWRITE, 0, lplpstg);
        if (sc != S_OK) {
            lpLockBytes->Release();
        }
        return sc;
    }
    STDMETHOD(QueryAcceptData)(LPDATAOBJECT lpdataobj, CLIPFORMAT FAR *lpcfFormat, DWORD reco, BOOL fReally, HGLOBAL hMetaPict) {
        return E_NOTIMPL;
    }
    STDMETHOD(QueryInsertObject)(LPCLSID lpclsid, LPSTORAGE lpstg, LONG cp) {
        return S_OK;
    }
    STDMETHOD(ShowContainerUI)(BOOL fShow) {
        return E_NOTIMPL;
    }
private:
    int      m_nRefCount;
};

//------------------------------------------------------------------//

#define USE_VERSION_1 1

namespace {
    class CRichEditInitializer {
        CDll m_oDll;
    public:
    #if USE_VERSION_1
        CRichEditInitializer() : m_oDll(L"RICHED32.DLL") {
    #else
        CRichEditInitializer() : m_oDll(L"RICHED20.DLL") {
    #endif
            /*
                RICHED32.DLL  ver 1.0
                RICHED20.DLL  ver 2.0ȍ~
                1.0 ȂNXL"RICHEDIT"A
                2.0 ȍ~ȂL"RichEdit20A" / L"RichEdit20W"
                c炵B
            */
        }
        ~CRichEditInitializer() {
        }
        inline void* GetProc(const string& strName) {
            return m_oDll.GetProc(strName);
        }
    };
    CRichEditInitializer& GetInitializer() {
        static CRichEditInitializer s_oInitializer;
        return s_oInitializer;
    }
}

CRichEdit::CRichEdit(HWND hWndParent) : CCtrl(InnerCreate(hWndParent)), m_pOleCallback(NULL) {
    // OLER[obNݒBȂƉ摜ǂ߂ȂۂB
    m_pOleCallback = new REOLECallback;
    SendMsg(EM_SETOLECALLBACK, 0, (LPARAM)m_pOleCallback);
    // Ô߃[hݒ
 // if (SendMsg(EM_SETTEXTMODE, TM_RICHTEXT | TM_MULTILEVELUNDO | TM_MULTICODEPAGE, 0) != 0) {
 //     Themis_DebugWarning(L"b`GfBbgœ䂦[B");
 // }
    // tHg̐ݒ
 // SetInitFont();
}

HWND CRichEdit::InnerCreate(HWND hWndParent) {
    // gɂĂĂłKvH
    GetInitializer();
    // 쐬[
    const DWORD dwStyle = WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_WANTRETURN | WS_VSCROLL | WS_HSCROLL;
#if USE_VERSION_1
    HWND hEdit = ::CreateWindowEx(WS_EX_CLIENTEDGE, "RICHEDIT", NULL, dwStyle,
#else
    HWND hEdit = ::CreateWindowEx(WS_EX_CLIENTEDGE, "RichEdit20A", NULL, dwStyle,
#endif
        0, 0, 0, 0, hWndParent, (HMENU)1, ::GetModuleHandle(NULL), NULL);
    if (hEdit == NULL) {
        throw Win32Exception(L"b`GfBbg̍쐬Ɏs");
    }
    return hEdit;
}

CRichEdit::~CRichEdit() {
    ::DestroyWindow(GetHandle());
}

/// WM_SIZEŌĂԂƃNCAg̈ɂ҂荇킹悤ɃTCY
void CRichEdit::ResizeToClient(CMsgHookPrms& rPrms) {
    ::MoveWindow(GetHandle(), 0, 0, rPrms.GetLPrmLoWord(), rPrms.GetLPrmHiWord(), TRUE);
}

namespace {
    static DWORD CALLBACK EditReadProc(DWORD_PTR dwCookie, LPBYTE pbBuf, LONG cb, LONG *pcb) {
        DWORD dw = 0;
        if (::ReadFile(reinterpret_cast<HANDLE>(dwCookie), pbBuf, cb, &dw, NULL) != FALSE) {
            if (pcb != NULL) {
                *pcb = dw;
            }
            return 0;
        }
        return -1;
    }
}
/// RTFt@C̓ǂݍ
void CRichEdit::LoadRTF(const CFileName& oFileName) {
    CApiFile oFile(oFileName, CApiFile::eModeOpen);
    EDITSTREAM eds = {0};
    eds.dwCookie = reinterpret_cast<DWORD_PTR>(oFile.GetApiHandle());
    eds.pfnCallback = &EditReadProc;
    SendMsg(EM_STREAMIN, SF_RTF, (LPARAM)&eds);
    if (eds.dwError != 0) {
        throw RuntimeException(L"RTFt@C '" + oFileName.Get() +L"' ̓ǂݍ݂Ɏs܂");
    }
}

/*
bool CRichEdit::FontSelect() {
    CHARFORMAT cfm;
    CHOOSEFONT cf;
    LOGFONT lf;
    HDC hDC;

    ZERO_MEMORY(&cf, sizeof(CHOOSEFONT));
    ZERO_MEMORY(&lf, sizeof(LOGFONT));
    cfm.cbSize = sizeof(CHARFORMAT);

    //܂ł̐ݒ擾
    SendMsg(EM_GETCHARFORMAT, TRUE, (LPARAM)&cfm);

    hDC = ::GetDC(GetHandle());
    lf.lfHeight = ::MulDiv(cfm.yHeight, GetDeviceCaps(hDC,LOGPIXELSY), -1440);
    ::ReleaseDC(GetHandle(), hDC);

    cfm.dwMask = m_dwMask;
    if(cfm.dwEffects & CFE_BOLD)        lf.lfWeight = FW_BOLD;
    else                                lf.lfWeight = FW_NORMAL;
    if(cfm.dwEffects & CFE_ITALIC)      lf.lfItalic = true;
    if(cfm.dwEffects & CFE_UNDERLINE)   lf.lfUnderline = true;
    if(cfm.dwEffects & CFE_STRIKEOUT)   lf.lfStrikeOut = true;
    lf.lfCharSet = cfm.bCharSet;
    lf.lfQuality = DEFAULT_QUALITY;
    lf.lfPitchAndFamily = cfm.bPitchAndFamily;
    strcpy(lf.lfFaceName, cfm.szFaceName);

    cf.rgbColors = cfm.crTextColor;
    cf.lStructSize = sizeof(CHOOSEFONT);
    cf.hwndOwner = GetHandle();
    cf.lpLogFont = &lf;
    cf.Flags = CF_SCREENFONTS | CF_EFFECTS | CF_INITTOLOGFONTSTRUCT;
    //tHgI_CAOoĐVݒ擾
    if (::ChooseFont(&cf)) {
        cfm.cbSize = sizeof(CHARFORMAT);
        cfm.dwMask = m_dwMask;
        cfm.yHeight = 2 * cf.iPointSize;
        cfm.dwEffects = 0;
        if (lf.lfWeight >= FW_BOLD)     cfm.dwEffects |= CFE_BOLD;
        if (lf.lfItalic)                cfm.dwEffects |= CFE_ITALIC;
        if (lf.lfUnderline)             cfm.dwEffects |= CFE_UNDERLINE;
        if (lf.lfStrikeOut)             cfm.dwEffects |= CFE_STRIKEOUT;
        cfm.crTextColor = (COLORREF)cf.rgbColors;
        cfm.bPitchAndFamily = lf.lfPitchAndFamily;
        cfm.bCharSet = lf.lfCharSet;
        ::strcpy(cfm.szFaceName, lf.lfFaceName);
        SendMsg(EM_SETCHARFORMAT, SCF_SELECTION, (LPARAM)&cfm);
    }
    ::SetFocus(GetHandle());
    return true;
}

bool CRichEdit::SetInitFont() {
    CHARFORMAT cfm;
    ZERO_MEMORY(&cfm, sizeof(CHARFORMAT));
    cfm.cbSize  = sizeof(CHARFORMAT);
    cfm.dwMask  = CFM_BOLD | CFM_CHARSET | CFM_COLOR;
    cfm.dwMask |= CFM_FACE | CFM_ITALIC | CFM_SIZE;
    cfm.dwMask |= CFM_STRIKEOUT | CFM_UNDERLINE;
    cfm.bCharSet = SHIFTJIS_CHARSET;
    strcpy(cfm.szFaceName, L"lr SVbN");
    if (m_dwMask == 0) {
        m_dwMask = cfm.m_dwMask; //O[oɕۑ
    }
    SendMsg(EM_SETCHARFORMAT, SCF_SELECTION | SCF_WORD,(LPARAM)&cfm);
    return true;
}
*/

}
