#pragma once
namespace Themis {

/**
    obt@B

    Q̃Xbhłꂼꂪǂݏ̂̓T|[g邯ǁA
    ̃Xbhɓǂݍ݂ƂA
    ̃Xbhɏ݂̓T|[gȂB
*/
class CRingBuffer : private boost::noncopyable {
public:
    CRingBuffer(size_t n)
        : m_pBuffer(NULL), m_nBufferSize((n + 15) & ~15), m_bWaiting(false) {
        m_pBuffer = new uint8_t[m_nBufferSize];
        m_nReadPos = m_nWritePos = 0;
    }
    ~CRingBuffer() {
        Themis_DebugAssert(!m_bWaiting);
        delete[] m_pBuffer;
    }

    /// ݏ߂TCY擾
    size_t GetWritableSize() const {
        boost::recursive_mutex::scoped_lock lock(mutex);
    // ReadPos == WritePosȎ́uǂݍݑݑ҂vȏԂȂ̂œǂݍ
        if (m_nWritePos < m_nReadPos) {
            // ǂĂ܂Ɓuǂݍݑݑ҂vƋʏoȂ̂ŁA
            // ǂݍ݈ʒüO܂
            return m_nReadPos - m_nWritePos - 1;
        } else {
            // obt@I[܂Ł{ǂݍ݃|C^̈O܂
            return m_nBufferSize + m_nReadPos - m_nWritePos - 1;
        }
    }
    /// ݓǂݍ߂TCY擾
    size_t GetReadableSize() const {
        boost::recursive_mutex::scoped_lock lock(mutex);
    // ReadPos == WritePosȎ͏ݑ҂œǂݍݕs\
        if (m_nReadPos <= m_nWritePos) {
            // ݈ʒu܂
            return m_nWritePos - m_nReadPos;
        } else {
            // obt@I[܂Ł{݃|C^܂
            return m_nBufferSize + m_nWritePos - m_nReadPos;
        }
    }

    /// GetWritableSize()nȏԂ悤ɂȂ܂ő҂
    void WaitForWritable(size_t n = 0) {
        if (n <= 0) n = 1;
        boost::recursive_mutex::scoped_lock lock(mutex);
        if (n <= GetWritableSize()) return;
        if (m_bWaiting) {
            throw RuntimeException(L"G[Fǂݍݑ҂Əݑ҂Փ˂܂");
        }
        while (GetWritableSize() < n) {
            m_bWaiting = true;
            condition.wait(lock);
        }
        m_bWaiting = false;
    }
    /// GetReadableSize()nȏԂ悤ɂȂ܂ő҂
    void WaitForReadable(size_t n = 0) {
        // ̂GetReadableSizeɏB
        if (n <= 0) n = 1;
        boost::recursive_mutex::scoped_lock lock(mutex);
        if (n <= GetReadableSize()) return;
        if (m_bWaiting) {
            throw RuntimeException(L"G[Fǂݍݑ҂Əݑ҂Փ˂܂");
        }
        while (GetReadableSize() < n) {
            m_bWaiting = true;
            condition.wait(lock);
        }
        m_bWaiting = false;
    }

    /// ݃bN
    class CWriteLock : private boost::noncopyable {
    public:
        inline CWriteLock(CRingBuffer& r, size_t n): m_r(r) { m_r.WriteLock(n, m_p1, m_n1, m_p2, m_n2); }
        inline ~CWriteLock() { m_r.WriteUnlock(m_p1, m_n1, m_p2, m_n2); }
        inline void* GetPtr1() const { return m_p1; }
        inline void* GetPtr2() const { return m_p2; }
        inline size_t GetSize1() const { return m_n1; }
        inline size_t GetSize2() const { return m_n2; }
    private:
        CRingBuffer& m_r;
        void* m_p1;
        void* m_p2;
        size_t m_n1;
        size_t m_n2;
    };
    /// ǂݍ݃bN
    class CReadLock : private boost::noncopyable {
    public:
        inline CReadLock(CRingBuffer& r, size_t n): m_r(r) { m_r.ReadLock(n, m_p1, m_n1, m_p2, m_n2); }
        inline ~CReadLock() { m_r.ReadUnlock(m_p1, m_n1, m_p2, m_n2); }
        inline const void* GetPtr1() const { return m_p1; }
        inline const void* GetPtr2() const { return m_p2; }
        inline size_t GetSize1() const { return m_n1; }
        inline size_t GetSize2() const { return m_n2; }
    private:
        CRingBuffer& m_r;
        const void* m_p1;
        const void* m_p2;
        size_t m_n1;
        size_t m_n2;
    };

    /// obt@̃TCY擾
    size_t GetBufferSize() const { return m_nBufferSize; }

    void WriteLock(size_t n, void*& p1, size_t& n1, void*& p2, size_t& n2) {
        boost::recursive_mutex::scoped_lock lock(mutex);
        Themis_DebugAssert(0 < n);
        Themis_DebugAssert(m_nWritePos <= m_nBufferSize);
        // ߂TCYĂ邩`FbN
        if (GetWritableSize() < n) {
            throw RuntimeException(L"G[Fobt@ւ݂̏Ɏs܂");
        }
        // |C^ʒuETCY̌vZ
        p1 = m_pBuffer + m_nWritePos;
        size_t nBufSize = m_nBufferSize - m_nWritePos;
        if (n <= nBufSize) {
            n1 = n;
            n2 = 0;
            p2 = NULL;
        } else {
            n1 = nBufSize;
            n2 = n - nBufSize;
            p2 = m_pBuffer;
        }
    }
    void WriteUnlock(void* p1, size_t n1, void* p2, size_t n2) {
        boost::recursive_mutex::scoped_lock lock(mutex);
        // ǂݍ݈ʒui߂
        m_nWritePos += n1 + n2;
        // ݈ʒuI𒴂Ă
        if (m_nBufferSize <= m_nWritePos) {
            m_nWritePos -= m_nBufferSize;
        }
        // ҂ĂȂCxgN
        if (m_bWaiting) {
            condition.notify_all();
        }
    }
    void ReadLock(size_t n, const void*& p1, size_t& n1, const void*& p2, size_t& n2) {
        boost::recursive_mutex::scoped_lock lock(mutex);
        Themis_DebugAssert(0 < n);
        Themis_DebugAssert(m_nReadPos <= m_nBufferSize);
        // ǂݍ߂TCYĂ邩`FbN
        if (GetReadableSize() < n) {
            throw RuntimeException(L"G[Fobt@̓ǂݍ݂Ɏs܂");
        }
        // |C^ʒuETCY̌vZ
        p1 = m_pBuffer + m_nReadPos;
        size_t nBufSize = m_nBufferSize - m_nReadPos;
        if (n <= nBufSize) {
            n1 = n;
            n2 = 0;
            p2 = NULL;
        } else {
            n1 = nBufSize;
            n2 = n - nBufSize;
            p2 = m_pBuffer;
        }
    }
    void ReadUnlock(const void* p1, size_t n1, const void* p2, size_t n2) {
        boost::recursive_mutex::scoped_lock lock(mutex);
        Themis_DebugAssert(m_nReadPos <= m_nBufferSize);
        // ǂݍ݈ʒui߂
        m_nReadPos += n1 + n2;
        // ǂݍ݈ʒuI܂ŗĂŏɖ߂
        if (m_nBufferSize <= m_nReadPos) {
            m_nReadPos -= m_nBufferSize;
        }
        // ҂ĂȂCxgN
        if (m_bWaiting) {
            condition.notify_all();
        }
    }

private:
    uint8_t* m_pBuffer;
    size_t m_nBufferSize;

    mutable boost::recursive_mutex mutex;
    boost::condition condition;

    size_t m_nReadPos;     // ǂݍݍς݈ʒu(0 ` m_nBufferSize - 1)
    size_t m_nWritePos;    // ݍς݈ʒu(0 ` m_nBufferSize - 1)
    bool m_bWaiting;
};

}
