#include "stdafx.h"
#include "Encode.h"
#include "File.h"
#include "Serialize.h"
#include "String/Encoding.h"
namespace Themis {

void ISerializer::operator<<(const string& str) {
    std::string mb = Encoding::GetDefault().GetBytes(str);
    *this << static_cast<unsigned int>(mb.length());
    InnerSerialize(mb.c_str(), mb.length());
}

void IRestorer::operator<<(string& str) {
    size_t n;
    *this << n;
    boost::scoped_array<char> sz(new char[n + 1]);
    InnerRestore(sz.get(), n);
    sz[n] = '\0';
    str = Encoding::GetDefault().GetString(sz.get());
}

//------------------------------------------------------------------//

void ISerializer::OnSerialize(ISerializer& r) const {
    Themis_DebugAssert(this == &r);
    //R͉ԈႦĂCc
    r << m_oBuffer;
}

void ISerializer::OnRestore(IRestorer& r) {
    r << m_oBuffer;
}

//------------------------------------------------------------------//

void IRestorer::OnSerialize(ISerializer& r) const {
    r << m_oBuffer;
    r << m_nPos;
}
void IRestorer::OnRestore(IRestorer& r) {
    Themis_DebugAssert(this == &r);
    //R͉ԈႦĂCc
    r << m_oBuffer;
    r << m_nPos;
}

//////////////////////////////////////////////////////////////////////

void CSerializer::Save(const CFileName& oFileName) const {
    CFile(oFileName).Save(GetBuffer());
}

CRestorer::CRestorer(const CFileName& oFileName) {
    CFile(oFileName).Load(GetBuffer());
}

//////////////////////////////////////////////////////////////////////

void CCompressSerializer::Save(const CFileName& oFileName) const {
    vector<uint8_t> vctTmp;
    CLZSSCompress().Encode(CWriteStream(&vctTmp), CReadStream(GetBuffer()));
    CFile(oFileName).Save(vctTmp);
}

CCompressRestorer::CCompressRestorer(const CFileName& oFileName) {
    vector<uint8_t> vctTmp = CFile(oFileName).LoadBin();
    CLZSSCompress().Decode(CWriteStream(&GetBuffer()), CReadStream(vctTmp));
}

}
