#pragma once
#include <vector>
#include <boost/call_traits.hpp>
namespace Themis {

/**
 * zBstd::vector͎XsւȂ̂.NETListɓKɁB
 */
template<class T> class List : public std::vector<T> {
public:
    typedef typename boost::call_traits<T>::param_type ParamType;
    typedef typename boost::call_traits<T>::reference Reference;
    typedef typename boost::call_traits<T>::const_reference ConstReference;

    //@{ B
    List() {}
    List(int capacity) { SetCapacity(capacity); }
    //@}

    //@{ e
    int GetCapacity() const { return static_cast<int>(capacity()); }
    void SetCapacity(int n) { reserve(n); }
    //@}

    //@{ 
    int GetCount() const { return static_cast<int>(size()); }
    void SetCount(int n) { resize(n); }
    //@}

    //@{ ǉ
    void Add(ParamType item) { push_back(item); }
    void AddRange(const std::vector<ParamType>& collection) {
        insert(end(), collection.begin(), collection.end());
    }
    //@}

  //ReadOnlyCollection<T> AsReadOnly() const;
  //int BinarySearch(T item) const;
  //int BinarySearch(T item, IComparer<T> comparer) const;
  //int BinarySearch(int index, int count, T item, IComparer<T> comparer) const;

    /// S폜
    void Clear() { erase(); }

    /// ܂܂Ă邩ǂ
    bool Contains(ParamType t) const { return std::find(begin(), end(), t) != end(); }

  //List<TOutput> ConvertAll<TOutput>(Converter<T, TOutput> converter) const;
  //void CopyTo(T[] array) const;
  //void CopyTo(T[] array, int arrayIndex) const;
  //void CopyTo(int index, T[] array, int arrayIndex, int count) const;
  //bool Exists(Predicate<T> match) const;
  //T Find(Predicate<T> match) const;
  //List<T> FindAll(Predicate<T> match) const;
  //int FindIndex(Predicate<T> match) const;
  //int FindIndex(int startIndex, Predicate<T> match) const;
  //int FindIndex(int startIndex, int count, Predicate<T> match) const;
  //T FindLast(Predicate<T> match) const;
  //int FindLastIndex(Predicate<T> match) const;
  //int FindLastIndex(int startIndex, Predicate<T> match) const;
  //int FindLastIndex(int startIndex, int count, Predicate<T> match) const;
  //void ForEach(Action<T> action) const;
  //List<T>.Enumerator GetEnumerator();
  //List<T> GetRange(int index, int count) const;
    //@{ 
    int IndexOf(ParamType item) const { return IndexOf(item, 0); }
    int IndexOf(ParamType item, int index) const { return IndexOf(item, index, GetCount() - index); }
    int IndexOf(ParamType item, int index, int count) const {
        const_iterator it = std::find(begin(), end(), item);
        return it == end() ? -1 : it - begin();
    }
    //@}
    /// }
    void Insert(int index, ParamType item) {
        insert(begin() + index, item);
    }
  //void InsertRange(int index, IEnumerable<T> collection);
  //int LastIndexOf(ParamType item) const;
  //int LastIndexOf(ParamType item, int index) const;
  //int LastIndexOf(ParamType item, int index, int count) const;
    //@{ 폜
  //bool Remove(ParamType item);
  //int RemoveAll(Predicate<T> match);
    void RemoveAt(int index) { RemoveRange(index, 1); }
    void RemoveRange(int index, int count) {
        erase(begin() + index, begin() + index + count);
    }
    //@}

    //@{ tɂ
    void Reverse() { Reverse(0, GetCount()); }
    void Reverse(int index, int count) {
        std::reverse(begin() + index, begin() + index + count);
    }
    //@}

    //@{ \[g
    void Sort() { std::sort(begin(), end()); }
    template<class LessThan> void Sort(LessThan lessThan) { std::sort(begin(), end(), lessThan); }
    //@}

  //void Sort(int index, int count, IComparer<T> comparer);
  //T[] ToArray() const;
  //void TrimExcess() const;
  //bool TrueForAll(Predicate<T> match) const;

    // boost/algorithm/string.hpp Ƃp̃RXgN^B
    template<class IT> List(IT begin, IT end) : std::vector<T>(begin, end) {}
};

//@{ yɃCX^X쐬邽߂̃wpBC# int[] a = {0, 1}; ݂ȁB
//#define P typename List<T>::ParamType
#define P const T&
template<class T> inline List<T> Array(P a) { List<T> l; l.Add(a); return l; }
template<class T> inline List<T> Array(P a, P b) { List<T> l; l.Add(a); l.Add(b); return l; }
template<class T> inline List<T> Array(P a, P b, P c) { List<T> l; l.Add(a); l.Add(b); l.Add(c); return l; }
template<class T> inline List<T> Array(P a, P b, P c, P d) { List<T> l; l.Add(a); l.Add(b); l.Add(c); l.Add(d); return l; }
template<class T> inline List<T> Array(P a, P b, P c, P d, P e) { List<T> l; l.Add(a); l.Add(b); l.Add(c); l.Add(d); l.Add(e); return l; }
template<class T> inline List<T> Array(P a, P b, P c, P d, P e, P f) { List<T> l; l.Add(a); l.Add(b); l.Add(c); l.Add(d); l.Add(e); l.Add(f); return l; }
#undef P
//@}

}
