#include "stdafx.h"
#include "Parallel.h"
#include "Thread.h"
#include "ThreadPool.h"
#include "../Windows/Environment.h" // Environment::GetProcessorCount()
#include "../tpl/smart_ptr_vector.h"
namespace Themis {

Parallel& Parallel::GetInstance() {
    static Parallel instance;
    return instance;
}

Parallel::Parallel() {
  #ifdef NDEBUG
    parallelCount = Environment::GetProcessorCount();
  #else
    parallelCount = 7;
  #endif
}

/// 񐔂̎擾
int Parallel::GetParallelCount() const {
    return parallelCount;
}

/// 񐔂̐ݒ
void Parallel::SetParallelCount(int n) {
    parallelCount = n;
}

namespace {
  #ifndef NDEBUG
    static void InnerFor(const std::tr1::function<void(int,int)>& fn, int start, int end, int threadNumber) {
        Thread::SetName(string::Format(L"ParallelThread(%d)", threadNumber));
        try {
            fn(start, end);
        } catch (...) {
            Themis_DebugWarning(L"ParallelsɗOI");
        }
    }
  #endif
}
void Parallel::For(const std::tr1::function<void(int,int)>& fn, int start, int end) {
    const int threadCount = GetParallelCount() - 1; // 쐬Xbh
    
    if (threadCount <= 0) {
        fn(start, end);
    } else {
        const int count = (end - start) / (threadCount + 1);
        // XbhJnI
        smart_ptr_vector<WorkerThreadController> threads(threadCount);
        for (int i = 0; i < threadCount; i++) {
            threads[i] = ThreadPool::CreateWorkerThread();
            threads[i]->SetWork(
              #ifdef NDEBUG
                std::tr1::bind(fn, start, start + count)
              #else
                std::tr1::bind(&InnerFor, fn, start, start + count, i)
              #endif
                );
            start += count;
        }
        // Ō̂P݂͌̃XbhŁB
        fn(start, end);
    }
}

}
