#include "stdafx.h"
#include "ThreadPool.h"
#include "Thread.h"
#include "../Windows/Environment.h" // Environment::GetProcessorCount()
namespace Themis {

/// SingletonȃCX^X̎擾
ThreadPool& ThreadPool::GetInstance() {
    static ThreadPool instance;
    return instance;
}

ThreadPool::ThreadPool() {
    int processors = Environment::GetProcessorCount();
    maxThreads = processors * 2;
    workerThreads.SetMaxPoolCount(processors * 4);
}

ThreadPool::~ThreadPool() {
 // Join();
}

/// gĂȂXbhj
void ThreadPool::InnerGarbage() {
    boost::mutex::scoped_lock lock(mutex);
    threads.erase(std::remove_if(threads.begin(), threads.end(),
        std::tr1::mem_fn(&WorkerThreadController::IsIdling)), threads.end());
    workerThreads.Garbage();
}

/// Start()̏ɎgXbh̍ő吔ݒ(ftHg̓vZbT~Q)
void ThreadPool::InnerSetMaxThreads(int n) {
    maxThreads = n;
}

/// ێXbh̍ő吔ݒ(ftHg̓vZbT~S)
void ThreadPool::InnerSetMaxPoolCount(int n) {
    workerThreads.SetMaxPoolCount(n);
}

/// WorkerThreadController̃CX^X쐬
std::tr1::shared_ptr<WorkerThreadController> ThreadPool::InnerCreateWorkerThread() {
    std::tr1::shared_ptr<WorkerThread> p = workerThreads.CreateInstance();
    Themis_DebugAssert(p->IsIdling());
    // ɈĎ́AdIOɉĂ܂ĎB
    // FXʓ|Ȃ̂ł̓_ĎɂB
    return std::tr1::shared_ptr<WorkerThreadController>(new WorkerThreadController(p));
}

/// XbhJnB
void ThreadPool::InnerStart(const std::tr1::function<void()>& fn) {
    boost::mutex::scoped_lock lock(mutex);
    // dIĂXbhɂ炻ŊJn
    for (size_t i = 0, n = threads.size(); i < n; i++) {
        if (threads[i]->IsIdling()) {
            threads[i]->SetWork(std::tr1::bind(&ThreadPool::OnThread, this, fn, threads[i]));
            return;
        }
    }
    // Βǉ or L[CO
    if (threads.size() < (size_t)maxThreads) {
        std::tr1::shared_ptr<WorkerThreadController> worker = InnerCreateWorkerThread();
        worker->SetWork(std::tr1::bind(&ThreadPool::OnThread, this, fn, worker));
        threads.push_back(worker);
    } else {
        workQueue.push(fn);
    }
}

/// Xbhȏ
void ThreadPool::OnThread(const std::tr1::function<void()>& w, const std::tr1::weak_ptr<WorkerThreadController>& worker) {
    Thread::SetName(L"PooledThread");
    // ds
    w();
    // n
    boost::mutex::scoped_lock lock(mutex);
    std::tr1::shared_ptr<WorkerThreadController> workerPtr = worker.lock();
    if (!workerPtr || !workerPtr->IsThreadValid()) return;
    // L[COĂ̂΂s
    if (workQueue.empty()) {
        // L[COĂ̖
        threads.erase(std::remove(threads.begin(), threads.end(), workerPtr), threads.end());
     // Themis_DebugAssert(workerPtr.use_count() == 1);
    } else {
        // L[COĂ̂
        workerPtr->SetWork(std::tr1::bind(&ThreadPool::OnThread, this, workQueue.front(), workerPtr));
        workQueue.pop();
    }
}

}
