#pragma once
#include "../tpl/smart_ptr_vector.h"
#include "../ObjectPool.h"
#include "WorkerThreadController.h"
namespace Themis {

/**
 * Xbhv[B
 * fXgN^̌Ă΂^C~OɒӁB蓮ThreadPool::Garbage()̂IXXB
 */
class ThreadPool : private boost::noncopyable {
    ObjectPool<WorkerThread> workerThreads;
    smart_ptr_vector<WorkerThreadController> threads;
    boost::mutex mutex; // for workQueue
    std::queue<std::tr1::function<void()> > workQueue;
    int maxThreads;
public:
    ~ThreadPool();

    /// gĂȂXbhj
    static void Garbage() {
        GetInstance().InnerGarbage();
    }

    /// Start()̏ɎgXbh̍ő吔ݒ(ftHg̓vZbT~Q)
    static void SetMaxThreads(int n) {
        GetInstance().InnerSetMaxThreads(n);
    }

    /// ێXbh̍ő吔ݒ(ftHg̓vZbT~S)
    static void SetMaxPoolCount(int n) {
        GetInstance().InnerSetMaxPoolCount(n);
    }

    /// WorkerThreadController̃CX^X쐬Bboost::thread̑ɂgƗǂB
    static std::tr1::shared_ptr<WorkerThreadController> CreateWorkerThread() {
        return GetInstance().InnerCreateWorkerThread();
    }

    /// XbhJnB
    static void Start(const std::tr1::function<void()>& fn) {
        GetInstance().InnerStart(fn);
    }

private:
    ThreadPool();

    void InnerGarbage();
    void InnerSetMaxThreads(int n);
    void InnerSetMaxPoolCount(int n);
    std::tr1::shared_ptr<WorkerThreadController> InnerCreateWorkerThread();
    void InnerStart(const std::tr1::function<void()>& fn);

    void OnThread(const std::tr1::function<void()>& w, const std::tr1::weak_ptr<WorkerThreadController>& worker);

    /// SingletonȃCX^X̎擾
    static ThreadPool& GetInstance();
};

}
