#pragma once
#include "../tpl/map_vector.h"
namespace Themis {

namespace Detail {
    template<class T> struct CThreadSpecificObjectDefaultCreater {
        T* operator()() const { return new T(); }
    };
}

#ifdef _MT

/**
 * XbhɌŗLȕϐׂ̃IuWFNgB
 * 
 * boost::thread_specific_ptr<T>gDLLKv炵̂ŁBB
 */
template<class T> class CThreadSpecificObject : private boost::noncopyable {
public:
    CThreadSpecificObject() {
    }
    ~CThreadSpecificObject() {
        for (size_t i = 0, n = m_oObjectList.size(); i < n; i++) {
            boost::checked_delete(m_oObjectList[i].second);
        }
    }
    template<class U> T& Get(U fnCreater) {
        boost::mutex::scoped_lock lock(mutex);
        DWORD dw = ::GetCurrentThreadId();
        map_vector<DWORD, T*>::iterator it = m_oObjectList.insert(::GetCurrentThreadId(), NULL).second;
        if ((*it).second == NULL) {
            (*it).second = fnCreater();
        }
        return *(*it).second;
    }
    T& Get() { return Get(Detail::CThreadSpecificObjectDefaultCreater<T>()); }
private:
    boost::mutex mutex;
    map_vector<DWORD, T*> m_oObjectList;
};

#else

template<class T> class CThreadSpecificObject : private boost::noncopyable {
public:
    CThreadSpecificObject() : m_p(NULL) {
    }
    ~CThreadSpecificObject() {
        boost::checked_delete(m_p);
    }
    template<class U> T& Get(U fnCreater) {
        if (m_p == NULL) {
            m_p = fnCreater();
        }
        return *m_p;
    }
    T& Get() { return Get(Detail::CThreadSpecificObjectDefaultCreater<T>()); }
private:
    T*  m_p;
};

#endif

}
