#pragma once
#include <boost/thread/xtime.hpp>
namespace Themis {

/**
 * boost::xtimep[eBeBB
 */
class XTime : private boost::noncopyable {
public:
    /// ݎ擾
    static inline boost::xtime Now() {
        boost::xtime xt;
        boost::xtime_get(&xt, boost::TIME_UTC);
        return xt;
    }

    /// ݎnbxtimeԂB
    static inline boost::xtime AfterSeconds(int n) {
        boost::xtime xt = Now();
        boost::xtime_get(&xt, boost::TIME_UTC);
        AddSeconds(xt, n);
        return xt;
    }

    /// ݎn~bxtimeԂB
    static inline boost::xtime AfterMilliSeconds(int n) {
     // Themis_DebugAssert(n < 1000);
        boost::xtime xt = Now();
        AddMilliSeconds(xt, n);
        return xt;
    }

    /// xtnbZ
    static inline void AddSeconds(boost::xtime& xt, int n) {
        xt.sec += n;
    }

    /// xtn~bZ
    static inline void AddMilliSeconds(boost::xtime& xt, int n) {
        xt.sec += n / 1000;
        xt.nsec += (n % 1000) * 1000 * 1000;
        while (1000 * 1000 * 1000 <= xt.nsec) {
            xt.nsec -= 1000 * 1000 * 1000;
            xt.sec++;
        }
        while (xt.nsec < 0) {
            xt.nsec += 1000 * 1000 * 1000;
            xt.sec--;
        }
    }
};

}
