#include "stdafx.h"
#include "COM.h"
#include <shlobj.h>
#pragma comment(lib, "ole32.lib")
#include "../Thread/ThreadSpecificObject.h"
namespace Themis {

CCOM* CCOM::CreateInstance() {
    return new CCOM;
}

CCOM::CCOM(): m_nRefCount(0) {
}

CCOM::~CCOM() {
    Themis_DebugAssert(m_nRefCount == 0);
}

CCOM& CCOM::GetInstance() {
    static CThreadSpecificObject<CCOM> s_oObj;
    return s_oObj.Get(&CCOM::CreateInstance);
}

void CCOM::Initialize() {
    if (m_nRefCount++ <= 0) {
        if (::CoInitialize(NULL) != S_OK) {
            throw RuntimeException(L"COM̏Ɏs܂");
        }
    }
}

void CCOM::Terminate() {
    if (--m_nRefCount <= 0) {
        ::CoUninitialize();
    }
}

}
