#include "stdafx.h"
#include "Mailslot.h"
#include "System.h"
#include "../String/Encoding.h"
namespace Themis {

CMailslotReceiver::CMailslotReceiver() : m_hSlot(INVALID_HANDLE_VALUE) {
    Init(L"\\\\.\\mailslot\\" + CSystem::GetModuleFileName());
}

CMailslotReceiver::CMailslotReceiver(const string& strName) : m_hSlot(INVALID_HANDLE_VALUE) {
    Init(strName);
}

CMailslotReceiver::~CMailslotReceiver() {
    if (m_hSlot != INVALID_HANDLE_VALUE) {
        ::CloseHandle(m_hSlot);
    }
}

void CMailslotReceiver::Init(const string& strName) {
    m_hSlot = ::CreateMailslot(Encoding::GetDefault().GetBytes(strName).c_str(), 0, 0, NULL);
    if (m_hSlot == INVALID_HANDLE_VALUE) {
        throw Win32Exception(L"vZXԒʐM̎MɎs");
    }
}

/// ̃f[^̃TCY擾
size_t CMailslotReceiver::GetSize() {
    DWORD dwNext = 0;
    if (::GetMailslotInfo(m_hSlot, NULL, &dwNext, NULL, NULL) == FALSE) {
        Themis_DebugApiError();
        return 0;
    }
    if (dwNext == MAILSLOT_NO_MESSAGE) {
        return 0;
    }
    return dwNext;
}

/// f[^擾
void CMailslotReceiver::Receive(void* p, size_t n) {
    DWORD dwSize = 0;
    if (::ReadFile(m_hSlot, p, DWORD(n), &dwSize, NULL) == FALSE) {
        throw Win32Exception(L"f[^̎MɎs");
    }
}

//------------------------------------------------------------------//

CMailslotSender::CMailslotSender() : m_hSlot(INVALID_HANDLE_VALUE) {
    Init(L"\\\\.\\mailslot\\" + CSystem::GetModuleFileName());
}

CMailslotSender::CMailslotSender(const string& strName) : m_hSlot(INVALID_HANDLE_VALUE) {
    Init(strName);
}

CMailslotSender::~CMailslotSender() {
    if (m_hSlot != INVALID_HANDLE_VALUE) {
        ::CloseHandle(m_hSlot);
    }
}

void CMailslotSender::Init(const string& strName) {
    m_hSlot = ::CreateFile(Encoding::GetDefault().GetBytes(strName).c_str(), GENERIC_WRITE,
        FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING,
        FILE_ATTRIBUTE_NORMAL, NULL);
    if (m_hSlot == INVALID_HANDLE_VALUE) {
        throw Win32Exception(L"vZXԒʐM̑MɎs");
    }
}

/// f[^𑗐M
void CMailslotSender::Send(const void* p, size_t n) {
    DWORD dwSize = 0;
    if (0 < n && ::WriteFile(m_hSlot, p, DWORD(n), &dwSize, NULL) == FALSE) {
        throw Win32Exception(L"f[^̑MɎs");
    }
}

}
