#pragma once
#include "../MsgHook.h"
namespace Themis {

/**
 * ScrollBar::ResumeLayoutɂxĂ΂ꂽ瓊OB
 * ċA΍ɂȂ悤ȂȂȂ悤ȁB
 */
class ScrollBarAlreadyResumedLayoutException : public InvalidOprationException {
public:
    ScrollBarAlreadyResumedLayoutException()
        : InvalidOprationException(L"XN[o[̏ɃG[܂") {}
};

/**
 * XN[o[̊NX
 */
class ScrollBar : private boost::noncopyable {
    HWND handle;
    const UINT orientation;
    int largeChange, smallChange;
    int maximum, minimum;
    int value;
    std::tr1::function<void(ScrollBar&, int, int)> scroll;
    bool suspendLayout;
    bool enabled, enabledNew, visible, visibleNew, disableNoScroll;
public:
    ScrollBar(HWND handle, UINT orientation) : handle(handle), orientation(orientation),
        largeChange(10), smallChange(1), maximum(100), minimum(0), value(0),
        suspendLayout(false), enabled(true), enabledNew(true),
        visible(false), visibleNew(true), disableNoScroll(false) {}
    virtual ~ScrollBar() {}

    /// ԂȂ̂ǂ
    bool IsVisible() const { return visible; }
    /// ԂȂ̂ǂ
    void SetVisible(bool b) { visibleNew = b; SetVisible(); }
    /// LȂ̂ǂ
    bool IsEnabled() const { return enabled; }
    /// LȂ̂ǂ
    void SetEnabled(bool b) { enabledNew = b; SetEnabled(); }

    /// XN[{bNX傫ړƂ Value ̕ω
    int GetLargeChange() const { return largeChange; }
    /// XN[{bNX傫ړƂ Value ̕ω
    void SetLargeChange(int n) { largeChange = n; SetScrollInfo(); }
    /// XN[{bNXړƂ Value ̕ω
    int GetSmallChange() const { return smallChange; }
    /// XN[{bNXړƂ Value ̕ω
    void SetSmallChange(int n) { smallChange = n; SetScrollInfo(); }
    /// XN[\Ȕ͈͂̏l
    int GetMaximum() const { return maximum; }
    /// XN[\Ȕ͈͂̏l
    void SetMaximum(int n) { maximum = n; SetScrollInfo(); }
    /// XN[\Ȕ͈͂̉l
    int GetMinimum() const { return minimum; }
    /// XN[\Ȕ͈͂̉l
    void SetMinimum(int n) { minimum = n; SetScrollInfo(); }
    /// XN[o[Rg[̃XN[{bNX݈̌ʒu\l
    int GetValue() const { return value; }
    /// XN[o[Rg[̃XN[{bNX݈̌ʒu\l
    void SetValue(int n) { value = n; SetScrollInfo(); }

    /// XN[镔ꍇɖɂȂtrueABȂfalse
    bool IsDisableNoScroll() const { return disableNoScroll; }
    /// XN[镔ꍇɖɂȂtrueABȂfalse
    void SetDisableNoScroll(bool b) { disableNoScroll = b; SetScrollInfo(); }

    /// XN[{bNXړƔCxgB(ScrollBar& sender, int oldValue, int newValue)
    void SetScrollEvent(const std::tr1::function<void(ScrollBar&, int, int)>& fn) { scroll = fn; }
    /// XN[{bNXړƔCxgB(ScrollBar& sender, int oldValue, int newValue)
    const std::tr1::function<void(ScrollBar&, int, int)>& GetScrollEvent() const { return scroll; }

    /// ĕ`sȂB
    void SuspendLayout() {
        if (suspendLayout) {
            throw ScrollBarAlreadyResumedLayoutException();
        }
        suspendLayout = true;
    }
    /// ĕ`s悤ɂB
    void ResumeLayout() {
        Themis_DebugAssert(suspendLayout);
        InnerSetVisible();
        InnerSetEnabled();
        InnerSetScrollInfo();
        suspendLayout = false;
    }

protected:
    /// WM_{H,V}SCROLLṕAXN[̈ʒuZoB
    int GetScrolledValue(WPARAM w) {
        switch (LOWORD(w)) {
        case SB_LINEDOWN:       return GetValue() + GetSmallChange();
        case SB_LINEUP:         return GetValue() - GetSmallChange();
        case SB_PAGEDOWN:       return GetValue() + GetLargeChange();
        case SB_PAGEUP:         return GetValue() - GetLargeChange();
        case SB_THUMBTRACK:     return static_cast<short>(HIWORD(w));
        case SB_THUMBPOSITION:  return static_cast<short>(HIWORD(w));
        default:                return GetValue();
        }
    }
    /// M_{H,V}SCROLLȏB
    bool InnerOnScroll(WPARAM w) {
        int oldValue = GetValue();
        int newValue = GetScrolledValue(w);
        if (oldValue != newValue) {
            SetValue(newValue);
            std::tr1::function<void(ScrollBar&, int, int)> fn = GetScrollEvent();
            if (!fn.empty()) {
                fn(*this, oldValue, newValue);
            }
            return true;
        }
        return false;
    }

private:
    void SetVisible() {
        if (suspendLayout) return;
        InnerSetVisible();
    }

    void SetEnabled() {
        if (suspendLayout) return;
        InnerSetEnabled();
    }

    void SetScrollInfo() {
        if (suspendLayout) return;
        InnerSetScrollInfo();
    }

    void InnerSetVisible() {
        if (visible != visibleNew) {
            visible = visibleNew;
            ::ShowScrollBar(handle, orientation, visible ? TRUE : FALSE);
        }
    }

    void InnerSetEnabled() {
        if (enabled != enabledNew) {
            enabled = enabledNew;
            ::EnableScrollBar(handle, orientation, enabled ? ESB_ENABLE_BOTH : ESB_DISABLE_BOTH);
        }
    }

    void InnerSetScrollInfo() {
        SCROLLINFO si = {sizeof(SCROLLINFO)};
        si.fMask = SIF_RANGE | SIF_PAGE | SIF_POS;
        if (disableNoScroll) {
            si.fMask |= SIF_DISABLENOSCROLL;
        }
        si.nMin = minimum;
        si.nMax = maximum + largeChange;
        si.nPage = largeChange + 1;
        si.nPos = value;
        // Kɕ␳BAPIłĂۂcB
        /*
        if (si.nPage < 0) si.nPage = 0;
        int pageMax = si.nMax - si.nMin + 1;
        if (pageMax < static_cast<int>(si.nPage)) si.nPage = pageMax;
        if (si.nPos < si.nMin) si.nPos = si.nMin;
        int posMax = si.nMax - Max(static_cast<int>(si.nPage) - 1, 0);
        if (posMax < si.nPos) si.nPos = posMax;
        */
        // APIցB
        ::SetScrollInfo(handle, orientation, &si, TRUE);
    }
};

/**
 * XN[o[
 */
class HScrollBar : public ScrollBar {
public:
    HScrollBar(HWND handle) : ScrollBar(handle, SB_HORZ) {}

    /// WM_HSCROLL̏
    bool OnScroll(CMsgHookPrms& rPrms) {
        Themis_DebugAssertIf(rPrms.GetMsg() == WM_HSCROLL) {
            return InnerOnScroll(rPrms.GetWPrm());
        }
        return false;
    }
};

/**
 * XN[o[
 */
class VScrollBar : public ScrollBar {
public:
    VScrollBar(HWND handle) : ScrollBar(handle, SB_VERT) {}

    /// WM_VSCROLL̏
    bool OnScroll(CMsgHookPrms& rPrms) {
        Themis_DebugAssertIf(rPrms.GetMsg() == WM_VSCROLL) {
            return InnerOnScroll(rPrms.GetWPrm());
        }
        return false;
    }
};

}
