#include "stdafx.h"
#include "System.h"
#include "Dll.h"
#include "COM.h"
#include "Registry.h"
#include "NativeString.h"
#include "../TempFile.h"
#include "../File.h"
#include "../String/Encoding.h"
#include <shellapi.h>
#pragma comment(lib, "shell32.lib")
namespace Themis {

CPoint CSystem::GetCursorPos() {
    CPoint pt;
    ::GetCursorPos(&pt);
    return pt;
}

void CSystem::SetCursorPos(const CPoint& pt) {
    ::SetCursorPos(pt.x, pt.y);
}

bool CSystem::ShowCursor() {
    bool b = (::ShowCursor(FALSE) < -1);
    while (::ShowCursor(TRUE) <= 0)
        ;
    return b;
}

bool CSystem::HideCursor() {
    bool b = (0 < ::ShowCursor(TRUE));
    while (0 <= ::ShowCursor(FALSE))
        ;
    return b;
}

string CSystem::FindExec(const string& strSuffix) {
    CTempFile oFile(string(), strSuffix);
    oFile.Create(vector<uint8_t>());
    wchar_t szw[_MAX_PATH] = {0};
    char sza[_MAX_PATH] = {0};
    HINSTANCE hInst = NativeString::IsUnicode() ?
        ::FindExecutableW(oFile.GetName().Get().ToCharPtr(), NULL, szw) :
        ::FindExecutableA(Encoding::GetDefault().GetBytes(oFile.GetName().Get()).c_str(), NULL, sza);
    if (hInst <= reinterpret_cast<HINSTANCE>(32)) {
        throw Win32Exception(L"." + strSuffix + L" Ɋ֘AtꂽAvP[V̎擾Ɏs");
    } else {
        string file(NativeString::IsUnicode() ? szw : Encoding::GetDefault().GetString(sza));
        if (CFile(CFileName(file)).ExistsFile()) {
            return file;
        }
    }
    throw RuntimeException(L"." + strSuffix + L" Ɋ֘AtꂽAvP[V̎擾Ɏs܂");
}

/// t@CS~
void CSystem::DeleteFile(const CFileName& oFileName, bool confirm, HWND hWndParent) {
    DeleteFile(vector<CFileName>(&oFileName, &oFileName + 1), confirm, hWndParent);
}
/// t@CS~
void CSystem::DeleteFile(const vector<CFileName>& vctFiles, bool confirm, HWND hWndParent) {
    vector<string> fileNames;
    for (size_t i = 0, n = vctFiles.size(); i < n; i++) {
        fileNames.push_back(vctFiles[i].Get());
    }
    NativeString names = string::Join(string(L'\0', 1), fileNames) + string(L'\0', 1);
    if (names.Unicode()) {
        SHFILEOPSTRUCTW s = {0};
        s.hwnd = hWndParent;
        s.wFunc = FO_DELETE;
        s.pFrom = names.GetW();
        s.pTo = NULL;
        s.fFlags = FOF_ALLOWUNDO;
        if (!confirm) { s.fFlags |= FOF_NOCONFIRMATION; }
        ::SHFileOperationW(&s);
    } else {
        SHFILEOPSTRUCTA s = {0};
        s.hwnd = hWndParent;
        s.wFunc = FO_DELETE;
        s.pFrom = names.GetA();
        s.pTo = NULL;
        s.fFlags = FOF_ALLOWUNDO;
        if (!confirm) { s.fFlags |= FOF_NOCONFIRMATION; }
        ::SHFileOperationA(&s);
    }
}

CRect CSystem::GetWorkArea() {
    CRect rc;
    ::SystemParametersInfo(SPI_GETWORKAREA, 0, &rc, 0);
    return rc;  //CSizeł悤ȋCBBleftƂ0ȊOɐ肤̂[cB
}

namespace {
    #include <pshpack1.h>
        typedef void* _HMONITOR;
        typedef struct _tagMONITORINFO {
            DWORD   cbSize;
            RECT    rcMonitor;
            RECT    rcWork;
            DWORD   dwFlags;
        } _MONITORINFO;
        typedef BOOL (CALLBACK* _MONITORENUMPROC)(_HMONITOR, HDC, LPRECT, LPARAM);
    #include <poppack.h>

    typedef BOOL (WINAPI* FnGMI)(_HMONITOR hMonitor, _MONITORINFO* lpmi);
    FnGMI g_nGMI = NULL;
    // rcWork擾vectorpush
    BOOL CALLBACK CSystemMonitorEnumProc(_HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor, LPARAM dwData) {
        vector<CRect>& rvct = *reinterpret_cast<vector<CRect>*>(dwData);
        _MONITORINFO mi = {sizeof(_MONITORINFO)};
        if (g_nGMI(hMonitor, &mi) != FALSE) {
            rvct.push_back(mi.rcWork);
        }
        return TRUE;
    }
    // rcMonitor擾vectorpush
    BOOL CALLBACK CSystemMonitorEnumProc2(_HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor, LPARAM dwData) {
        vector<CRect>& rvct = *reinterpret_cast<vector<CRect>*>(dwData);
        _MONITORINFO mi = {sizeof(_MONITORINFO)};
        if (g_nGMI(hMonitor, &mi) != FALSE) {
            rvct.push_back(mi.rcMonitor);
        }
        return TRUE;
    }
}
vector<CRect> CSystem::GetAllWorkAreas() {
    vector<CRect> vct;
    try {
        // fBXvC̗
        CDll oDll(L"user32.dll", false);
        if (g_nGMI == NULL) {
            g_nGMI = (FnGMI)oDll.GetProc(L"GetMonitorInfoA");
        }
        typedef BOOL (WINAPI* FnEDM)(HDC, LPCRECT, _MONITORENUMPROC, LPARAM);
        FnEDM fnEDM = (FnEDM)oDll.GetProc(L"EnumDisplayMonitors");
        fnEDM(NULL, NULL, &CSystemMonitorEnumProc, reinterpret_cast<LPARAM>(&vct));
        Themis_DebugAssert(0 < vct.size());
        return vct;
    } catch (std::exception& e) {
        Themis_DebugWarning(e.what()); e;
    }
    // Win95/NTŕj^̎擾oȂꍇH
    vct.resize(1);
    vct[0] = CSystem::GetWorkArea();
    return vct;
}
vector<CRect> CSystem::GetAllScreensRect() {
    vector<CRect> vct;
    try {
        // fBXvC̗
        CDll oDll(L"user32.dll", false);
        if (g_nGMI == NULL) {
            g_nGMI = (FnGMI)oDll.GetProc(L"GetMonitorInfoA");
        }
        typedef BOOL (WINAPI* FnEDM)(HDC, LPCRECT, _MONITORENUMPROC, LPARAM);
        FnEDM fnEDM = (FnEDM)oDll.GetProc(L"EnumDisplayMonitors");
        fnEDM(NULL, NULL, &CSystemMonitorEnumProc2, reinterpret_cast<LPARAM>(&vct));
        Themis_DebugAssert(0 < vct.size());
        return vct;
    } catch (std::exception& e) {
        Themis_DebugWarning(e.what()); e;
    }
    // Win95/NTŕj^̎擾oȂꍇH
    vct.resize(1);
    vct[0] = CSystem::GetWorkArea();
    return vct;
}
CRect CSystem::GetScreensCoverRect() {
    CRect rc(0, 0, 0, 0);
    vector<CRect> vct = GetAllScreensRect();
    if (!vct.empty()) {
        rc = vct[0];
        for (size_t i = 0 + 1, n = vct.size(); i < n; i++) {
            rc.SetUnion(vct[i]);
        }
    }
    return rc;
}

bool CSystem::Is2kLater() {
    OSVERSIONINFO ov = {sizeof(OSVERSIONINFO)};
    ::GetVersionEx(&ov);
    return (5 <= ov.dwMajorVersion);
}

/// vZXgĂ郁̗ʂ擾
CSystem::SProcessMemory CSystem::GetProcessMemoryInfo() {
    typedef struct _PROCESS_MEMORY_COUNTERS {
        DWORD cb;
        DWORD PageFaultCount;
        SIZE_T PeakWorkingSetSize;
        SIZE_T WorkingSetSize;
        SIZE_T QuotaPeakPagedPoolUsage;
        SIZE_T QuotaPagedPoolUsage;
        SIZE_T QuotaPeakNonPagedPoolUsage;
        SIZE_T QuotaNonPagedPoolUsage;
        SIZE_T PagefileUsage;
        SIZE_T PeakPagefileUsage;
    } PROCESS_MEMORY_COUNTERS, *PPROCESS_MEMORY_COUNTERS;
    PROCESS_MEMORY_COUNTERS pmc = { sizeof(PROCESS_MEMORY_COUNTERS) };
    CDll oDll(L"psapi.dll");
    typedef BOOL (WINAPI* Fn)(HANDLE, PROCESS_MEMORY_COUNTERS*, DWORD);
    Fn fn = (Fn)oDll.GetProc(L"GetProcessMemoryInfo");
    fn(::GetCurrentProcess(), &pmc, sizeof(pmc));
    Themis_DebugOutput(string::Format(L"PageFaultCount         F%d", pmc.PageFaultCount));
    Themis_DebugOutput(string::Format(L"PeakWorkingSetSize     F%d", pmc.PeakWorkingSetSize));
    Themis_DebugOutput(string::Format(L"WorkingSetSize         F%d", pmc.WorkingSetSize));
    Themis_DebugOutput(string::Format(L"QuotaPeakPagedPoolUsageF%d", pmc.QuotaPeakPagedPoolUsage));
    Themis_DebugOutput(string::Format(L"QuotaPagedPoolUsage    F%d", pmc.QuotaPagedPoolUsage));
    Themis_DebugOutput(string::Format(L"QuotaPeakNonPagedPoolUsageF%d", pmc.QuotaPeakNonPagedPoolUsage));
    Themis_DebugOutput(string::Format(L"QuotaNonPagedPoolUsage F%d", pmc.QuotaNonPagedPoolUsage));
    Themis_DebugOutput(string::Format(L"PagefileUsage          F%d", pmc.PagefileUsage));
    Themis_DebugOutput(string::Format(L"PeakPagefileUsage      F%d", pmc.PeakPagefileUsage));
    // ĂƁ[ɈڂւB(蔲)
    SProcessMemory pm;
    pm.nPageFaultCount = pmc.PageFaultCount;
    pm.nPeakWorkingSetSize = pmc.PeakWorkingSetSize;
    pm.nWorkingSetSize = pmc.WorkingSetSize;
    pm.nQuotaPeakPagedPoolUsage = pmc.QuotaPeakPagedPoolUsage;
    pm.nQuotaPagedPoolUsage = pmc.QuotaPagedPoolUsage;
    pm.nQuotaPeakNonPagedPoolUsage = pmc.QuotaPeakNonPagedPoolUsage;
    pm.nQuotaNonPagedPoolUsage = pmc.QuotaNonPagedPoolUsage;
    pm.nPagefileUsage = pmc.PagefileUsage;
    pm.nPeakPagefileUsage = pmc.PeakPagefileUsage;
    return pm;
}

pair<uint64_t, uint64_t> CSystem::GetPhysicalMemorySize() {
    try {
        CDll oDll(L"kernel32.dll", false);
        typedef BOOL (WINAPI* Fn)(MEMORYSTATUSEX* ms);
        Fn fn = (Fn)oDll.GetProc(L"GlobalMemoryStatusEx");
        MEMORYSTATUSEX ms = { sizeof(MEMORYSTATUSEX) };
        if (fn(&ms) != FALSE) {
            Themis_DebugOutput(string::Format(L"󂫕F%dMB", static_cast<int>(ms.ullAvailPhys / 1048576)));
            Themis_DebugOutput(string::Format(L"ڕF%dMB", static_cast<int>(ms.ullTotalPhys / 1048576)));
            return pair<uint64_t, uint64_t>(ms.ullAvailPhys, ms.ullTotalPhys);
        }
    } catch (...) {
    }
    MEMORYSTATUS ms = {sizeof(MEMORYSTATUS)};
    ::GlobalMemoryStatus(&ms);
    Themis_DebugOutput(string::Format(L"󂫕F%dMB", static_cast<int>(ms.dwAvailPhys / 1048576)));
    Themis_DebugOutput(string::Format(L"ڕF%dMB", static_cast<int>(ms.dwTotalPhys / 1048576)));
    return pair<uint64_t, uint64_t>(ms.dwAvailPhys, ms.dwTotalPhys);
}

namespace {
    bool CSystemExitWindows(UINT uFlags) {
        HANDLE hToken = NULL;
        TOKEN_PRIVILEGES oTp = {0};
        if (NativeString::IsUnicode()) {    //NTnȂVbg_EȂƂȂc
            ::OpenProcessToken(::GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken);
            ::LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &oTp.Privileges[0].Luid);
            oTp.PrivilegeCount = 1;
            oTp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
            ::AdjustTokenPrivileges(hToken, FALSE, &oTp, 0, NULL, NULL);
        }

        BOOL ret = ::ExitWindowsEx(uFlags, 0);

        if (hToken != NULL) {
            oTp.Privileges[0].Attributes = 0;
            ::AdjustTokenPrivileges(hToken, FALSE, &oTp, 0, NULL, NULL);
            ::CloseHandle(hToken);
        }
        return (ret != FALSE);
    }
}
bool CSystem::Shutdown() {
    return CSystemExitWindows(EWX_POWEROFF);
}
bool CSystem::Reboot() {
    return CSystemExitWindows(EWX_REBOOT);
}

namespace {
    HWND _FindChildWindowFromClassname(HWND hWndParent, LPSTR lpszClassName) {
        char classname[400];
        HWND hWnd = GetTopWindow(hWndParent);
        if (!hWnd) return(NULL);
        while (hWnd) {
            GetClassName(hWnd, classname, 400);
            if (!lstrcmpi(classname, lpszClassName)) return(hWnd);
            hWnd = GetWindow(hWnd, GW_HWNDNEXT);
        }
        return NULL;
    }
    HWND _GetDesktopWindow(VOID) {
        HWND hWnd = FindWindow("Progman", "Program Manager");
        if (!hWnd) return(GetDesktopWindow());
        hWnd = _FindChildWindowFromClassname(hWnd, "SHELLDLL_DefView");
        if (!hWnd) return(GetDesktopWindow());
        return hWnd;
    }
    BOOL _IsActiveDesktopUsing(VOID) {
        HWND hWnd = _GetDesktopWindow();
        if (!hWnd) return(FALSE);
        hWnd = _FindChildWindowFromClassname(hWnd, "Internet Explorer_Server");
        return hWnd != NULL;
    }
}
void CSystem::SetWallpaper(const string& strFileName) {
    /*if (_IsActiveDesktopUsing()) {
        HKEY hkey;
        char tmp[_MAX_PATH];
        DWORD nTmp = _MAX_PATH;
        ::RegOpenKey(HKEY_CURRENT_USER, "Control Panel\\desktop\\", &hkey);
        ::RegQueryValueEx(hkey, L"Wallpaper", NULL, NULL, (LPBYTE)tmp, &nTmp);
        BOOL ret = ::SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, const_cast<char*>(Encoding::GetDefault().GetBytes(strFileName).c_str()), SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
        ::RegSetValueEx(hkey, L"Wallpaper", 0, REG_SZ, (const LPBYTE)tmp, lstrlen(tmp)+1);
        ::RegCloseKey(hkey);
        if (ret == FALSE) {
            throw RuntimeException(L"ǎ̐ݒɎs܂");
        }
    }
    else*/ {
        BOOL ret = ::SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, const_cast<char*>(Encoding::GetDefault().GetBytes(strFileName).c_str()), SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
        if (ret == FALSE) {
            throw Win32Exception(L"ǎ̐ݒɎs");
        }
    }
}
void CSystem::SetWallpaperDefault() {
    BOOL ret = ::SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, SETWALLPAPER_DEFAULT, SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
    if (ret == FALSE) {
        throw Win32Exception(L"ǎ̐ݒɎs");
    }
}
void CSystem::UnsetWallpaper() {
    SetWallpaper(string());
}

bool CSystem::GetClipboard(string& str) {
    if (::IsClipboardFormatAvailable(CF_TEXT) != FALSE) {
        if (::OpenClipboard(NULL) == 0) {
            throw Win32Exception(L"Nbv{[h̎̕擾Ɏs");
        }
        HGLOBAL hGlobal = reinterpret_cast<HGLOBAL>(::GetClipboardData(CF_TEXT));
        if (hGlobal == NULL) {
            Win32Exception e(L"Nbv{[h̎̕擾Ɏs");
            ::CloseClipboard();
            throw e;
        }
        str = Encoding::GetDefault().GetString(reinterpret_cast<char*>(::GlobalLock(hGlobal)));
        ::GlobalUnlock(hGlobal);
        ::CloseClipboard();
        return true;
    }
    return false;
}

bool CSystem::GetClipboard(HDC hdc, const CPoint& pt, CSize& sz) {
    if (::IsClipboardFormatAvailable(CF_BITMAP) != FALSE) {
        if (::OpenClipboard(NULL) == 0) {
            throw Win32Exception(L"Nbv{[h̉摜̎擾Ɏs");
        }
        HBITMAP hbmp = reinterpret_cast<HBITMAP>(::GetClipboardData(CF_BITMAP));
        if (hbmp == NULL) {
            Win32Exception e(L"Nbv{[h̉摜̎擾Ɏs");
            ::CloseClipboard();
            throw e;
        }
        HDC hdcTmp1 = ::GetDC(NULL);
        if (hdcTmp1 == NULL) {
            throw Win32Exception(L"Nbv{[h̉摜̎擾Ɏs");
        }
        HDC hdcTmp2 = ::CreateCompatibleDC(hdcTmp1);
        if (hdcTmp2 == NULL) {
            Win32Exception e(L"Nbv{[h̉摜̎擾Ɏs");
            ::ReleaseDC(NULL, hdcTmp1);
            throw e;
        }
        ::SelectObject(hdcTmp2, hbmp);
        BITMAP bmp = {0};
        if (::GetObject(hbmp, sizeof(bmp), &bmp) == 0) {
            Win32Exception e(L"Nbv{[h̉摜̎擾Ɏs");
            ::DeleteDC(hdcTmp2);
            ::ReleaseDC(NULL, hdcTmp1);
            throw e;
        }
        if (bmp.bmWidth <= 0 || bmp.bmHeight <= 0) {
            ::DeleteDC(hdcTmp2);
            ::ReleaseDC(NULL, hdcTmp1);
            throw RuntimeException(L"Nbv{[h̉摜̑傫̎擾Ɏs܂");
        }
        sz.cx = bmp.bmWidth;
        sz.cy = bmp.bmHeight;
        ::BitBlt(hdc, pt.x, pt.y, sz.cx, sz.cy, hdcTmp2, 0, 0, SRCCOPY);
        ::DeleteDC(hdcTmp2);
        ::ReleaseDC(NULL, hdcTmp1);
        ::CloseClipboard();
        return true;
    }
    return false;
}

void CSystem::SetClipboard(const string& str) {
    std::string mb = Encoding::GetDefault().GetBytes(str);
    HGLOBAL hGlobal = ::GlobalAlloc(GHND, mb.length() + 1);
    if (hGlobal == NULL) {
        throw Win32Exception(L"Nbv{[hւ̐̕ݒɎs");
    }
    char* p = reinterpret_cast<char*>(::GlobalLock(hGlobal));
    memcpy(p, mb.c_str(), mb.length() + 1);
    ::GlobalUnlock(hGlobal);
    if (::OpenClipboard(NULL) == 0) {
        ::GlobalFree(hGlobal);
        throw Win32Exception(L"Nbv{[hւ̐̕ݒɎs");
    }
    ::EmptyClipboard();
    ::SetClipboardData(CF_TEXT, hGlobal);
    ::CloseClipboard();
}

/// DDB
void CSystem::SetClipboard(HDC hdc, const CRect& rc) {
    HDC hdcTmp1 = ::GetDC(NULL);
    if (hdcTmp1 == NULL) {
        throw Win32Exception(L"Nbv{[hւ̉摜̐ݒɎs");
    }
    HDC hdcTmp2 = ::CreateCompatibleDC(hdcTmp1);
    if (hdcTmp2 == NULL) {
        Win32Exception e(L"Nbv{[hւ̉摜̐ݒɎs");
        ::ReleaseDC(NULL, hdcTmp1);
        throw e;
    }
    HBITMAP hbmp = ::CreateCompatibleBitmap(hdcTmp1, rc.GetWidth(), rc.GetHeight());
    if (hbmp == NULL) {
        Win32Exception e(L"Nbv{[hւ̉摜̐ݒɎs");
        ::DeleteDC(hdcTmp2);
        ::ReleaseDC(NULL, hdcTmp1);
        throw e;
    }
    ::SelectObject(hdcTmp2, hbmp);
    ::BitBlt(hdcTmp2, 0, 0, rc.GetWidth(), rc.GetHeight(), hdc, rc.left, rc.top, SRCCOPY);
    if (::OpenClipboard(NULL) == 0) {
        Win32Exception e(L"Nbv{[hւ̉摜̐ݒɎs");
        ::DeleteDC(hdcTmp2);
        ::ReleaseDC(NULL, hdcTmp1);
        throw e;
    }
    ::EmptyClipboard();
    ::SetClipboardData(CF_BITMAP, hbmp);
    ::CloseClipboard();
    ::DeleteDC(hdcTmp2);
    ::ReleaseDC(NULL, hdcTmp1);
}

/*
/// lt32BPPDIB(Win2k/XPȍ~p)
void CSystem::SetClipboard(const BITMAPV5HEADER& bif, const uint32_t* pdwBits, int nPitch) {
    const int nDstBytePitch = abs(bif.bV5Width) * 4;
    const int nHeight = abs(bif.bV5Height);
    HGLOBAL hGlobal = ::GlobalAlloc(GHND, sizeof(BITMAPV5HEADER) + nDstBytePitch * nHeight);
    if (hGlobal == NULL) {
        throw Win32Exception(L"Nbv{[hւDIB̐ݒɎs");
    }
    uint8_t* pbyDst = reinterpret_cast<uint8_t*>(::GlobalLock(hGlobal));
    memcpy(pbyDst, &bif, sizeof(BITMAPV5HEADER));
    pbyDst += sizeof(BITMAPV5HEADER);
    for (int y = 0; y < nHeight; y++) {
        memcpy(pbyDst, pdwBits, nDstBytePitch);
        pbyDst += nDstBytePitch;
        pdwBits += nPitch;
    }
    ::GlobalUnlock(hGlobal);
    if (::OpenClipboard(NULL) == 0) {
        Win32Exception e(L"Nbv{[hւDIB̐ݒɎs");
        ::GlobalFree(hGlobal);
        throw e;
    }
    ::EmptyClipboard();
    ::SetClipboardData(CF_DIBV5, hGlobal);
    ::CloseClipboard();
}
*/

namespace {
    int CALLBACK CSystemEnumFontsProc(const LOGFONT* lplf, const TEXTMETRIC* lptm, DWORD FontType, LPARAM lParam) {
        vector<string>* pList = reinterpret_cast<vector<string>*>(lParam);
        if (lplf->lfFaceName[0] != '@') { // Ƃ肠c͏
            pList->push_back(Encoding::GetDefault().GetString(lplf->lfFaceName));
        }
        return 1;
    }
}
/// tHg̃Xg쐬
vector<string> CSystem::GetFontList() {
    vector<string> oList;
    HDC hdc = ::CreateCompatibleDC(NULL);
    LOGFONT lf = {0};
    lf.lfCharSet = SHIFTJIS_CHARSET;
 // lf.lfCharSet = DEFAULT_CHARSET;
    ::EnumFontFamiliesEx(hdc, &lf, &CSystemEnumFontsProc, reinterpret_cast<LPARAM>(&oList), 0);
    ::DeleteDC(hdc);
    return oList;
}
/// tHg̃Xg쐬
vector<string> CSystem::GetAnsiFontList() {
    vector<string> oList;
    HDC hdc = ::CreateCompatibleDC(NULL);
    LOGFONT lf = {0};
    lf.lfCharSet = ANSI_CHARSET;
    ::EnumFontFamiliesEx(hdc, &lf, &CSystemEnumFontsProc, reinterpret_cast<LPARAM>(&oList), 0);
    ::DeleteDC(hdc);
    return oList;
}

namespace {
    BOOL CALLBACK CSystemEnumWindowsProc(HWND hwnd, LPARAM lParam) {
        vector<HWND>* pList = reinterpret_cast<vector<HWND>*>(lParam);
        pList->push_back(hwnd);
        return TRUE;
    }
}
vector<HWND> CSystem::GetWindowList() {
    vector<HWND> oList;
    ::EnumWindows(&CSystemEnumWindowsProc, reinterpret_cast<LPARAM>(&oList));
    return oList;
}

vector<PROCESSENTRY32> CSystem::GetProcessSnapshot() {
    CDll oKernel(L"KERNEL32.DLL", false);
    HANDLE hProcessSnap = oKernel(L"CreateToolhelp32Snapshot", CDllFunc2<HANDLE, DWORD, DWORD>())(TH32CS_SNAPPROCESS, 0);
    if (hProcessSnap == INVALID_HANDLE_VALUE) {
        throw RuntimeException(L"vZX̃XibvVbg擾Ɏs܂");
    }

    vector<PROCESSENTRY32> oBuf;
    PROCESSENTRY32 pe32 = {sizeof(PROCESSENTRY32)};
    if (oKernel(L"Process32First", CDllFunc2<BOOL, HANDLE, LPPROCESSENTRY32>())(hProcessSnap, &pe32) == FALSE) {
        throw RuntimeException(L"vZX̃XibvVbg擾Ɏs܂");
    }

    CDllFunc2<BOOL, HANDLE, LPPROCESSENTRY32>::T Process32Next
        = oKernel(L"Process32Next", CDllFunc2<BOOL, HANDLE, LPPROCESSENTRY32>());
    do {
        oBuf.push_back(pe32);
    } while (Process32Next(hProcessSnap, &pe32));
    ::CloseHandle(hProcessSnap);
    return oBuf;
}

string CSystem::GetModuleName(HWND hWnd) {
    return GetModuleName(hWnd, GetProcessSnapshot());
}

string CSystem::GetModuleName(HWND hWnd, const vector<PROCESSENTRY32>& oPe) {
    DWORD dwProcessId = 0;
    ::GetWindowThreadProcessId(hWnd, &dwProcessId);
    for (size_t i = 0, n = oPe.size(); i < n; i++) {
        if (oPe[i].th32ProcessID == dwProcessId) {
            return Encoding::GetDefault().GetString(oPe[i].szExeFile);
        }
    }
    return string();
}

HWND CSystem::GetWindow(const string& strModuleName) {
    //gqƃpXŔׂ邯ǁAvcH
    string strPrefix = CFileName(strModuleName).GetPrefix();
    //
    // EBhEnhƃvZXf[^񋓂āA
    // EBhEnh炻ɑvZXID擾āA
    // ID񋓂vZXf[^̒TEXẼt@C𓾂āA
    // ƈ̂ƂׂĈv炻̃EBhEnhԂB
    // cƊȒPȕ@肻ȋCBB
    //
    vector<PROCESSENTRY32> peList = GetProcessSnapshot();
    vector<HWND> vctWnd = GetWindowList();
    for (size_t i = 0, n = vctWnd.size(); i < n; i++) {
        if ((static_cast<DWORD>(::GetWindowLong(vctWnd[i], GWL_STYLE)) & WS_CHILD) == 0) { //  qȂꍇ̂݁B
            if (strPrefix == CFileName(GetModuleName(vctWnd[i], peList)).GetPrefix()) {
                return vctWnd[i];
            }
        }
    }
    return NULL;
}

string CSystem::GetModuleFileName() {
    char sz[_MAX_PATH] = {0};
    ::GetModuleFileName(NULL, sz, sizeof(sz));
    return Encoding::GetDefault().GetString(sz);
}

string CSystem::GetTempDir() {
    char sz[_MAX_PATH];
    ::GetTempPath(_MAX_PATH, sz);
    size_t n = strlen(sz);
    if (sz[n - 1] != '\\') {
        sz[n - 0] = '\\';
        sz[n + 1] = '\0';
    }
    return Encoding::GetDefault().GetString(sz);
}

namespace {
    string CSystemGetDir(int nFolder, const string& name) {
        ITEMIDLIST* pidl;
        if (SUCCEEDED(::SHGetSpecialFolderLocation(NULL, nFolder, &pidl))) {
            //uCSIDL_FXvŐFXȂ̂擾oB
            string str = CSystem::GetPath(pidl);
            ::CoTaskMemFree(pidl);
            if (!str.EndsWith(L"\\")) str += L"\\";
            return str;
        }
        throw RuntimeException(name + L"tH_̎擾Ɏs܂");
    }
}
string CSystem::GetAppDataDir() { return CSystemGetDir(CSIDL_APPDATA, L"AvP[Vf[^"); }
string CSystem::GetCommonDesktopDir() { return CSystemGetDir(CSIDL_COMMON_DESKTOPDIRECTORY, L"ʃfXNgbv"); }
string CSystem::GetCommonFavoritesDir() { return CSystemGetDir(CSIDL_COMMON_FAVORITES, L"ʂCɓ"); }
string CSystem::GetCommonProgramsDir() { return CSystemGetDir(CSIDL_COMMON_PROGRAMS, L"ʃvO"); }
string CSystem::GetCommonStartMenuDir() { return CSystemGetDir(CSIDL_COMMON_STARTMENU, L"ʃX^[gj["); }
string CSystem::GetCommonStartupDir() { return CSystemGetDir(CSIDL_COMMON_STARTUP, L"ʃX^[gAbv"); }
string CSystem::GetCookiesDir() { return CSystemGetDir(CSIDL_COOKIES, L"Cookies"); }
string CSystem::GetDesktopDir() { return CSystemGetDir(CSIDL_DESKTOPDIRECTORY, L"fXNgbv"); }
string CSystem::GetFavoritesDir() { return CSystemGetDir(CSIDL_FAVORITES, L"Cɓ"); }
string CSystem::GetFontsDir() { return CSystemGetDir(CSIDL_FONTS, L"tHg"); }
string CSystem::GetHistoryDir() { return CSystemGetDir(CSIDL_HISTORY, L""); }
string CSystem::GetInternetCacheDir() { return CSystemGetDir(CSIDL_INTERNET_CACHE, L"C^[lbgLbV"); }
string CSystem::GetNetHoodDir() { return CSystemGetDir(CSIDL_NETHOOD, L"NetHood"); }
string CSystem::GetMyDocumentsDir() { return CSystemGetDir(CSIDL_PERSONAL, L"}C hLg"); }
string CSystem::GetPrintHoodDir() { return CSystemGetDir(CSIDL_PRINTHOOD, L"v^"); }
string CSystem::GetProgramsDir() { return CSystemGetDir(CSIDL_PROGRAMS, L"vO"); }
string CSystem::GetRecentDir() { return CSystemGetDir(CSIDL_RECENT, L"ŋߎgt@C"); }
string CSystem::GetSendToDir() { return CSystemGetDir(CSIDL_SENDTO, L"SendTo"); }
string CSystem::GetStartMenuDir() { return CSystemGetDir(CSIDL_STARTMENU, L"X^[gj["); }
string CSystem::GetStartupDir() { return CSystemGetDir(CSIDL_STARTUP, L"X^[gAbv"); }
string CSystem::GetTemplatesDir() { return CSystemGetDir(CSIDL_TEMPLATES, L"ev[g"); }
string CSystem::GetMyPicturesDir() { return CSystemGetDir(CSIDL_MYPICTURES, L"}CsN`["); }

string CSystem::GetEnv(const string& strName) {
    DWORD dwLen = ::GetEnvironmentVariable(Encoding::GetDefault().GetBytes(strName).c_str(), NULL, 0) + 1;
    if (dwLen <= 1) {
        throw RuntimeException(L"ϐ '" + strName + L"' ̎擾Ɏs܂");
    }
    boost::scoped_array<char> sz(new char[dwLen]);
    ::GetEnvironmentVariable(Encoding::GetDefault().GetBytes(strName).c_str(), sz.get(), dwLen);
    return Encoding::GetDefault().GetString(sz.get());
}

void CSystem::SetEnv(const string& strName, const string& strValue) {
    if (::SetEnvironmentVariable(Encoding::GetDefault().GetBytes(strName).c_str(), Encoding::GetDefault().GetBytes(strValue).c_str()) == FALSE) {
        throw Win32Exception(L"ϐ'" + strName + L"'̐ݒɎs܂");
    }
}

bool CSystem::IsUserAnAdmin(bool defaultValue) {
    typedef BOOL (WINAPI* FN)();
    FN IsUserAnAdmin = (FN)CDll(L"shell32.dll", false).GetProcNoThrow(L"IsUserAnAdmin");
    if (IsUserAnAdmin != NULL) {
        return defaultValue;
    }
    return IsUserAnAdmin() != FALSE;
}

CSystem::SDriveInfo::SDriveInfo(const string& p, const string& n, const string& t, HICON h)
: strPath(p), strName(n), strTypeName(t), hIcon(h) {
}

CSystem::SDriveInfo::~SDriveInfo() {
    ::DestroyIcon(hIcon);
}

/// hCũXg쐬
smart_ptr_vector<CSystem::SDriveInfo> CSystem::EnumDrives() {
    DWORD dwDrives = ::GetLogicalDrives();
    if (dwDrives == 0) {
        throw Win32Exception(L"hCu̗񋓂Ɏs");
    }
    smart_ptr_vector<CSystem::SDriveInfo> vct;
    for (int i = 0; i < 26; i++) {
        if ((dwDrives & (1 << i)) != 0) {
            char szPath[] = {i + 'A', ':', '\\', '\0'};
            SHFILEINFO si = {0};
            if (::SHGetFileInfo(szPath, 0, &si, sizeof(si), SHGFI_TYPENAME | SHGFI_DISPLAYNAME | SHGFI_ICON | SHGFI_SMALLICON) == NULL) {
                Themis_DebugApiError();
            } else {
                vct.push_back(std::tr1::shared_ptr<SDriveInfo>(
                    new SDriveInfo(Encoding::GetDefault().GetString(szPath),
                        Encoding::GetDefault().GetString(si.szDisplayName),
                        Encoding::GetDefault().GetString(si.szTypeName), si.hIcon)));
            }
        }
    }
    return vct;
}

string CSystem::LoadResource(UINT nId) {
    HINSTANCE hInst = ::GetModuleHandle(NULL);
    int nSize = 0x100;
    boost::scoped_array<char> sz(new char[nSize]);
    while (true) {
        int nRet = ::LoadString(hInst, nId, sz.get(), nSize);
        if (nRet == 0) {
            return string();   //\[XȂȂJb|
        } else if (nRet < nSize) {    //Sǂݍ߂Ă
            break;
        }
        nSize *= 2;                 //TCYQ{ɂčĒ
        sz.reset(new char[nSize]);
    }
    return Encoding::GetDefault().GetString(sz.get());
}

CSystem::SShortcutInfo::SShortcutInfo(): nShowCmd(SW_SHOWNORMAL) {
}

void CSystem::CreateShortcut(const CFileName& oFileName, const SShortcutInfo& o) {
    CCOM::GetInstance().Initialize();
    IShellLink *pShellLink = NULL;
    IPersistFile *pPersistFile = NULL;
    try{
        if (CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (void**)&pShellLink) != S_OK) {
            throw RuntimeException(L"V[gJbg̍쐬Ɏs܂");
        }
        // ̐ݒ
        Themis_DebugAssert(!string::IsNullOrEmpty(o.strTarget));
        pShellLink->SetPath(Encoding::GetDefault().GetBytes(o.strTarget).c_str());
        if (!string::IsNullOrEmpty(o.strArguments)) {
            pShellLink->SetArguments(Encoding::GetDefault().GetBytes(o.strArguments).c_str());
        }
        if (!string::IsNullOrEmpty(o.strDescription)) {
            pShellLink->SetDescription(Encoding::GetDefault().GetBytes(o.strDescription).c_str());
        }
        if (!string::IsNullOrEmpty(o.strWorkDir)) {
            pShellLink->SetWorkingDirectory(Encoding::GetDefault().GetBytes(o.strWorkDir).c_str());
        }
        if (!string::IsNullOrEmpty(o.strIconFile)) {
            pShellLink->SetIconLocation(Encoding::GetDefault().GetBytes(o.strIconFile).c_str(), o.nIcon);
        }
        if (o.nShowCmd != SW_SHOWNORMAL) {
            pShellLink->SetShowCmd(o.nShowCmd);
        }
        // o
        if (pShellLink->QueryInterface(IID_IPersistFile,  (void**)&pPersistFile) != S_OK) {
            throw RuntimeException(L"V[gJbgt@C̍쐬Ɏs܂");
        }
        if (pPersistFile->Save(oFileName.Get().ToCharPtr(), true) != S_OK) {
            throw RuntimeException(L"V[gJbgt@C̏oɎs܂");
        }
        // n
        pPersistFile->Release();
        pPersistFile = NULL;
        pShellLink->Release();
        pShellLink = NULL;
        CCOM::GetInstance().Terminate();
    }
    catch(...) {
        if (pPersistFile != NULL) {
            pPersistFile->Release();
        }
        if (pShellLink != NULL) {
            pShellLink->Release();
        }
        CCOM::GetInstance().Terminate();
        throw;
    }
}

CSystem::SShortcutInfo CSystem::GetShortcutInfo(const CFileName& oFileName) {
    SShortcutInfo o;
    o.nShowCmd = SW_SHOWNORMAL;
    o.nIcon = 0;
    CCOM::GetInstance().Initialize();
    IShellLink *pShellLink = NULL;
    IPersistFile *pPersistFile = NULL;
    try{
        // ǂݍ
        if (CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (void**)&pShellLink) != S_OK) {
            throw RuntimeException(L"V[gJbg̓ǂݍݏɎs܂");
        }
        if (pShellLink->QueryInterface(IID_IPersistFile, (void**)&pPersistFile) != S_OK) {
            throw RuntimeException(L"V[gJbgt@C̓ǂݍݏɎs܂");
        }
        if (pPersistFile->Load(oFileName.Get().ToCharPtr(), STGM_READ) != S_OK) {
            throw RuntimeException(L"V[gJbgt@C̏oɎs܂");
        }
        pPersistFile->Release();
        pPersistFile = NULL;
        // ̎擾
        char sz[0x400];
        sz[0] = '\0';
        pShellLink->GetPath(sz, 0x400, NULL, SLGP_UNCPRIORITY);
        o.strTarget = Encoding::GetDefault().GetString(sz);
        sz[0] = '\0';
        pShellLink->GetArguments(sz, 0x400);
        o.strArguments = Encoding::GetDefault().GetString(sz);
        sz[0] = '\0';
        pShellLink->GetDescription(sz, 0x400);
        o.strDescription = Encoding::GetDefault().GetString(sz);
        sz[0] = '\0';
        pShellLink->GetWorkingDirectory(sz, 0x400);
        o.strWorkDir = Encoding::GetDefault().GetString(sz);
        sz[0] = '\0';
        pShellLink->GetIconLocation(sz, 0x400, &o.nIcon);
        o.strIconFile = Encoding::GetDefault().GetString(sz);
        pShellLink->GetShowCmd(&o.nShowCmd);
        // n
        pShellLink->Release();
        pShellLink = NULL;
        CCOM::GetInstance().Terminate();
    }
    catch(...) {
        if (pPersistFile != NULL) {
            pPersistFile->Release();
        }
        if (pShellLink != NULL) {
            pShellLink->Release();
        }
        CCOM::GetInstance().Terminate();
        throw;
    }
    return o;
}

void CSystem::RegisterRelation(const string& strSuffix, const string& strFileType, const string& strContentType) {
    CRegistry oReg;
    oReg.Create(HKEY_CLASSES_ROOT, L"." + strSuffix);
    oReg.Str(string(), strFileType);
    if (!string::IsNullOrEmpty(strContentType)) {
        oReg.Str(L"Content Type", strContentType);
    }
    //obNAbvƂ͖ʓ|Ȃ̂łƂ肠ȂBC炷邩B
}

void CSystem::RegisterRelationFileType(const string& strFileType, const SRelationFileTypeInfo& o) {
    CRegistry oReg;
    oReg.Create(HKEY_CLASSES_ROOT, strFileType);
    if (!string::IsNullOrEmpty(o.strDescription)) {
        oReg.Str(string(), o.strDescription);
    }
    if (!string::IsNullOrEmpty(o.strCommand)) {
        oReg.Create(L"Shell\\" + o.strCommand);
    } else {
        oReg.Create(L"Shell\\Open");
    }
    if (!string::IsNullOrEmpty(o.strMenuName)) {
        oReg.Str(string(), o.strMenuName);
    }
    if (!string::IsNullOrEmpty(o.strCommandLine)) {
        oReg.Create(L"Command");
        oReg.Str(string(), o.strCommandLine);
    }
    if (!string::IsNullOrEmpty(o.strIconFile)) {
        oReg.Create(HKEY_CLASSES_ROOT, strFileType + L"\\DefaultIcon");
        oReg.Str(string(), o.strIconFile + L"," + string::Format(L"%d", o.nIcon));
    }
}

void CSystem::NotifyRelation() {
    ::SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, NULL, NULL);
}

void CSystem::DeleteRelation(const string& strSuffix, const string& strFileType) {
    CRegistry oReg;
    try {
        oReg.Open(HKEY_CLASSES_ROOT, L"." + strSuffix, true);
    } catch (...) {
        return;
    }
    if (oReg.Str(string()) == strFileType) {
        oReg.Str(string(), string()); //ꍇɂĂ͐Ղc邯ǁAExplorerƂĂۂ̂ŁcB
     // oReg.Delete(HKEY_CLASSES_ROOT, L"." + strSuffix);
    }
}

void CSystem::DeleteRelationFileType(const string& strFileType) {
    // 폜
    if (!string::IsNullOrEmpty(strFileType)) {
        CRegistry::Delete(HKEY_CLASSES_ROOT, strFileType + L"\\Shell\\Open\\Command");
        CRegistry::Delete(HKEY_CLASSES_ROOT, strFileType + L"\\Shell\\Open");
        CRegistry::Delete(HKEY_CLASSES_ROOT, strFileType + L"\\Shell");
        CRegistry::Delete(HKEY_CLASSES_ROOT, strFileType);
    }
}

void CSystem::DeleteRelationCommand(const string& strFileType, const string& strCommand) {
    // R}ĥƂ폜
    if (!string::IsNullOrEmpty(strFileType) && !string::IsNullOrEmpty(strCommand)) {
        CRegistry::Delete(HKEY_CLASSES_ROOT, strFileType + L"\\Shell\\" + strCommand + L"\\Command");
        CRegistry::Delete(HKEY_CLASSES_ROOT, strFileType + L"\\Shell\\" + strCommand);
    }
}

string CSystem::GetRelationFileType(const string& strSuffix) {
    try {
        CRegistry oReg;
        oReg.Open(HKEY_CLASSES_ROOT, L"." + strSuffix, false);
        return oReg.Str(string());
    } catch (std::exception&) {
        return string();
    }
}

/// ֘AtĂ邩ǂ
bool CSystem::IsRelationFileType(const string& strSuffix, const string& strFileType) {
    try {
        return GetRelationFileType(strSuffix) == strFileType;
    } catch (std::exception&) {
        return false;
    }
}

/// R}ho^Ă邩ǂ
bool CSystem::IsRelationCommand(const string& strFileType, const string& strCommand) {
    try {
        CRegistry oReg;
        oReg.Open(HKEY_CLASSES_ROOT, strFileType + L"\\Shell\\" + strCommand, false);
        oReg.Close();
        return true; // Jo^ĂƌȂ
    } catch (std::exception&) {
        return false;
    }
}

/// t@CITEMIDLIST쐬
ITEMIDLIST* CSystem::GetItemIDList(const CFileName& oFileName) {
    IShellFolder* pFolder;
    if (::SHGetDesktopFolder(&pFolder) != NOERROR) {
        throw RuntimeException(L"t@C̕ϊɎs܂");
    }
    std::wstring name; name = oFileName.Get().ToCharArray();
    // IDList̎擾
    ITEMIDLIST* pIDL;
    ULONG chEaten, dwAttributes;
    if (pFolder->ParseDisplayName(NULL, NULL, &name[0], &chEaten, &pIDL, &dwAttributes) != NOERROR) {
        pFolder->Release();
        throw RuntimeException(L"t@C '" + oFileName.Get() + L"' ̕ϊɎs܂");
    }
    pFolder->Release();
    return pIDL;
}

string CSystem::GetPath(ITEMIDLIST* pIL) {
    if (NativeString::IsUnicode()) {
        wchar_t sz[_MAX_PATH];
        if (::SHGetPathFromIDListW(pIL, sz) == FALSE) {
            return string::Empty;
        }
        return sz;
    } else {
        char sz[_MAX_PATH];
        if (::SHGetPathFromIDListA(pIL, sz) == FALSE) {
            return string::Empty;
        }
        return Encoding::GetDefault().GetString(sz);
    }
}

}
