#pragma once
namespace Themis {

/**
    vf̏dȂz
*/
template<class C> class unique_array : private boost::noncopyable {
public:
    typedef typename C::value_type value_type;
    typedef typename C::size_type size_type;
    typedef typename C::reference reference;
    typedef typename C::iterator iterator;
    typedef typename C::const_reference const_reference;
    typedef typename C::const_iterator const_iterator;

    unique_array() {}
    ~unique_array() {}

    template<class T> int find(const T& x) {
        for (int i = 0, n = m_c.size(); i < n; i++) {
            if (m_c[i] == x)
                return i;
        }
        return -1;
    }

    template<class T> bool insert(const T& x) {
        if (find(x) < 0) {
            m_c.push_back(x);
            return true;
        }
        return false;
    }

    template<class T> bool erase(const T& x) {
        int n = find(x);
        if (0 <= n) {
            erase(begin() + n);
            return true;
        }
        return false;
    }

    inline void clear() { m_c.clear(); }
    inline bool empty() const { return m_c.empty(); }
    inline size_type size() const { return m_c.size(); }
    inline const_iterator begin() const { return m_c.begin(); }
    inline const_iterator end() const { return m_c.end(); }
    inline iterator erase(iterator it) { return m_c.erase(it); }
    inline iterator erase(iterator f, iterator l) { return m_c.erase(f, l); }
    inline void pop_front() { m_c.pop_front(); }
    inline void pop_back() { m_c.pop_back(); }
    inline reference operator[](size_type n) { return m_c[n]; }
    inline const_reference operator[](size_type n) const { return m_c[n]; }

private:
    C       m_c;
};

/// vf̏dȂϒz
template<class T> class unique_vector : public unique_array<vector<T> > {};

}
