#include "stdafx.h"
#include "ConfigEx.h"
#include <Themis/Spi.h>
#include <Themis/Utility/StringUtility.h>

void ConfigInitialize(CConfig& m_oConfig, const CFileName& oFileName) {
    // ftHgl̐ݒ
    m_oConfig.Num(L"ArchiverPriorityZL", 0);
    m_oConfig.Num(L"ArchiverPriorityS", 4);
    m_oConfig.Num(L"ArchiverPriorityZ", 8);
    m_oConfig.Num(L"ArchiverPriorityR", 12);
    m_oConfig.Num(L"ArchiverPriorityG", 14);
    m_oConfig.Num(L"ArchiverPriorityL", 16);
    m_oConfig.Num(L"ArchiverPriority7Z", 20);
    m_oConfig.Num(L"ArchiverPriorityX", 24);
    m_oConfig.Bool(L"ArcPassMask", true);
    m_oConfig.Str(L"ArcPassAutoTry", string());

    m_oConfig.Bool(L"SaveNameUseArchive", false);
    m_oConfig.Bool(L"SaveNameUseArchiveDir", false);
    m_oConfig.Str(L"SaveNameSeparator", L" - ");

    m_oConfig.File(L"BookmarkDir", L".\\bookmark\\");
    m_oConfig.File(L"CurrentDir", string());
    m_oConfig.Str(L"ChooseColor", string());
    m_oConfig.Bool(L"CDOnDrop", true);
    m_oConfig.Bool(L"ClearType", false);
    m_oConfig.Bool(L"AutoCursorHide", true);
    m_oConfig.Num(L"AutoCursorHideTime", 2000);
    m_oConfig.Bool(L"DrawStickOut", false);
    m_oConfig.Num(L"DrawStretchType", 0); // k\, kEg, ...
    m_oConfig.Float(L"DrawStretchRate", 1.0);
    m_oConfig.Num(L"DrawMode_", 3);
    m_oConfig.Color(L"DrawBgColor", RGB(0x00, 0x00, 0x00));
    m_oConfig.Bool(L"DeleteByShell", true);
    m_oConfig.Bool(L"StretchCaching", true);
    m_oConfig.Bool(L"LoaderCaching", true);
    m_oConfig.Str(L"EnvSetOthers", string());
    m_oConfig.Str(L"EnvRClickOthers", string());
    m_oConfig.Indirect(L"EnvDesc", L"т C[W");
    m_oConfig.Indirect(L"EnvDescGvb", L"т ubN}[N");
    m_oConfig.Indirect(L"EnvMenuName", L"тŊJ(&2)");
    m_oConfig.File(L"ExViewer0File", L"rundll32");
    m_oConfig.Indirect(L"ExViewer0Arg", L"shimgvw,ImageView_Fullscreen $(dir)\\$(file).$(ext)");
    m_oConfig.Indirect(L"ExViewer0Dir", L"$(dir)");
    m_oConfig.File(L"ExViewer1File", L"%ProgramFiles%\\Internet Explorer\\IEXPLORE.EXE");
    m_oConfig.Indirect(L"ExViewer1Arg", L"\"$(dir)\\$(file).$(ext)\"");
    m_oConfig.Indirect(L"ExViewer1Dir", L"$(dir)");
    m_oConfig.File(L"ExViewer2File", L"explorer");
    m_oConfig.Indirect(L"ExViewer2Arg", L"/select,$(dir)\\$(file).$(ext)");
    m_oConfig.Indirect(L"ExViewer2Dir", L"$(dir)");
    m_oConfig.Bool(L"FileAddMode", true);
    m_oConfig.Bool(L"FileAddFollowLnk", false);
    m_oConfig.Bool(L"FileAddWithSave", false);
    m_oConfig.Bool(L"FileAddWithSaveNext", true);
    m_oConfig.Size(L"FullScreen", CSize(800, 600));
    m_oConfig.Num(L"FullScreenBpp", 32);
    m_oConfig.Bool(L"FullScreenCursorHide", false);
    m_oConfig.Bool(L"FullScreenMinOnDeactive", true);
    m_oConfig.Bool(L"HttpBackup", true);
    m_oConfig.Num(L"HttpBackupCount", 4);
    m_oConfig.Bool(L"HttpProxy", false);
    m_oConfig.Str(L"HttpProxyServer", L"example.com:80");
    m_oConfig.Str(L"HttpUpdate", string());
    m_oConfig.Num(L"HttpOldNotice", 0);
/*
    m_oConfig.Bool(L"HttpAutoCheck", true);
    m_oConfig.Num(L"HttpAutoCheckLastTime", 0);
    m_oConfig.Num(L"HttpAutoCheckInterval", 60 * 60);  //PԒu
    m_oConfig.Str(L"HttpAutoCheckModified", string());
*/
    m_oConfig.File(L"HistoryDir", L".\\history\\");
    m_oConfig.Num(L"HistoryMax", 10);
    m_oConfig.Bool(L"ImageCache", true);
    m_oConfig.Num(L"ImageCacheAutoMax", 6);
    m_oConfig.Num(L"ImageCacheAutoLimitRate", 70);
    m_oConfig.Num(L"ImageCacheAutoBaseW", 1024);
    m_oConfig.Num(L"ImageCacheAutoBaseH", 1536);
    m_oConfig.Bool(L"ImageSizeLimit", false);
    m_oConfig.Float(L"ImageSizeLimitPixel.cx", 200.1f);
    m_oConfig.Float(L"ImageSizeLimitPixel.cy", 50.1f);
    m_oConfig.Bool(L"ImageSizeLimitCmpArea", false);

    m_oConfig.Bool(L"ReduceOnLoad", true);
    m_oConfig.Size(L"ReduceOnLoadSize", CSize(3200, 2400));
    m_oConfig.Bool(L"ReduceOnLoadBySpace", true);

    m_oConfig.Bool(L"Padding", false);
    m_oConfig.Num(L"PaddingV", 32);
    m_oConfig.Num(L"PaddingH", 32);
    m_oConfig.Rect(L"FileListWindowRect", CRect(160, 240, 320, 320));
    m_oConfig.Bool(L"FileSizeLimit", false);
    m_oConfig.Float(L"FileSizeLimitMin", 0);
    m_oConfig.Float(L"FileSizeLimitMax", 16*1024);
    m_oConfig.Num(L"ImageSpreadView_", 1);
    m_oConfig.Num(L"JpgQuality", 80);
    m_oConfig.Num(L"PngCompressLevel", -1);

    m_oConfig.Bool(L"IgnoreBySuffix", true);
    m_oConfig.Str(L"IgnoreExcludeSuffixes", string());
    m_oConfig.Str(L"IgnoreSuffixes", string());

    m_oConfig.Num(L"PaddingCenter", 0);
    m_oConfig.Bool(L"NextOnCancelSpread", false);

    m_oConfig.Num(L"FilterGray", 0);
    m_oConfig.Bool(L"Filter", true);
    m_oConfig.Bool(L"FilterMark", true);
    m_oConfig.Num(L"FilterRot1", 0);
    m_oConfig.Num(L"FilterRot2", 0);
    m_oConfig.Bool(L"FilterNeg", false);
    m_oConfig.Bool(L"FilterMedian", false);
    m_oConfig.Bool(L"FilterBC", false);
    m_oConfig.Num(L"FilterBCBright", 0);
    m_oConfig.Num(L"FilterBCContrast", 0);
    m_oConfig.Bool(L"FilterLevelRev", false);
    m_oConfig.Num(L"FilterLevelRevLow", 64);
    m_oConfig.Num(L"FilterLevelRevHigh", 255 - 64);
    m_oConfig.Bool(L"LevelRevOpaque", false);
    m_oConfig.Bool(L"LevelRevReflect", false);
    m_oConfig.Bool(L"FilterGammaRev", false);
    m_oConfig.Num(L"FilterGammaRevValue", 0);
    m_oConfig.Num(L"FilterSharp", 0);
    m_oConfig.Bool(L"FilterGauss", false);
    m_oConfig.Num(L"FilterGaussValue", 150);
    m_oConfig.Bool(L"FilterUnsharp", false);
    m_oConfig.Num(L"FilterUnsharpValue", 150);
    m_oConfig.Bool(L"FilterAlpha", false);
    m_oConfig.Color(L"FilterAlphaBg", RGB(0x00, 0x00, 0x00));
    m_oConfig.Bool(L"FilterAlphaCheck", true);

    m_oConfig.Bool(L"GammaRevOpaque", false);
    m_oConfig.Bool(L"GammaRevReflect", false);
    m_oConfig.Bool(L"GaussReflect", false);
    m_oConfig.Bool(L"UnsharpReflect", false);
    m_oConfig.Num(L"LoaderPriorityJ", 0);
    m_oConfig.Num(L"LoaderPriorityP", 4);
    m_oConfig.Num(L"LoaderPriorityB", 8);
    m_oConfig.Num(L"LoaderPriorityS", 12);
    m_oConfig.Num(L"LoaderPriorityA", 16);
    m_oConfig.Num(L"LoaderPriorityX", 20);
    m_oConfig.Num(L"LoaderPriorityO", 24);
    m_oConfig.Size(L"Magnifier", CSize(400, 300));
    m_oConfig.Num(L"Magnification", 200);
    m_oConfig.Num(L"MagnifierShape", 0); // `
    m_oConfig.Num(L"MosaicLevel", 8);
    m_oConfig.Num(L"MosaicType", 0);
    m_oConfig.Bool(L"QuestionRemoveFile", true);
    m_oConfig.Bool(L"RemoveOnMove", false);
    m_oConfig.Bool(L"StretchKeepRate", true);
    m_oConfig.Num(L"SlideShowFreq", 2000);
    m_oConfig.Num(L"SlideShowDist", 0); // 
    m_oConfig.Bool(L"SlideShowStopWithLast", true);
    m_oConfig.Bool(L"SlideShowStopWithCommand", true);
    m_oConfig.Num(L"SortMode", 6); // l
    m_oConfig.File(L"SpiPluginsDir", CSpi::GetInstallDir());
    if (string::IsNullOrEmpty(m_oConfig.File(L"SpiPluginsDir"))) {
        m_oConfig.File(L"SpiPluginsDir", L".\\spi\\");
    }
    m_oConfig.Indirect(L"Titlebar", L"т : $(dir)$(file)$(ext) ($(imgw)x$(imgh)) [$(index)/$(count)] $(build)");
    m_oConfig.File(L"TmpDir", L".\\temp\\");
    m_oConfig.File(L"WallpaperDir", L"%windir%\\Web\\Wallpaper\\");
    m_oConfig.Bool(L"WallpaperUnifyFile",  true);
    m_oConfig.Bool(L"WallpaperResize",  false);
    m_oConfig.File(L"WallpaperUnifyFileName", L"т.bmp");
    m_oConfig.Bool(L"WindowTopMost", false);
    m_oConfig.Bool(L"WindowPosRestore", false);
    m_oConfig.Bool(L"WindowPosRestoreDisableOnLoad", false);
    m_oConfig.Rect(L"WindowPosRestoreRect", CRect(320, 240, 640, 320)); // ĂƁ[
    m_oConfig.Bool(L"Snap", false);
    m_oConfig.Bool(L"LinkFirstAndLast", true);

    m_oConfig.Bool(L"OpenTopDirOnly", false); // GUIݒ

    // t@Cǂݍ
    m_oConfig.Load(oFileName);

    // ڂ̕ύX
    if (!m_oConfig.Exists(L"LoaderPriorityT")) {
        m_oConfig.Num(L"LoaderPriorityT", m_oConfig.Num(L"LoaderPriorityA") + 2);
    }
    m_oConfig.ChanegName(L"FullScreenWidth", L"FullScreen.cx");
    if (m_oConfig.Exists(L"FullScreen.cx")) {
        m_oConfig.ChanegName(L"FullScreenHeight", L"FullScreen.cy");
        m_oConfig.Size(L"FullScreen", CSize(m_oConfig.Num(L"FullScreen.cx"), m_oConfig.Num(L"FullScreen.cy")));
    }
    if (m_oConfig.Exists(L"ImageSizeLimitPixel")) {
        CSize sz = m_oConfig.Size(L"ImageSizeLimitPixel");
        m_oConfig.Float(L"ImageSizeLimitPixel.cx", float(sz.cx));
        m_oConfig.Float(L"ImageSizeLimitPixel.cy", float(sz.cy));
    }
    m_oConfig.ChanegName(L"MagnifierWidth", L"Magnifier.cx");
    if (m_oConfig.Exists(L"Magnifier.cx")) {
        m_oConfig.ChanegName(L"MagnifierHeight", L"Magnifier.cy");
        m_oConfig.Size(L"Magnifier", CSize(m_oConfig.Num(L"Magnifier.cx"), m_oConfig.Num(L"Magnifier.cy")));
    }
    if (m_oConfig.Exists(L"ImageSpreadView")) {
        m_oConfig.Num(L"ImageSpreadView_", m_oConfig.Bool(L"ImageSpreadView")? 1: 0);
    }
    if (m_oConfig.Exists(L"DrawMode")) {
        int n = m_oConfig.Num(L"DrawMode");
        m_oConfig.Num(L"DrawMode_", n <= 2? n + 2: n - 2);
    }
    m_oConfig.ChanegName(L"Cleartype", L"ClearType");
    m_oConfig.ChanegName(L"CursorHide", L"FullScreenCursorHide");
    m_oConfig.ChanegName(L"TmpDirCustomName", L"TmpDir");
    m_oConfig.ChanegName(L"GrayFilter", L"FilterGray");
    m_oConfig.ChanegName(L"LevelRevAuto", L"FilterLevelRev");
    m_oConfig.ChanegName(L"LevelRevAutoLow", L"FilterLevelRevLow");
    m_oConfig.ChanegName(L"LevelRevAutoHigh", L"FilterLevelRevHigh");
    m_oConfig.ChanegName(L"GammaRevAuto", L"FilterGammaRev");
    m_oConfig.ChanegName(L"GammaRevAutoValue", L"FilterGammaRevValue");
    m_oConfig.ChanegName(L"SharpFilter", L"FilterSharp");

    if (m_oConfig.Exists(L"DrawMagnification") && 
        m_oConfig.Exists(L"DrawReduction")) {
        bool br = m_oConfig.Bool(L"DrawReduction");
        bool bm = m_oConfig.Bool(L"DrawMagnification");
        if (br && bm) {
            m_oConfig.Num(L"DrawStretchType", 1); // kEg
        } else if (br && !bm) {
            m_oConfig.Num(L"DrawStretchType", 0); // k
        } else if (!br && bm) {
            m_oConfig.Num(L"DrawStretchType", 2); // ĝ
        } else if (!br && !bm) {
            m_oConfig.Num(L"DrawStretchType", 3); // 
        }
    }
}

static string ExViewerArgReplace(const string& str) {
    vector<pair<string, string> > vct;
    vct.push_back(make_pair(L"$(dir)\\$(file).$(ext)", L"$(full)"));
    vct.push_back(make_pair(L"$(file).$(ext)", L"$(name)"));
    return Replace(str, vct);
}

static string TitlebarReplace(const string& str) {
    vector<pair<string, string> > vct;
    vct.push_back(make_pair(L"$(dir)$(file)$(ext)", L"$(full)"));
    vct.push_back(make_pair(L"$(file)$(ext)", L"$(name)"));
    return Replace(str, vct);
}

void ConfigDelayInitialize(CConfig& m_oConfig, const CFileName& oFileName) {
    if (m_oConfig.Str(L"HttpProxyServer") == L".proxy.jp:80") {
        m_oConfig.Str(L"HttpProxyServer", L"example.com:80");
    }
    m_oConfig.Indirect(L"ExViewer0Arg", ExViewerArgReplace(m_oConfig.Indirect(L"ExViewer0Arg")));
    m_oConfig.Indirect(L"ExViewer1Arg", ExViewerArgReplace(m_oConfig.Indirect(L"ExViewer1Arg")));
    m_oConfig.Indirect(L"ExViewer2Arg", ExViewerArgReplace(m_oConfig.Indirect(L"ExViewer2Arg")));
    m_oConfig.Indirect(L"Titlebar", TitlebarReplace(m_oConfig.Indirect(L"Titlebar")));
    m_oConfig.Delete(L"FullScreen.cx");
    m_oConfig.Delete(L"FullScreen.cy");
    m_oConfig.Delete(L"ImageSizeLimitPixel");
    m_oConfig.Delete(L"Magnifier.cx");
    m_oConfig.Delete(L"Magnifier.cy");
    m_oConfig.Delete(L"ImageSpreadView");
    m_oConfig.Delete(L"DrawMode");
    m_oConfig.Delete(L"CustomKey");
    m_oConfig.Delete(L"TmpDirCustom");
    m_oConfig.Delete(L"Bookmark0");
    m_oConfig.Delete(L"Bookmark1");
    m_oConfig.Delete(L"Bookmark2");
    m_oConfig.Delete(L"Bookmark3");
    m_oConfig.Delete(L"Bookmark4");
    m_oConfig.Delete(L"Bookmark5");
    m_oConfig.Delete(L"Bookmark6");
    m_oConfig.Delete(L"Bookmark7");
    m_oConfig.Delete(L"Bookmark8");
    m_oConfig.Delete(L"Bookmark9");
    m_oConfig.Delete(L"EnvSCStart");
    m_oConfig.Delete(L"EnvSCStartAll");
    m_oConfig.Delete(L"EnvSCSendAll");
    m_oConfig.Delete(L"EnvResetting");
    m_oConfig.Delete(L"UseOleLoadPicture");
    m_oConfig.Delete(L"LoadGifOwn");
    m_oConfig.Delete(L"ArchiverPriorityZ2");
    m_oConfig.Delete(L"MaximizeByDoubleClick");
    m_oConfig.Delete(L"EnvSet");
    m_oConfig.Delete(L"EnvSetJpg");
    m_oConfig.Delete(L"EnvSetPng");
    m_oConfig.Delete(L"EnvSetBmp");
    m_oConfig.Delete(L"EnvSetArgb");
    m_oConfig.Delete(L"EnvSetGvb");
    m_oConfig.Delete(L"EnvRClickZip");
    m_oConfig.Delete(L"EnvRClickRar");
    m_oConfig.Delete(L"EnvRClickLzh");
    m_oConfig.Delete(L"EnvRClickDir");
    m_oConfig.Delete(L"EnvSCSend");
    m_oConfig.Delete(L"HttpLastModified");
    m_oConfig.Delete(L"ExtractMinimum");
    m_oConfig.Delete(L"ImageCacheCount");
    m_oConfig.Delete(L"ImageCacheAuto");
    m_oConfig.Delete(L"DrawMagnification");
    m_oConfig.Delete(L"DrawReduction");
    m_oConfig.Delete(L"ResizeOnLoad");

    // o
    m_oConfig.Save(oFileName);
}

