#include "stdafx.h"
#include "Document.h"
#include "DocView.h"
#include <Themis/Layout.h>
#include <Themis/Image.h>
#include <Themis/Config.h>
#include <Themis/Display.h>
#include <Themis/File.h>
#include <Themis/TimeChecker.h>
#include <Themis/TempFile.h>
#include <Themis/LocalExclusion.h>
#include <Themis/Windows/System.h>
#include <Themis/Utility/BoostUtility.h>
#include <math.h>

// fobOɎOg킸GDI1gȂP
#define GV_DEBUG_GDISTRETCH 0

inline int CDocument::GetDrawMode() {
#if !defined(NDEBUG) && GV_DEBUG_GDISTRETCH
    return 0;
#else
    if (m_bBackup) {
        return 0; // obNAbvgĂꍇGDI̍ō̃cB
    }
    return m_oConfig.Num(L"DrawMode_");
#endif
}

CDocument::CDocument(IDocView& v, IQueryArchivePassword& q, HWND hwndOwner, CConfig& r)
: m_rView(v), m_rQueryPass(q), m_oConfig(r), m_bBackup(false), m_historyMaxOld(-1), pageChanged(false) {
    m_pFileList.reset(new CFileList(ArchiveOwner(this, hwndOwner)));
 // m_pLayout.reset(new SimpleLayout()); // ʂۂȂׂ̃_~[(L`)

    localExclusion.reset(new CLocalExclusion());
    threadedImageLoader.reset(new ThreadedImageLoader(shared_ptr_fake<ThreadedImageLoader::IOwner>(this)));

    CFontStyle fs;
    fs.SetFace(L"lr SVbN");
    fs.SetHeight(16);
    fs.SetColor(RGB(0xff, 0x55, 0x88));
    fs.SetWeight(CFontStyle::eWeightBold);
    fs.SetShadowType(2);
    fs.SetShadowColor(RGB(0, 0, 0));
    fs.SetShadowGap(1);
    fs.SetBg(false);
    fs.SetAntiAlias(false);
    m_pFont.reset(new CFont(fs));

    m_pImageFilter.reset(new CImageFilter(r));

    m_nStartMemorySize = 0;

    /// RtBO̓ǂݍ
    OnChangeConfig(false);
}

CDocument::~CDocument() {
    Clear();
    // ǂ݃XbhoO肻Ȃ̂ŐɎ~߂ĂB
    Dispose();
    threadedImageLoader.reset();
    // DLLȊ҂ƂȂƃe|fBNgcH
    CArchiverDll::GetUnZip().WaitForEndRunning();
    CArchiverDll::GetUnRar().WaitForEndRunning();
    CArchiverDll::Get7Zip().WaitForEndRunning();
    CArchiverDll::GetUnGca().WaitForEndRunning();
    CArchiverDll::GetUnLha().WaitForEndRunning();
}

//////////////////////////////////////////////////////////////////////

uint64_t CDocument::GetNowFreeMemory() {
    uint64_t freeMemory = CSystem::GetPhysicalMemorySize().first;
    size_t nMemorySize = CSystem::GetProcessMemoryInfo().nWorkingSetSize;
    if (m_nStartMemorySize == 0) { // NۂȊB
        m_nStartMemorySize = nMemorySize;
    }
    freeMemory = freeMemory + (nMemorySize - m_nStartMemorySize); // LbVɎgpۂ͋󂫃ɂ
    Themis_DebugOutput(string::Format(L"m_nStartMemorySize F%dMB", int(m_nStartMemorySize / 1024 / 1024)));
    Themis_DebugOutput(string::Format(L"nMemorySize        F%dMB", int(nMemorySize / 1024 / 1024)));
    Themis_DebugOutput(string::Format(L"freeMemory         F%dMB", int(freeMemory / 1024 / 1024)));
    return freeMemory;
}

void CDocument::OnChangeConfig(bool update) {
    m_pFileList->SetTempDir(CFileName(L"$т$/", CFileNameModuleDir(
        CFileName::AddDirSeparator(m_oConfig.File(L"TmpDir")))));
    m_pFileList->SetSortMode(m_oConfig.Num(L"SortMode"));

    bool useStretchCache = m_oConfig.Bool(L"StretchCaching");
    if (GetDrawMode() <= 1) {
        useStretchCache = false; // GDIȂStretchCacingB
    }
    bool useLoaderCache = m_oConfig.Bool(L"LoaderCaching");
    int nCache;
    if (m_oConfig.Bool(L"ImageCache")) {
        int img = m_oConfig.Num(L"ImageCacheAutoBaseW") * m_oConfig.Num(L"ImageCacheAutoBaseH") * 4;
        if (m_oConfig.Num(L"ImageSpreadView_") != 0) {
            img *= 2; // J\ONȂ{ɂƂB
            img += Max(m_oConfig.Num(L"PaddingCenter"), 0)
                * m_oConfig.Num(L"ImageCacheAutoBaseH") * 4; // PaddingꉞǉB
        }
        img += img / 8; // FX덷̂Ŗ1.125{Ƃ(L`)
        // 󂫃̎擾
        uint64_t freeMemory = GetNowFreeMemory();
        // LbV̎Zo
        nCache = static_cast<int>(freeMemory / img);
        nCache -= 2; // \ŎgƂAƎĝœKɍƂ
        int cacheAutoMax = m_oConfig.Num(L"ImageCacheAutoMax"); // ݒ莞ő喇
        if (useStretchCache) {
            if (cacheAutoMax * 2 <= nCache) { // {ȏgƂ̂ݗLƂB
                nCache -= cacheAutoMax; // Ƃ
            } else {
                useStretchCache = false;
            }
        }
        if (useLoaderCache) {
            if (cacheAutoMax * 2 <= nCache) { // {ȏgƂ̂ݗLƂB
                nCache -= cacheAutoMax; // ꉞƂ
            } else {
                useLoaderCache = false; 
            }
        }
        nCache = Min(nCache, cacheAutoMax);
    } else {
        nCache = 1;
        useStretchCache = false;
    }
    this->useStretchCache = useStretchCache;
    SetCacheCount(nCache, nCache / 2);
        // 1  0AO0
        // 2  0AO1
        // 3  1AO1
        // 4  1AO2
        // 5  2AO2
        // 6  2AO3
        // 7  3AO3
        // 8  3AO4
    threadedImageLoader->SetCacheCount(!useLoaderCache ? 0 :
        m_oConfig.Num(L"ImageSpreadView_") != 0 ? nCache * 5 : nCache * 3);

    int stretchType = m_oConfig.Num(L"DrawStretchType");
    if (stretchType <= 3) {
        std::tr1::shared_ptr<AutoStretchingLayout> p(new AutoStretchingLayout());
        switch (stretchType) {
        default:
        case 0: // k
            p->SetReduction(true);
            p->SetMagnification(false);
            break;
        case 1: // kEg
            p->SetReduction(true);
            p->SetMagnification(true);
            break;
        case 2: // g\
            p->SetReduction(false);
            p->SetMagnification(true);
            break;
        case 3: // \
            p->SetReduction(false);
            p->SetMagnification(false);
            break;
        }
        p->SetStickOut(m_oConfig.Bool(L"DrawStickOut"));
        m_pLayout = p;
    } else {
        Themis_DebugAssert(stretchType == 4);
        std::tr1::shared_ptr<FixedStretchingLayout> p(new FixedStretchingLayout());
        p->SetRate(m_oConfig.Float(L"DrawStretchRate"));
        m_pLayout = p;
    }
    if (IsReadyImage()) {
        m_pLayout->SetDocument(CRect(GetCurrentImage()->GetSize()));
    }
    InnerSetScreen(m_szScreen);

    // ŔwiFςĂPaddingCenterO傫Ȃh蒼Kv̂Aʓ|Ȃ̂ŖB(L`)
    m_rgbBgColor = m_oConfig.Color(L"DrawBgColor");

    m_vctArcPass = m_oConfig.Str(L"ArcPassAutoTry").Split(Array<string>(L"\n"));

    if (m_historyMaxOld < 0) {
        m_historyMaxOld = m_oConfig.Num(L"HistoryMax");
    } else if (m_historyMaxOld != m_oConfig.Num(L"HistoryMax")) {
        CFileNameModuleDir historyDir(m_oConfig.File(L"HistoryDir"));
        int max = m_oConfig.Num(L"HistoryMax");
        if (max < m_historyMaxOld) { // ꍇAgȂȂ폜B
            for (int i = 0, n = m_historyMaxOld - max; i < n; i++) {
                CFile file(CFileName(string::Format(L"%02d.gvb", i + max), historyDir));
                if (file.Exists()) {
                    file.Delete();
                }
            }
        }
        m_historyMaxOld = max;
    }

    // \̍XV
    if (update) {
     // ReloadAllPage();
        UpdateImage();
    }
}

void CDocument::SetScreen(const CSize& szScreen) {
    if (InnerSetScreen(szScreen)) {
        UpdateImage();
        // kLbVĂȂLbV̓[hĂ݂B
        if (useStretchCache) {
            ReloadCachePage();
        }
    }
}
bool CDocument::InnerSetScreen(const CSize& szScreen) {
    m_szScreen = szScreen;
    CRect screenNew = m_szScreen.ToRect();
    if (m_oConfig.Bool(L"Padding")) { // ]
        int paddingH = m_oConfig.Num(L"PaddingH");
        int paddingV = m_oConfig.Num(L"PaddingV");
        screenNew.left += paddingH;
        screenNew.top += paddingV;
        screenNew.right -= paddingH;
        screenNew.bottom -= paddingV;
    }
    if (m_pLayout->GetScreen() != screenNew) { // TCY]ςĂXV
        CPoint scrollPos = m_pLayout->GetScrollPos();
        m_pLayout->SetScreen(screenNew);
        m_pLayout->SetScrollPos(scrollPos);
        return true;
    }
    return false;
}

/// XN[ʒũZbg
void CDocument::SetScrollPos(const CPoint& pt) {
    m_pLayout->SetScrollPos(pt);
    UpdateImage();
}

//////////////////////////////////////////////////////////////////////

void CDocument::Clear() {
    {
        boost::recursive_mutex::scoped_lock lock(mutex);
        // ̕ۑ
     // if (0 < m_pFileList->GetCount()) {
        if (IsReady()) {
            int max = m_oConfig.Num(L"HistoryMax");
            if (0 < max) {
                CFileNameModuleDir historyDir(m_oConfig.File(L"HistoryDir"));
                CFileName oSaveFileName(L"00.gvb", historyDir);
                if (CFile(oSaveFileName).Exists()) {
                    // 00.gvb݂ȂPl[ĂB
                    {
                        CFile oFile(CFileName(string::Format(L"%02d.gvb", max - 1), historyDir));
                        if (oFile.Exists()) {
                            oFile.Delete();
                        }
                    }
                    for (int i = max - 2; 0 <= i; i--) {
                        CFile oFile(CFileName(string::Format(L"%02d.gvb", i), historyDir));
                        if (oFile.Exists()) {
                            oFile.Move(CFileName(string::Format(L"%02d.gvb", i + 1), historyDir));
                        }
                    }
                }
                SaveBookmark(oSaveFileName, false);
            }
        }
        // 肠[
        m_pFileList->Clear();
        m_pFileList->SetCurrentIndex(-1);
    }

    bookmarkFileName = string();

    GetCurrentImage()->SetSize(CSize());
    threadedImageLoader->Clear();
    m_pLayout->SetDocument(CRect());
    ReloadAllPage();
    UpdateImage();

    //m_pFileList->Garbage(); // t@CXgɎgĂB
}

void CDocument::Open(const CFileName& oFileName, MsgDialog* msgDialog) {
    if (oFileName.GetSuffixLc() == L"gvb") {
        LoadBookmark(oFileName);
        return;
    }
    {
        boost::recursive_mutex::scoped_lock lock(mutex);
        CFileList::AddConfig config;
        config.followLnk = m_oConfig.Bool(L"FileAddFollowLnk");
        config.ignoreBySuffix = m_oConfig.Bool(L"IgnoreBySuffix");
        config.includeSuffixes = m_oConfig.Str(L"IgnoreExcludeSuffixes").Split(Array(L';'));
        config.excludeSuffixes = m_oConfig.Str(L"IgnoreSuffixes").Split(Array(L';'));
        config.openTopDirOnly = m_oConfig.Bool(L"OpenTopDirOnly");
        m_pFileList->Add(oFileName, config, msgDialog);
    }
    ReloadAllPage();
    UpdateImage();
}

void CDocument::Open(const vector<CFileName>& vct, MsgDialog* msgDialog) {
    if (vct.size() == 1) {
        Open(vct[0], msgDialog);
        return;
    }
    {
        boost::recursive_mutex::scoped_lock lock(mutex);
        CFileList::AddConfig config;
        config.followLnk = m_oConfig.Bool(L"FileAddFollowLnk");
        config.ignoreBySuffix = m_oConfig.Bool(L"IgnoreBySuffix");
        config.includeSuffixes = m_oConfig.Str(L"IgnoreExcludeSuffixes").Split(Array(L';'));
        config.excludeSuffixes = m_oConfig.Str(L"IgnoreSuffixes").Split(Array(L';'));
        config.openTopDirOnly = m_oConfig.Bool(L"OpenTopDirOnly");
        m_pFileList->Add(vct, config, msgDialog);
    }
    ReloadAllPage();
    UpdateImage();
}

/// ݂̃t@C폜
void CDocument::Delete(HWND hwndParent) {
    {
        boost::recursive_mutex::scoped_lock lock(mutex);
        if (!m_pFileList->IsValidIndex()) return;
        m_pFileList->Delete(m_oConfig.Bool(L"DeleteByShell"), hwndParent);
    }
    ReloadAllPage();
    UpdateImage();
}

/// ݂̃t@C𖼏̕ύX
void CDocument::Rename(const CFileName& oFileName) {
    {
        boost::recursive_mutex::scoped_lock lock(mutex);
        if (!m_pFileList->IsValidIndex()) return;
        m_pFileList->Rename(oFileName, m_oConfig.Bool(L"RemoveOnMove"));
    }
    ReloadAllPage();
    UpdateImage();
}

/// ݂̃t@C𕡐
void CDocument::Copy(const CFileName& oFileName) {
    if (m_pFileList->IsValidIndex()) {
        m_pFileList->Copy(oFileName);
    }
}

//////////////////////////////////////////////////////////////////////

/// LbVjēǂݒ
void CDocument::Reload(bool clearFailed) {
    // t@CXgԂȂ摜NAB
    if (!m_pFileList->IsValidIndex()) {
        GetCurrentImage()->SetSize(CSize());
    }
    // sƂYꂳB
    if (clearFailed) {
        m_pFileList->ClearFailed();
    }
    // ēǍ
    threadedImageLoader->Clear();
    ReloadAllPage();
    UpdateImage();
}

void CDocument::MirrorH() {
    if (IsReadyImage()) {
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane(GetCurrentImage()->GetSize());
        pTempDib.swap(GetCurrentImage());
        GetCurrentImage()->MirrorHBlt(*pTempDib, CPoint(), pTempDib->GetSize().ToRect());
        ClearCurrentStretchCache();
        UpdateImage();
    }
}

void CDocument::MirrorV() {
    if (IsReadyImage()) {
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane(GetCurrentImage()->GetSize());
        pTempDib.swap(GetCurrentImage());
        GetCurrentImage()->MirrorVBlt(*pTempDib, CPoint(), pTempDib->GetSize().ToRect());
        ClearCurrentStretchCache();
        UpdateImage();
    }
}

void CDocument::Rot90() {
    if (IsReadyImage()) {
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane();
        pTempDib.swap(GetCurrentImage());
        GetCurrentImage()->SetSize(CPlaneEx::GetRot90Size(pTempDib->GetSize()));
        GetCurrentImage()->Rot90ClockwiseBlt(*pTempDib, CPoint(), pTempDib->GetSize().ToRect());
        ClearCurrentStretchCache();
        CurrentPageChanged();
        UpdateImage();
    }
}

void CDocument::Rot90A() {
    if (IsReadyImage()) {
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane();
        pTempDib.swap(GetCurrentImage());
        GetCurrentImage()->SetSize(CPlaneEx::GetRot90Size(pTempDib->GetSize()));
        GetCurrentImage()->Rot90AntiClockwiseBlt(*pTempDib, CPoint(), pTempDib->GetSize().ToRect());
        ClearCurrentStretchCache();
        CurrentPageChanged();
        UpdateImage();
    }
}

void CDocument::Rot180() {
    if (IsReadyImage()) {
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane(GetCurrentImage()->GetSize());
        pTempDib.swap(GetCurrentImage());
        GetCurrentImage()->Rot180Blt(*pTempDib, CPoint(), pTempDib->GetSize().ToRect());
        ClearCurrentStretchCache();
        UpdateImage();
    }
}

void CDocument::Rot(double dAngle) {
    if (IsReadyImage()) {
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane();
        pTempDib.swap(GetCurrentImage());
        GetCurrentImage()->SetSize(CPlaneEx::GetRotSize(pTempDib->GetSize(), dAngle));
        GetCurrentImage()->RotBlt(*pTempDib, CPoint(), pTempDib->GetSize().ToRect(), dAngle, RGB(0,0,0));
        ClearCurrentStretchCache();
        CurrentPageChanged();
        UpdateImage();
    }
}

void CDocument::RotDraft(double dAngle) {
    if (IsReadyImage()) {
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane();
        pTempDib.swap(GetCurrentImage());
        GetCurrentImage()->SetSize(CPlaneEx::GetRotSize(pTempDib->GetSize(), dAngle));
        GetCurrentImage()->RotBltDraft(*pTempDib, CPoint(), pTempDib->GetSize().ToRect(), dAngle, RGB(0,0,0));
        ClearCurrentStretchCache();
        CurrentPageChanged();
        UpdateImage();
    }
}

void CDocument::Stretch(const CSize& sz) {
    if (IsReadyImage()) {
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane(sz);
        pTempDib.swap(GetCurrentImage());
        GetCurrentImage()->StretchBltLanczos3Alpha(*pTempDib, CRect(sz), pTempDib->GetSize().ToRect());
        ClearCurrentStretchCache();
        CurrentPageChanged();
        UpdateImage();
    }
}

void CDocument::Cut(const CRect& rc) {
    Themis_DebugAssert(rc.IsValid());
    CRect rcDst = m_pLayout->GetDst();
    CRect rcSrc = m_pLayout->GetSrc();
    CRect rcSelected = m_pLayout->ScreenToDocument(rc.GetIntersect(rcDst));
    if (rcSelected.GetPoint() != CPoint()) {
        GetCurrentImage()->Blt(*GetCurrentImage(), CPoint(), rcSelected);
    }
    GetCurrentImage()->SetSize(rcSelected.GetSize());
    ClearCurrentStretchCache();
    CurrentPageChanged();
    UpdateImage();
}

void CDocument::CopyToClipboard(const CRect& rc) {
 //*
    CSystem::SetClipboard(CPlane::CGdiLock(*GetCurrentImage()), ClientToImage(rc));
 /*/
    bool bDibWhenHasAlpha = true;
    CRect rc2 = ClientToImage(rc);
    if (!bDibWhenHasAlpha || !HasImageAlpha()) {
        CSystem::SetClipboard(CPlane::CGdiLock(*GetCurrentImage()), rc2);
    } else {
        BITMAPV5HEADER bh = {sizeof(BITMAPV5HEADER)};
        bh.bV5Width = rc2.GetWidth();
        bh.bV5Height = rc2.GetHeight();
        bh.bV5Planes = 1;
        bh.bV5BitCount = 32;
        bh.bV5Compression = BI_RGB;
        bh.bV5XPelsPerMeter = 3780;
        bh.bV5YPelsPerMeter = 3780;
        bh.bV5RedMask = 0x00ff0000;     //
        bh.bV5GreenMask = 0x0000ff00;   //
        bh.bV5BlueMask = 0x000000ff;    // ֌WȂƎvǈꉞ
        bh.bV5AlphaMask = 0xff000000;
        bh.bV5CSType = LCS_WINDOWS_COLOR_SPACE;
        bh.bV5Intent = LCS_GM_IMAGES;
        Themis_PlaneLock4(*GetCurrentImage(), CPoint(rc2.left, rc2.bottom - 1), p, nPitch);
        CSystem::SetClipboard(bh, p, - nPitch);
    }
 //*/
}

void CDocument::Paste() {
    if (!GetCurrentImage()->IsCreated()) {
        GetCurrentImage()->SetSize(CSize(1, 1));
    }
    CSize sz;
    if (CSystem::GetClipboard(CPlane::CGdiLock(*GetCurrentImage()), CPoint(), sz)) {
        if (GetCurrentImage()->GetSize().cx < sz.cx || GetCurrentImage()->GetSize().cy < sz.cy) {
            GetCurrentImage()->SetSize(sz);
            CSystem::GetClipboard(CPlane::CGdiLock(*GetCurrentImage()), CPoint(), sz);
        } else {
            GetCurrentImage()->SetSize(sz);
        }
        ClearCurrentStretchCache();
        CurrentPageChanged();
        UpdateImage();
    }
}

void CDocument::Fill(COLORREF rgb, const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    GetCurrentImage()->Fill(rgb, rc2);
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}

void CDocument::Reverse(const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    GetCurrentImage()->ReverseFill(rc2);
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}

void CDocument::Mosaic(const CRect& rc, int nLevel, int nType) {
    CRect rc2 = ClientToImage(rc);
    switch (nType) {
    case 0: GetCurrentImage()->MosaicFill(rc2, nLevel); break;
    case 1: GetCurrentImage()->MosaicAverageFill(rc2, nLevel); break;
    default: Themis_DebugWarning(L"G[BUCN^Cv"); break;
    }
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}

void CDocument::LevelRev(const CRect& rc, int nLow, int nHigh) {
    CRect rc2 = ClientToImage(rc);
    GetCurrentImage()->LevelRevFill(rc2, nLow, nHigh);
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}

void CDocument::GammaRev(const CRect& rc, double dGamma) {
    CRect rc2 = ClientToImage(rc);
    GetCurrentImage()->GammaRevFill(rc2, dGamma);
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}
void CDocument::BrightContrast(const CRect& rc, int nBright, int nContrast) {
    CRect rc2 = ClientToImage(rc);
    GetCurrentImage()->BrightContrastFill(rc2, nBright, nContrast);
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}
void CDocument::Gray(const CRect& rc, bool bStrict) {
    CRect rc2 = ClientToImage(rc);
    if (bStrict) {
        GetCurrentImage()->GrayFillStrict(rc2);
    } else {
        GetCurrentImage()->GrayFill(rc2);
    }
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}

void CDocument::Befog(const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    CMemoryPlane32 oTempPlane(rc2.GetSize());
    oTempPlane.Blt(*GetCurrentImage(), CPoint(), rc2);
    GetCurrentImage()->BefogBlt(oTempPlane, rc2.GetPoint(), rc2.GetSize().ToRect());
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}
void CDocument::HardBefog(const CRect& rc) { // Befog~Q
    CRect rc2 = ClientToImage(rc);
    CMemoryPlane32 oTempPlane(rc2.GetSize());
    oTempPlane.BefogBlt(*GetCurrentImage(), CPoint(), rc2);
    GetCurrentImage()->BefogBlt(oTempPlane, rc2.GetPoint(), rc2.GetSize().ToRect());
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}

void CDocument::Sharp(const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    CMemoryPlane32 oTempPlane(rc2.GetSize());
    oTempPlane.Blt(*GetCurrentImage(), CPoint(), rc2);
    GetCurrentImage()->SharpBlt(oTempPlane, rc2.GetPoint(), rc2.GetSize().ToRect());
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}
void CDocument::HardSharp(const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    CMemoryPlane32 oTempPlane(rc2.GetSize());
    oTempPlane.Blt(*GetCurrentImage(), CPoint(), rc2);
    GetCurrentImage()->HardSharpBlt(oTempPlane, rc2.GetPoint(), rc2.GetSize().ToRect());
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}
void CDocument::GaussBefog(const CRect& rc, double r) {
    CRect rc2 = ClientToImage(rc);
    CMemoryPlane32 oTempPlane(rc2.GetSize());
    oTempPlane.Blt(*GetCurrentImage(), CPoint(), rc2);
    GetCurrentImage()->GaussBefogBlt(oTempPlane, rc2.GetPoint(), rc2.GetSize().ToRect(), r);
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}
void CDocument::UnsharpMask(const CRect& rc, double r) {
    CRect rc2 = ClientToImage(rc);
    CMemoryPlane32 oTempPlane(rc2.GetSize());
    oTempPlane.GaussBefogBlt(*GetCurrentImage(), CPoint(), rc2, r);
    GetCurrentImage()->UnsharpMaskBlt(*GetCurrentImage(), oTempPlane, rc2.GetPoint(), rc2.GetSize().ToRect(), rc2.GetPoint());
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}
void CDocument::MedianFilter(const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    CMemoryPlane32 oTempPlane(rc2.GetSize());
    oTempPlane.Blt(*GetCurrentImage(), CPoint(), rc2);
    GetCurrentImage()->MedianFilterBlt(oTempPlane, rc2.GetPoint(), rc2.GetSize().ToRect());
    ClearCurrentStretchCache();
    UpdateImage(rc2);
}

void CDocument::Alpha(const CRect& rc, COLORREF rgbBgColor, bool bCheck) {
    if (!bCheck || HasImageAlpha()) {
        CRect rc2 = ClientToImage(rc);
        CMemoryPlane32 oTempPlane(rc2.GetSize());
        oTempPlane.Fill(rgbBgColor);
        oTempPlane.BltAlpha(static_cast<CPlane32&>(*GetCurrentImage()), CPoint(), rc2);
        GetCurrentImage()->Blt(oTempPlane, rc2.GetPoint(), rc2.GetSize().ToRect());
        ClearCurrentStretchCache();
        UpdateImage(rc2);
        // rc摜ŜȂꍇ蓾邪Aʓ|Ȃ̂falseɂĂ܂B
        GetCurrentPage().m_bAlpha = false;
    }
}

void CDocument::SaveJpg(const CFileName& oFileName, const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    CJpgSaver().SetQuality(m_oConfig.Num(L"JpgQuality"))
        .Save(oFileName, *GetCurrentImage(), rc2);
    if (m_oConfig.Bool(L"FileAddWithSave")) {
        m_pFileList->InsertExistFile(oFileName, m_oConfig.Bool(L"FileAddWithSaveNext"));
    }
}
void CDocument::SavePng(const CFileName& oFileName, const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    CPngSaver().SetCompressLevel(m_oConfig.Num(L"PngCompressLevel"))
        .Save(oFileName, *GetCurrentImage(), rc2);
    if (m_oConfig.Bool(L"FileAddWithSave")) {
        m_pFileList->InsertExistFile(oFileName, m_oConfig.Bool(L"FileAddWithSaveNext"));
    }
}
void CDocument::SaveBmp(const CFileName& oFileName, const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    CBmpSaver().Save(oFileName, *GetCurrentImage(), rc2);
    if (m_oConfig.Bool(L"FileAddWithSave")) {
        m_pFileList->InsertExistFile(oFileName, m_oConfig.Bool(L"FileAddWithSaveNext"));
    }
}
void CDocument::SaveArgb(const CFileName& oFileName, const CRect& rc) {
    CRect rc2 = ClientToImage(rc);
    CArgbSaver().Save(oFileName, *GetCurrentImage(), rc2);
    if (m_oConfig.Bool(L"FileAddWithSave")) {
        m_pFileList->InsertExistFile(oFileName, m_oConfig.Bool(L"FileAddWithSaveNext"));
    }
}

void CDocument::SetToWallpaper(const string& strDir, bool bUnifyFile, const string& strUnifyFileName, bool bResize) {
    if (m_pFileList->IsValidIndex()) {
        CFileName oFileName = CFileName(CFileNameModuleDir(strDir).Get() + (bUnifyFile? strUnifyFileName: (CFileName(m_pFileList->GetViewName()).GetPrefix() + L".bmp")));
        if (oFileName != m_pFileList->GetViewName()) {
            // Oꍇ̃TCY̓iV(蔲)
            if (bResize) {
                std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane();
                pTempDib->SetSize(CDisplay::GetCurrentMode().oSize);
                pTempDib->StretchBltLanczos3(*GetCurrentImage(), CRect(CDisplay::GetCurrentMode().oSize),  CRect(GetCurrentImage()->GetSize()));
                CBmpSaver().Save(oFileName, *pTempDib, CDisplay::GetCurrentMode().oSize.ToRect());
            } else {
                CBmpSaver().Save(oFileName, *GetCurrentImage(), GetCurrentImage()->GetSize().ToRect());
            }
        }
        CSystem::SetWallpaper(oFileName.Get());
    }
}

COLORREF CDocument::GetAverageColor(const CRect& rc) const {
    if (!IsReadyImage()) return RGB(0, 0, 0);
    CRect rc2 = ClientToImage(rc);
    return GetCurrentImage()->GetAverageColor(rc2);
}

int CDocument::GetColorCount(const CRect& rc) const {
    if (!IsReadyImage()) return 0;
    CRect rc2 = ClientToImage(rc);
    return GetCurrentImage()->GetColorCount(rc2);
}

string CDocument::GetFileMD5() const {
    if (!IsReady()) return string();
    return m_pFileList->GetFileMD5();
}

//------------------------------------------------------------------//

CRect CDocument::ClientToImage(const CRect& rc) const {
    if (rc.IsValid()) {
        CRect rcDst = m_pLayout->GetDst();
        CRect rcSrc = m_pLayout->GetSrc();
        return m_pLayout->ScreenToDocument(rc.GetIntersect(rcDst));
    } else {
        return CRect(GetCurrentImage()->GetSize());
    }
}

//////////////////////////////////////////////////////////////////////

void CDocument::ToIndirect(int n) {
    if (!IsReady()) return;
    m_pFileList->SetCurrentIndex(n);
    ReloadAllPage();
    UpdateImage();
}
void CDocument::ToLast() {
    if (!IsReady()) return;
    m_pFileList->SetCurrentIndex(0);
    ReloadAllPage();
    //ToPrior();
    ToPriorPage();
    UpdateImage();
}

void CDocument::ToPrior(int nCount, bool update) {
    if (!IsReady()) return;
    if (nCount < 0) {
        int t = m_pFileList->GetCurrentIndex();
        ToPriorPage();
        if (!m_oConfig.Bool(L"LinkFirstAndLast") && t < GetCurrentPage().GetIndex2Safe()) {
            ToNextPage();
        }
    } else {
        int t = m_pFileList->GetCurrentIndex() - nCount;
        if (!m_oConfig.Bool(L"LinkFirstAndLast"))  t = Max(t, 0);
        m_pFileList->SetCurrentIndex(t);
        ReloadAllPage();
    }
    if (update) {
        UpdateImage();
    }
}

void CDocument::ToNext(int nCount, bool update) {
    if (!IsReady()) return;
    if (nCount < 0) {
        int t = m_pFileList->GetCurrentIndex();
        ToNextPage();
        if (!m_oConfig.Bool(L"LinkFirstAndLast") && GetCurrentPage().m_nIndex1 < t) {
            ToPriorPage();
        }
    } else {
        int t = m_pFileList->GetCurrentIndex() + nCount;
        if (!m_oConfig.Bool(L"LinkFirstAndLast"))  t = Min(t, m_pFileList->GetCount() - 1);
        m_pFileList->SetCurrentIndex(t);
        ReloadAllPage();
    }
    if (update) {
        UpdateImage();
    }
}

void CDocument::ToNextDir() {
    if (!IsReady()) return;
    m_pFileList->ToNextDir();
    ReloadAllPage();
    UpdateImage();
}

void CDocument::ToPriorDir() {
    if (!IsReady()) return;
    m_pFileList->ToPriorDir();
    ReloadAllPage();
    UpdateImage();
}

void CDocument::ToPriorMarkFile() {
    if (!IsReady()) return;
    m_pFileList->ToPriorMarkFile();
    ReloadAllPage();
    UpdateImage();
}

void CDocument::ToNextMarkFile() {
    if (!IsReady()) return;
    m_pFileList->ToNextMarkFile();
    ReloadAllPage();
    UpdateImage();
}

void CDocument::ToSortedNext() {
    if (!IsReady()) return;
    m_pFileList->ToSortedNext();
    ReloadAllPage();
    UpdateImage();
}

void CDocument::ToSortedPrior() {
    if (!IsReady()) return;
    m_pFileList->ToSortedPrior();
    ReloadAllPage();
    UpdateImage();
}

void CDocument::Remove() {
    if (!IsReady()) return;
    m_pFileList->Remove();
    ReloadAllPage();
    UpdateImage();
}

void CDocument::Sort(int nSortMode) {
    if (!IsReady()) return;
    m_pFileList->Sort(nSortMode);
    ReloadAllPage(); // ReloadCachePage()łǂA₱ɂȂȂ悤Ô߁c
    UpdateImage(CRect()); // 摜͕ςȂ^Cgo[Ȃǂ̕\͕ς\̂ŁcB
}

void CDocument::Shuffle() {
    if (!IsReady()) return;
    m_pFileList->Shuffle();
    ReloadAllPage(); // ReloadCachePage()łǂA₱ɂȂȂ悤Ô߁c
    UpdateImage(CRect()); // 摜͕ςȂ^Cgo[Ȃǂ̕\͕ς\̂ŁcB
}

void CDocument::ShuffleDir() {
    if (!IsReady()) return;
    m_pFileList->ShuffleDir();
    ReloadAllPage();
    UpdateImage(CRect()); // 摜͕ςȂ^Cgo[Ȃǂ̕\͕ς\̂ŁcB
}

/// ̓ǂݍ݁B
void CDocument::LoadHistory(int n) {
    // ɕ(݂̃Xg΃qXg0ԂƂĕۑāAc+1)
    int max = m_oConfig.Num(L"HistoryMax");
    if (IsReady() && 0 < max) n++; // +1
    Clear();
    // ǂݍރqXg[t@Ce|Ƀl[
    CFileNameModuleDir historyDir(m_oConfig.File(L"HistoryDir"));
    CTempFile tempFile(historyDir, L"", L"gvb");
    tempFile.CreateByMove(CFileName(string::Format(L"%02d.gvb", n), historyDir));
    // ԍl߂ĂB
    for (int i = n + 1; i < max; i++) {
        CFile oFile(CFileName(string::Format(L"%02d.gvb", i), historyDir));
        if (oFile.Exists()) {
            oFile.Move(CFileName(string::Format(L"%02d.gvb", i - 1), historyDir));
        }
    }
    // ǂݍ݁B
    LoadBookmark(tempFile.GetName(), false);
}

void CDocument::SaveBookmark(const CFileName& oFileName, bool rememberFileName) {
    if (rememberFileName) {
        bookmarkFileName = oFileName;
    }
    m_pFileList->SaveBookmark(oFileName);
}

void CDocument::LoadBookmark(const CFileName& oFileName, bool rememberFileName) {
    Clear();
    if (rememberFileName) {
        bookmarkFileName = oFileName;
    }
    m_pFileList->LoadBookmark(oFileName);
    ReloadAllPage();
    UpdateImage();
}

void CDocument::SetMark(bool mark) {
    m_pFileList->SetMark(mark);
    UpdateImage();
}

void CDocument::ReverseAllMarks() {
    m_pFileList->ReverseAllMarks();
    UpdateImage();
}

void CDocument::ReverseFirstToCurrentMarks() {
    m_pFileList->ReverseFirstToCurrentMarks();
    UpdateImage();
}

void CDocument::ClearMarks() {
    m_pFileList->ClearMarks();
    UpdateImage();
}

//------------------------------------------------------------------//

std::tr1::shared_ptr<CPageLoaderBase::IPageData> CDocument::CreatePage() {
    std::tr1::shared_ptr<SPageData> p(new SPageData());
    p->m_pPlane = CreatePagePlane();
    return p;
}

void CDocument::ClearPage(CPageLoaderBase::IPageData& rPage) {
    SPageData& rPageData = static_cast<SPageData&>(rPage);
    if (0 <= rPageData.m_nIndex1 && rPageData.m_nIndex1 < m_pFileList->GetCount()) {
        m_pFileList->SetLoadState(rPageData.m_nIndex1, 0);
    }
    if (0 <= rPageData.m_nIndex2 && rPageData.m_nIndex2 < m_pFileList->GetCount()) {
        m_pFileList->SetLoadState(rPageData.m_nIndex2, 0);
    }
 // rPageData.m_nIndex1 = -1;
 // rPageData.m_nIndex2 = -1;
    // Ô
    rPageData.stretchCache.reset();
}

namespace {
    struct SLoadData : public CPageLoaderBase::ILoadData {
        std::tr1::shared_ptr<CPlaneEx> pPlane;
        std::tr1::shared_ptr<CPlaneEx> stretchCache;
        int nIndex1, nIndex2;
        string strTypeName;
        bool bAlpha;
        bool filtered;
    };
}

// ǂݍݑO
std::tr1::shared_ptr<CPageLoaderBase::ILoadData> CDocument::PrepareLoadPage(CPageLoaderBase::IPageData& rPage) {
    SPageData& rPageData = static_cast<SPageData&>(rPage);
    std::tr1::shared_ptr<SLoadData> p(new SLoadData);

    if (!m_pFileList->IsValidIndex()) {
        return std::tr1::shared_ptr<CPageLoaderBase::ILoadData>(); // ǂݍރt@Cۂ
    }
    if (!rPageData.IsReadyIndex()) {
        return std::tr1::shared_ptr<CPageLoaderBase::ILoadData>(); // ǂ^C~OClearƃR蓾BB
    }
    p->nIndex1 = rPageData.m_nIndex1;
    p->nIndex2 = rPageData.m_nIndex2;
 // p->pPlane = rPageData.m_pPlane;
    p->pPlane = CreatePagePlane(); // ǂ݃XbhƓɂPPlaneɓǂݍ܂Ȃ悤ɁBB

    return p;
}

// ǂݍ
bool CDocument::LoadPage(CPageLoaderBase::ILoadData& rLoad) {
    try {
        SLoadData& rLoadData = static_cast<SLoadData&>(rLoad);
        // ǂݍݏ
        bool bForward = (0 <= rLoadData.nIndex1);
        Themis_DebugAssert(bForward || 0 <= rLoadData.nIndex2);
        int& r_nIndex1 = bForward ? rLoadData.nIndex1 : rLoadData.nIndex2;
        int& r_nIndex2 = bForward ? rLoadData.nIndex2 : rLoadData.nIndex1;
        std::tr1::shared_ptr<CImageLoader> pImageLoader1, pImageLoader2;
        std::tr1::shared_ptr<CImageLoader>& r_pImageLoader1 = bForward? pImageLoader1: pImageLoader2;
        std::tr1::shared_ptr<CImageLoader>& r_pImageLoader2 = bForward? pImageLoader2: pImageLoader1;

        // Pڂ̃t@Cǂݍ
        if (CreateLoader(r_pImageLoader1, r_nIndex1, bForward)) {
            try {
                rLoadData.strTypeName = r_pImageLoader1->GetTypeName();
            } catch (std::exception&) {
                rLoadData.strTypeName = L"sȉ摜";
            }
            CSize szImage1 = r_pImageLoader1->GetSize();
            CSize szImage2(0, 0);
            // QԖڂ̃t@Cǂݍ
            const int nSpreadView =m_oConfig.Num(L"ImageSpreadView_");
            if (nSpreadView != 0 && szImage1.cx < szImage1.cy) {
                //CfbNX̉ݒ
                r_nIndex2 = bForward ? r_nIndex1 + 1 : r_nIndex1 - 1;
                // ǂݍ
                if (CreateLoader(r_pImageLoader2, r_nIndex2, bForward) && r_nIndex1 != r_nIndex2) {
                    szImage2 = r_pImageLoader2->GetSize();
                } else {
                    r_nIndex2 = -1;
                }
            } else {
                r_nIndex2 = -1;
            }
            // `BRender()̗O͐K؂t@CƂƌȂĖ鎖ɂB
            if (0 <= r_nIndex2 && szImage2.cx < szImage2.cy && abs(szImage1.cy - szImage2.cy) < 16) {
                // cŁẢ摜̏c̍16Pixelȉ̎
                // J\
                int paddingCenter = Max(m_oConfig.Num(L"PaddingCenter"), 0); // ƉƖʓ|Ȃ̂łOȏƂĂ܂B
                rLoadData.pPlane->SetSize(CSize(szImage1.cx + szImage2.cx + paddingCenter, Max(szImage1.cy, szImage2.cy)));
                
                int x;
                if (nSpreadView == 1) { // EԂ
                    x = (bForward ? szImage2.cx : szImage1.cx);
                    try { pImageLoader2->Render(*rLoadData.pPlane, CPoint()); } catch (std::exception&) {}
                    try { pImageLoader1->Render(*rLoadData.pPlane, CPoint(x + paddingCenter, 0)); } catch (std::exception&) {}
                } else { // Ԃ
                    x = (bForward ? szImage1.cx : szImage2.cx);
                    try { pImageLoader1->Render(*rLoadData.pPlane, CPoint()); } catch (std::exception&) {}
                    try { pImageLoader2->Render(*rLoadData.pPlane, CPoint(x + paddingCenter, 0)); } catch (std::exception&) {}
                }
                if (0 < paddingCenter) { // wiFhhB
                    rLoadData.pPlane->Fill(m_rgbBgColor, CRect(x, 0, paddingCenter, rLoadData.pPlane->GetSize().cy));
                }
                // `lĂ邩擾BJ̏ꍇ͕ЕłĂȂȂ玝ĂȂƌȂ
                rLoadData.bAlpha = r_pImageLoader1->HasAlpha() && r_pImageLoader2->HasAlpha();
            } else {
                r_nIndex2 = -1;
                // Py[W\
                rLoadData.pPlane->SetSize(r_pImageLoader1->GetSize());
                try { r_pImageLoader1->Render(*rLoadData.pPlane, CPoint()); } catch (std::exception&) {}
                // `lĂ邩擾
                rLoadData.bAlpha = r_pImageLoader1->HasAlpha();
            }
        } else {
            // ǂݍރt@Cۂ
            rLoadData.pPlane->SetSize(CSize(0, 0));
            r_nIndex1 = -1;
            r_nIndex2 = -1;
        }
        // Py[Windex2ݒ肳ĂAindex1ɂƂ
        if (rLoadData.nIndex1 < 0) {
            rLoadData.nIndex1 = rLoadData.nIndex2;
            rLoadData.nIndex2 = -1;
        }
        // ǂݍݎk
        if (m_oConfig.Bool(L"ReduceOnLoad")) {
            CSize originalSize = rLoadData.pPlane->GetSize();
            CSize size = m_oConfig.Size(L"ReduceOnLoadSize");
            if (0 < size.cx && 0 < size.cy) { // Ô
                double r = -1;
                if (m_oConfig.Bool(L"ReduceOnLoadBySpace")) {
                    // ʐςŏ
                    int space = size.GetSpace();
                    int originalSpace = originalSize.GetSpace();
                    // ŃI[o[t[悤Ȃ͍̂lȂBBMPɂ8GBɂȂႤ̂ŁB
                    if (space < originalSpace) {
                        r = sqrt(double(space) / originalSpace);
                    }
                } else {
                    // ő咷ŏ
                    if (size.cx < originalSize.cx || size.cy < originalSize.cy) {
                        double r1 = double(size.cx) / originalSize.cx;
                        double r2 = double(size.cy) / originalSize.cy;
                        r = Min(r1, r2);
                    }
                }
                if (0 <= r) {
                    CSize resizeSize = CSize(int(originalSize.cx * r), int(originalSize.cy * r));
                    std::tr1::shared_ptr<CPlaneEx> tmp = CreatePagePlane();
                    Stretch(*tmp, *rLoadData.pPlane, resizeSize); // ClearType͂ł͂ȂB
                    rLoadData.pPlane.swap(tmp);
                    tmp->Delete();
                }
            }
        }
        // tB^
        if (m_oConfig.Bool(L"Filter")) {
            m_pImageFilter->Filter(rLoadData.pPlane, CreatePagePlane(), rLoadData.bAlpha);
            rLoadData.filtered = m_pImageFilter->IsFiltering();
        } else {
            rLoadData.filtered = false;
        }
        // kLbVp
        if (useStretchCache) {
            CreateStretchCache(rLoadData.stretchCache, rLoadData.pPlane);
        } else {
            rLoadData.stretchCache.reset();
        }
        // ǂݍݐ
        return true;
    } catch (std::exception&) {
        // ǂݍݎs
        return false;
    }
}

// ǂݍݐ̌n
void CDocument::DisposeLoadPage(CPageLoaderBase::IPageData& rPage, CPageLoaderBase::ILoadData& rLoad) {
    SPageData& rPageData = static_cast<SPageData&>(rPage);
    SLoadData& rLoadData = static_cast<SLoadData&>(rLoad);
    // t@CXg̍XV
    if (0 <= rLoadData.nIndex1) {
        m_pFileList->SetLoadState(rLoadData.nIndex1, 2);
    }
    if (0 <= rLoadData.nIndex2) {
        m_pFileList->SetLoadState(rLoadData.nIndex2, 2);
    }
    // LbV̍XV
    rPageData.m_pPlane = rLoadData.pPlane;
    rPageData.stretchCache = rLoadData.stretchCache;
    rPageData.m_bAlpha = rLoadData.bAlpha;
    rPageData.filtered = rLoadData.filtered;
    rPageData.m_strTypeName = rLoadData.strTypeName;
    rPageData.SetIndex(rLoadData.nIndex1, rLoadData.nIndex2);
}

void CDocument::PrepareCurrentPage(CPageLoaderBase::IPageData& rPage) {
    if (m_pFileList->IsValidIndex()) {
        static_cast<SPageData&>(rPage).SetIndex(m_pFileList->GetCurrentIndex(), -1);
        RegisterPreLoad(m_pFileList->GetCurrentIndex());
    } else {
        static_cast<SPageData&>(rPage).SetIndex(-1, -1);
    }
}

void CDocument::PrepareForwardPage(CPageLoaderBase::IPageData& rPage, CPageLoaderBase::IPageData& rPrior) {
    if (m_pFileList->IsValidIndex()) {
        int n = static_cast<SPageData&>(rPrior).GetNextIndex(*m_pFileList);
        static_cast<SPageData&>(rPage).SetIndex(n, -1);
        RegisterPreLoad(n);
    } else {
        static_cast<SPageData&>(rPage).SetIndex(-1, -1);
    }
}

void CDocument::PrepareBackwardPage(CPageLoaderBase::IPageData& rPage, CPageLoaderBase::IPageData& rNext) {
    if (m_pFileList->IsValidIndex()) {
        int n = static_cast<SPageData&>(rNext).GetPriorIndex(*m_pFileList);
        static_cast<SPageData&>(rPage).SetIndex(-1, n);
        RegisterPreLoad(n);
    } else {
        static_cast<SPageData&>(rPage).SetIndex(-1, -1);
    }
}

bool CDocument::CreateLoader(std::tr1::shared_ptr<CImageLoader>& pImageLoader, int& nIndex, bool bForward) {
    for (int i = 0; i < m_pFileList->GetCount(); i++) {
        try {
            // t@CJ
            std::tr1::shared_ptr<ThreadedImageLoader::IFileID> fileID;
            {
                boost::recursive_mutex::scoped_lock lock(mutex);
                if (m_pFileList->GetCount() <= i) break;
                nIndex = m_pFileList->GetRotatedIndex(nIndex);
                if (nIndex < 0 || m_pFileList->GetCount() <= nIndex) {
                    throw std::exception(); // t@ČƂH
                }
                if (m_pFileList->GetViewName(nIndex).IsEmpty()) {
                    Themis_DebugWarning(L"CDocument::CreateLoader()̎Ƀt@CہH");
                    throw std::exception();
                }
                if (!IsLoadableFileSize(m_pFileList->GetFileSize(nIndex))) {
                    throw std::exception(); // t@CTCYɈ[
                }
                m_pFileList->SetLoadState(nIndex, 1); // ǂݍݒ
                fileID.reset(new SFileID(m_pFileList->GetFileInfoClone(nIndex)));
            }

            // ǂݍ
            pImageLoader = threadedImageLoader->Load(fileID);
            if (pImageLoader == NULL) {
                throw std::exception(); // ǂݍݎs
            }
            if (!IsLoadableImage(*pImageLoader)) {
                throw std::exception(); // 摜TCYɈ[
            }
            return true;
        } catch (std::exception&) {
            // s[
            boost::recursive_mutex::scoped_lock lock(mutex);
            Themis_DebugAssert(0 <= nIndex);
            Themis_DebugAssert(nIndex < m_pFileList->GetCount());
            m_pFileList->SetLoadState(nIndex, -1);
            if (bForward) {
                nIndex = m_pFileList->GetRotatedIndexOnInc(nIndex + 1);
            } else {
                nIndex = m_pFileList->GetRotatedIndexOnDec(nIndex - 1);
            }
        }
    }
    // ǂރt@Cۂ
    return false;
}

//------------------------------------------------------------------//

int CDocument::SPageData::GetNextIndex(CFileList& r) const {
    if (0 <= m_nIndex2) {
        return r.GetRotatedIndexOnInc(m_nIndex2 + 1, r.GetCount());   //J
    } else {
        if (0 <= m_nIndex1) {
            return r.GetRotatedIndexOnInc(m_nIndex1 + 1, r.GetCount());   //Py[W
        } else {
            return 0;
        }
    }
}

int CDocument::SPageData::GetPriorIndex(CFileList& r) const {
    if (0 <= m_nIndex1) {
        return r.GetRotatedIndexOnDec(m_nIndex1 - 1, r.GetCount());
    } else {
        return r.GetCount() - 1;
    }
}
//------------------------------------------------------------------//

std::tr1::shared_ptr<CPlaneEx> CDocument::CreatePagePlane() {
    static CDibPlaneFactory32 s_oFactory;
    return s_oFactory.CreateInstance();
}

bool CDocument::IsLoadableFileSize(size_t nFileSize) {
    if (m_oConfig.Bool(L"FileSizeLimit")) {
        if (size_t(INT_MAX) < nFileSize) {
            return false;
        }
        if (int(nFileSize) < m_oConfig.Float(L"FileSizeLimitMin") * 1024.0) {
            return false;
        }
        if (m_oConfig.Float(L"FileSizeLimitMax") * 1024.0 < int(nFileSize)) {
            return false;
        }
    }
    return true;
}

bool CDocument::IsLoadableImage(const CImageLoader& rLoader) {
    if (m_oConfig.Bool(L"ImageSizeLimit")) {
        CSize szImage = rLoader.GetSize();
        double dLimitW = m_oConfig.Float(L"ImageSizeLimitPixel.cx");
        double dLimitH = m_oConfig.Float(L"ImageSizeLimitPixel.cy");
        if (m_oConfig.Bool(L"ImageSizeLimitCmpArea") && szImage.GetSpace() <= dLimitW * dLimitH) {
            return false;
        } else if (szImage.cx <= dLimitW && szImage.cy <= dLimitH) {
            return false;
        }
    }
    return true;
}

/// kLbV̍쐬
void CDocument::CreateStretchCache(std::tr1::shared_ptr<CPlaneEx>& stretchCache, std::tr1::shared_ptr<CPlaneEx>& pPlane) {
    std::tr1::shared_ptr<ILayout> layoutCopy = m_pLayout->Clone(); // RsB
    layoutCopy->SetDocument(CRect(pPlane->GetSize()));
    if (layoutCopy->IsActualSize()) {
        stretchCache.reset();
    } else {
        stretchCache = CreatePagePlane();
        Stretch(stretchCache, pPlane, layoutCopy->GetVirtualDstSize());
    }
}
/// ݂̃y[WύXꂽ
void CDocument::CurrentPageChanged() {
    pageChanged = true;
}

void CDocument::UpdateImage(const CRect& rc) {
    CLocalExclusion::CLock lock(*localExclusion);
    if (lock.IsLocked()) {
        // XN[o[֘Ał̍ċAh~
        if (!m_pFileList->IsEmpty()) {
            WaitLoadPage(); //ǂݍݏI܂ő҂
            m_pFileList->SetCurrentIndex(GetCurrentPage().m_nIndex1);
            if (m_pFileList->IsValidIndex()) {
                InnerUpdateImage(rc);
            }
            m_rView.OnUpdateDocument(rc);
            StartLoadBeforehand();
        } else {
            if (IsReadyImage()) {
                InnerUpdateImage(rc);
            }
            m_rView.OnUpdateDocument(rc);
        }
    }
}

void CDocument::InnerUpdateImage(const CRect& rc) {
    // CAEg̍XV
    if (pageChanged) {
        pageChanged = false;
        m_pLayout->SetDocument(CRect(GetCurrentImage()->GetSize()));
    }
    Themis_DebugAssert(0 < localExclusion->GetLockCount());
    m_rView.LayoutChanged();
    m_rView.LayoutChanged();
    m_rView.LayoutChanged();
    // gEk
    if (GetCurrentPage().stretchCache != NULL) {
        if (GetCurrentPage().stretchCache->GetSize() != m_pLayout->GetVirtualDstSize()) { // TCYςĂȂj
            GetCurrentPage().stretchCache.reset();
        }
    }
    if (GetCurrentPage().stretchCache == NULL) {
        const int nDrawMode = GetDrawMode();
        if (2 <= nDrawMode || m_oConfig.Bool(L"ClearType")) { // O`掞 or ClearTypegp̓ZJ_g
            if (m_pLayout->IsActualSize()) {
                // {]ȂkLbVgȂ
                GetCurrentPage().stretchCache.reset();
            } else {
                // ZJ_gp
                GetCurrentPage().stretchCache = CreatePagePlane();
                Stretch(GetCurrentPage().stretchCache, GetCurrentImage(), m_pLayout->GetVirtualDstSize());
            }
        } else {
            GetCurrentPage().stretchCache.reset();
        }
    } else {
        // kLbVς݂Ȃ炻̂܂܁B
    }
}

/// srcstretch̉摜dstցB
void CDocument::Stretch(std::tr1::shared_ptr<CPlaneEx>& pDst, std::tr1::shared_ptr<CPlaneEx>& pSrc, const CSize& szDst) {
    if (m_oConfig.Bool(L"ClearType")) {
        CSize szDst3 = CPlaneEx::GetClearTypeSize(szDst);
        std::tr1::shared_ptr<CPlaneEx> pTempDib = CreatePagePlane();
        Stretch(*pTempDib, *pSrc, szDst3);
        pDst->SetSize(szDst);
        pDst->ClearTypeBlt(*pTempDib, CPoint(), szDst3.ToRect());
    } else {
        Stretch(*pDst, *pSrc, szDst);
    }
}

void CDocument::Stretch(CPlaneEx& rDst, CPlaneEx& rSrc, const CSize& szDst) {
    const CRect rcSrc = rSrc.GetSize().ToRect();
    rDst.SetSize(szDst);
    const int nDrawMode = GetDrawMode();
    if (nDrawMode == 0) {
        CDC(CPlane::CGdiLock(rDst)).StretchBltNearest(CPlane::CGdiLock(rSrc), szDst.ToRect(), rcSrc);
    } else if (nDrawMode == 1) {
        CDC(CPlane::CGdiLock(rDst)).StretchBlt(CPlane::CGdiLock(rSrc), szDst.ToRect(), rcSrc);
    } else if (nDrawMode == 2) {
        rDst.StretchBltNearest(rSrc, szDst.ToRect(), rcSrc);
    } else if (nDrawMode == 3) {
        rDst.StretchBlt(rSrc, szDst.ToRect(), rcSrc);
    } else if (nDrawMode == 4) {
        rDst.StretchBltPixelAveration(rSrc, szDst.ToRect(), rcSrc);
    } else if (nDrawMode == 5) {
        rDst.StretchBltLanczos3(rSrc, szDst.ToRect(), rcSrc);
    } else if (nDrawMode == 6) {
        std::tr1::shared_ptr<CPlaneEx> tmp = CreatePagePlane(szDst);
        tmp->StretchBltPixelAveration(rSrc, tmp->GetSize().ToRect(), rcSrc);
        std::tr1::shared_ptr<CPlaneEx> tmp2 = CreatePagePlane(szDst);
        tmp2->GaussBefogBlt(*tmp, CPoint(), tmp->GetSize().ToRect(), 2.0);
        rDst.UnsharpMaskBlt(*tmp, *tmp2, CPoint(), tmp->GetSize().ToRect(), CPoint());
    }
}

//////////////////////////////////////////////////////////////////////

void CDocument::Draw(PAINTSTRUCT& ps) {
    if (GetCurrentImage()->IsCreated()) {
        CDC dc(ps.hdc);
        CRect rcPaint(ps.rcPaint);
        InnerDraw(dc, rcPaint);
        vector<CRect> vct = m_szScreen.ToRect().GetBlanks(m_pLayout->GetDst());
        for (size_t i = 0, n = vct.size(); i < n; i++) {
            dc.Fill(m_rgbBgColor, vct[i]);
        }
    } else {
        CDC(ps.hdc).Fill(m_rgbBgColor, CRect(ps.rcPaint));
    }
}

void CDocument::InnerDraw(CDC& dc, const CRect& rcPaint) {
    if (GetCurrentPage().stretchCache != NULL) { // ZJ_瓙{]
        if (GetCurrentPage().stretchCache->GetSize() == m_pLayout->GetVirtualDstSize()) {
            dc.Blt(CPlane::CGdiLock(*GetCurrentPage().stretchCache),
                m_pLayout->GetDst().GetPoint(),
                m_pLayout->GetVirtualDstSrc(), rcPaint);
            return;
        } else {
            Themis_DebugWarning(L"kLbṼTCYLayoutƕsv");
            GetCurrentPage().stretchCache.reset();
        }
    }
    // ZJ_gpȏꍇ
    const int nDrawMode = GetDrawMode();
    if (nDrawMode == 0) { // ǂݍ񂾉摜GDIœ]
        dc.StretchBltNearest(CPlane::CGdiLock(*GetCurrentImage()), m_pLayout->GetDst(), m_pLayout->GetSrc(), rcPaint);
    } else if (nDrawMode == 1) { // ǂݍ񂾉摜GDIœ]
        dc.StretchBlt(CPlane::CGdiLock(*GetCurrentImage()), m_pLayout->GetDst(), m_pLayout->GetSrc(), rcPaint);
    } else { // ǂݍ񂾉摜璼ړ]
        Themis_DebugAssertLog(m_pLayout->IsActualSize());
        Themis_DebugAssertLog(m_pLayout->GetSrc().GetSize() == m_pLayout->GetDst().GetSize());
        dc.Blt(CPlane::CGdiLock(*GetCurrentImage()), m_pLayout->GetDst().GetPoint(), m_pLayout->GetSrc(), rcPaint);
    }
}

void CDocument::DrawMark(PAINTSTRUCT& ps) {
    if (m_pFileList->IsMarked()) {
        //}[N̕`
        string strMark = L"";
        int nWidth = m_pFont->GetSize(strMark).cx;
        m_pFont->DrawText(ps.hdc, CPoint(m_szScreen.cx - nWidth, 2), strMark);
    }
}

void CDocument::DrawFilterMark(PAINTSTRUCT& ps) {
    if (m_oConfig.Bool(L"FilterMark")) {
        //tB^[}[N̕`
        if (IsReady() && GetCurrentPage().filtered) {
            m_pFont->DrawText(ps.hdc, CPoint(), L"e");
        }
    }
}

void CDocument::DrawSelectFrame(PAINTSTRUCT& ps, const CRect& rc) {
    //IĂȂ炻͈̔͂`
    CRect rcDst1(rc.GetPoint(), CSize(rc.GetWidth(), 1));
    CRect rcDst2(rc.GetPoint(), CSize(1, rc.GetHeight()));
    CRect rcDst3(rc.GetPoint() + CSize(0, rc.GetHeight()), CSize(rc.GetWidth(), 1));
    CRect rcDst4(rc.GetPoint() + CSize(rc.GetWidth(), 0), CSize(1, rc.GetHeight()));
    CDC dc(ps.hdc);
    dc.ReverseFill(rcDst1);
    dc.ReverseFill(rcDst2);
    dc.ReverseFill(rcDst3);
    dc.ReverseFill(rcDst4);
}

void CDocument::DrawStretch(PAINTSTRUCT& ps, const CRect& rcDst, const CRect& rcSrc) {
    CPlane::CGdiLock oGdiLock(*GetCurrentImage());
    CDC(ps.hdc).StretchBlt(oGdiLock.Get(), rcDst, rcSrc, CRect(ps.rcPaint));
}

//////////////////////////////////////////////////////////////////////

/// ŏ̃t@CȂ̂ǂ
bool CDocument::IsFirstFile() const {
    // ɂ͖̂ʓ|Ȃ̂ŊȈՎBs߂ꍇ͕̏ʂłׂB
    return GetCurrentPage().m_nIndex1 == 0 || GetCurrentPage().m_nIndex2 == 0;
}

/// Ō̃t@CȂ̂ǂ
bool CDocument::IsLastFile() const {
    // ɂ͖̂ʓ|Ȃ̂ŊȈՎBs߂ꍇ͕̏ʂłׂB
    int n = GetFileCount() - 1;
    return GetCurrentPage().m_nIndex1 == n || GetCurrentPage().m_nIndex2 == n;
}

//////////////////////////////////////////////////////////////////////

void CDocument::BackupBegin() {
    Themis_DebugAssert(m_pBackupImage == NULL);
    m_pBackupImage = CreatePagePlane(GetCurrentImage()->GetSize());
    m_pBackupImage->Blt(*GetCurrentImage());
    backupImageHasAlpha = GetCurrentPage().m_bAlpha;
    m_bBackup = true;
}

void CDocument::BackupRestore() {
    GetCurrentImage()->SetSize(m_pBackupImage->GetSize());
    GetCurrentImage()->Blt(*m_pBackupImage);
    GetCurrentPage().m_bAlpha = backupImageHasAlpha;
 // UpdateImage();
}

void CDocument::BackupEnd() {
    m_bBackup = false;
    UpdateImage();
    m_pBackupImage.reset();
}

void CDocument::BackupEndWithRestore() {
    m_bBackup = false;
    BackupRestore();
    UpdateImage();
    m_pBackupImage.reset();
}

namespace {
    double HistogramTransform(int n) {
        return sqrt(double(n));
    }
}
std::tr1::shared_ptr<CPlaneEx> CDocument::GetHistogramGraph(const CRect& rc, const CSize& szDst, double& dAverage, double& dStdEvp) {
    CRect rc2 = ClientToImage(rc);
    int anHistogram[0x100];
    GetCurrentImage()->GetHistogramRGBAverage(anHistogram, rc2);
    int nHistogramMax = *std::max_element(anHistogram, anHistogram + 0x100);
    dAverage = 0.0;
    {for (int i = 0; i < 0x100; i++) {
        dAverage += double(i) * anHistogram[i];
    }}
    double dSpace = rc2.GetSpace();
    dAverage /= dSpace;
    dStdEvp = 0.0;
    {for (int i = 0; i < 0x100; i++) {
        double dt = double(i)  - dAverage;
        dStdEvp += dt * dt * anHistogram[i];
    }}
    dStdEvp = sqrt(dStdEvp / dSpace);

    double adHistogram[0x100];
    std_transform(anHistogram, anHistogram + 0x100, adHistogram, HistogramTransform);

    std::tr1::shared_ptr<CPlaneEx> pResult(CreatePagePlane(szDst));
    pResult->MakeBargraph(szDst.ToRect(), adHistogram, 0x100, 0.0, HistogramTransform(nHistogramMax), ::GetSysColor(COLOR_3DFACE));
    return pResult;
}

void CDocument::SaveHistogramGraph(const CRect& rc, const CFileName& oFileName) {
    CRect rc2 = ClientToImage(rc);
    int anHistogram[0x100] = {0};
    GetCurrentImage()->GetHistogramRGBAverage(anHistogram, rc2);
    StringBuilder file;
    file.Append(L"\"t@C\",\"");
    file.Append(GetCurrentFileName().Get());
    file.Append(L"\"\r\n");
    file.Append(L"\"̈(x,y,w,h)\",");
    file.Append(ItoA(rc2.left));
    file.Append(L',');
    file.Append(ItoA(rc2.top));
    file.Append(L',');
    file.Append(ItoA(rc2.GetWidth()));
    file.Append(L',');
    file.Append(ItoA(rc2.GetHeight()));
    file.Append(L',');
    file.Append(L"\r\n\"f[^F\"\r\n");
    for (int i = 0; i < 0x100; i++) {
        file.Append(ItoA(i));
        file.Append(L',');
        file.Append(ItoA(anHistogram[i]));
        file.Append(L"\r\n");
    }
    CFile(oFileName).Save(file.ToString());
}

/// ɂ̃pX[h₢킹B
bool CDocument::QueryPassword(const CFileName& archiveName, string& pass, int tryCount) {
    if (tryCount < int(m_vctArcPass.size())) {
        pass = m_vctArcPass[tryCount];
        return true;
    }
    return m_rQueryPass.QueryPassword(archiveName, pass, tryCount);
}

std::tr1::shared_ptr<CImageLoader> CDocument::CreateImageLoader() {
    std::tr1::shared_ptr<CImageLoader> p(new CImageLoader());
 // Ă̓_B
 // p->SetRenderOnlyAtOnce(true);
    return p;
}

std::tr1::shared_ptr<CFileData> CDocument::LoadFile(ThreadedImageLoader::IFileID& fileId) {
    SFileID& id = static_cast<SFileID&>(fileId);
    return id.info->LoadFile();
}

/// ThreadedImageLoader.PreLoad()ȏB
void CDocument::RegisterPreLoad(int n) {
    boost::recursive_mutex::scoped_lock lock(mutex);
    if (m_pFileList->GetCount() <= 0) return;
    // LbV̔{܂œǂݍށB
    int f = GetForwardCount() * 2;
    int b = GetBackwardCount() * 2;
    if (m_oConfig.Num(L"ImageSpreadView_") != 0) { // JȂ{
        f *= 2;
        b *= 2;
    }
    // Oǂ
    for (int i = n, end = n + f; i < end; i++) {
        int index = m_pFileList->GetRotatedIndex(i);
        if (index < 0 || m_pFileList->GetCount() <= index) continue; // Ô
        threadedImageLoader->PreLoad(std::tr1::shared_ptr<ThreadedImageLoader::IFileID>(
            new SFileID(m_pFileList->GetFileInfoClone(index))));
    }
    // ǂ
    for (int i = n - 1, end = n - b; end <= i; i--) {
        // ̓Rsy
        int index = m_pFileList->GetRotatedIndex(i);
        if (index < 0 || m_pFileList->GetCount() <= index) continue; // Ô
        threadedImageLoader->PreLoad(std::tr1::shared_ptr<ThreadedImageLoader::IFileID>(
            new SFileID(m_pFileList->GetFileInfoClone(index))));
    }
}
