#include "stdafx.h"
#include "EnvConfigDialog.h"
#include "SuffixUtility.h"
#include "resource.h"
#include <Themis/Windows/System.h>
#include <Themis/Windows/Process.h>
#include <Themis/WndCtrlData.h>
#include <Themis/CtrlEnable.h>
#include <Themis/File.h>
#include <Themis/Config2.h>
#include <Themis/Tooltip.h>
#include <Themis/TempFile.h>

CEnvConfigDialog::CEnvConfigDialog(CConfig& rConfig) : CResourceDialogBase(IDD_ENVCFG), m_oConfig(rConfig) {
}

CEnvConfigDialog::~CEnvConfigDialog() {
}

bool CEnvConfigDialog::HookMsg(CMsgHookPrms& rPrms) {
    if (rPrms.GetMsg() == WM_COMMAND) {
        switch (rPrms.GetWPrmLoWord()) {
        case IDOK:
            SaveToConfig();
            GetDialog().Close();
            break;
        case IDCANCEL:
            GetDialog().Close();
            break;

        case IDC_BUTTON1:   // ǉ{^
            GetDialog().Listbox(IDC_LIST1).Add(GetValidSuffix(GetDialog().Editbox(IDC_EDIT1).GetText()));
            GetDialog().Editbox(IDC_EDIT1).SetText(string());   //ۂɁB
            break;
        case IDC_BUTTON2:   // 폜{^
            GetDialog().Listbox(IDC_LIST1).Delete();
            break;
        case IDC_BUTTON3:   // ǉ{^
            GetDialog().Listbox(IDC_LIST2).Add(GetValidSuffix(GetDialog().Editbox(IDC_EDIT5).GetText()));
            GetDialog().Editbox(IDC_EDIT5).SetText(string());   //ۂɁB
            break;
        case IDC_BUTTON5:   // 폜{^
            GetDialog().Listbox(IDC_LIST2).Delete();
            break;
        case IDC_CHECK18:   //ڂ
            UpdateCtrl();
            break;
        }
        return true;
    } else if (rPrms.GetMsg() == WM_INITDIALOG) {
        CWnd oParentWindow(GetDialog().GetParent());
        if (oParentWindow.Exists()) {
            GetDialog().SetPosClip(oParentWindow.ToScreen(oParentWindow.GetClientSize().GetCenterOf(GetDialog().GetSize())));  //
        }
        LoadFromConfig();

        // [邿ՁB
        CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
        pTip->Add(IDC_CHECK18, L"̃IvVIt̏ꍇƃLZ{^ꍇƂ́A֘AtɊւ鏈؍s܂B");

        pTip->Add(IDC_CHECK1, L"ꂼ̊gqтɊ֘At܂B");
        pTip->Add(IDC_CHECK2, L"ꂼ̊gqтɊ֘At܂B");
        pTip->Add(IDC_CHECK3, L"ꂼ̊gqтɊ֘At܂B");
        pTip->Add(IDC_CHECK4, L"ꂼ̊gqтɊ֘At܂B");
        pTip->Add(IDC_CHECK6, L"ꂼ̊gqтɊ֘At܂B");
        pTip->Add(IDC_EDIT1, L"gqiu.vȂǂ͕tubmpv̂悤Ɂj͂܂B\r\n"
            L"ǉ{^ȂƔfȂ̂ŁAӂĂB");
        pTip->Add(IDC_EDIT5, L"gqiu.vȂǂ͕tubmpv̂悤Ɂj͂܂B\r\n"
            L"ǉ{^ȂƔfȂ̂ŁAӂĂB");
        pTip->Add(IDC_LIST1, L"֘Atsgq̈ꗗB");
        pTip->Add(IDC_LIST2, L"֘Atsgq̈ꗗB");
        pTip->Add(IDC_BUTTON1, L"͗̊gqo^܂B");
        pTip->Add(IDC_BUTTON3, L"͗̊gqo^܂B");
        pTip->Add(IDC_BUTTON2, L"XgőIĂgq폜܂B");
        pTip->Add(IDC_BUTTON5, L"XgőIĂgq폜܂B");
        pTip->Add(IDC_CHECK13, L"ꂼ̊gq̉ENbNj[ɁuтŊJvǉ܂B");
        pTip->Add(IDC_CHECK14, L"ꂼ̊gq̉ENbNj[ɁuтŊJvǉ܂B");
        pTip->Add(IDC_CHECK5, L"ꂼ̊gq̉ENbNj[ɁuтŊJvǉ܂B");
        pTip->Add(IDC_CHECK15, L"ꂼ̊gq̉ENbNj[ɁuтŊJvǉ܂B");
        pTip->Add(IDC_CHECK19, L"tH_̉ENbNj[ɁuтŊJvǉ܂B");

        pTip->Add(IDC_CHECK12, L"gq gvb тubN}[Nt@CƂĊ֘At܂B");

        pTip->Add(IDC_CHECK8, L"ENbNj[́uvɂтւ̃V[gJbg쐬܂B");

        pTip->Add(IDC_EDIT9, L"ut@C̎ށvƂĕ\镶ݒ肵܂B");
        pTip->Add(IDC_EDIT11, L"ENbNj[ɕ\镶ݒ肵܂B");
        pTip->Add(IDC_EDIT25, L"ubN}[Nt@C(*.gvb)́ut@C̎ށvƂĕ\镶ݒ肵܂B");

        return true;
    } else if (rPrms.GetMsg() == WM_CLOSE) {
        GetDialog().Delete();
        return true;
    } else {
        return false;
    }
}

void CEnvConfigDialog::LoadFromConfig() {
    GetDialog().Checkbox(IDC_CHECK18).SetCheck(false);
    GetDialog().Checkbox(IDC_CHECK1).SetCheck(CSystem::IsRelationFileType(L"jpg", L"gv2-img-files"));
    GetDialog().Checkbox(IDC_CHECK2).SetCheck(CSystem::IsRelationFileType(L"png", L"gv2-img-files"));
    GetDialog().Checkbox(IDC_CHECK3).SetCheck(CSystem::IsRelationFileType(L"bmp", L"gv2-img-files"));
    GetDialog().Checkbox(IDC_CHECK6).SetCheck(CSystem::IsRelationFileType(L"gif", L"gv2-img-files"));
    GetDialog().Checkbox(IDC_CHECK4).SetCheck(CSystem::IsRelationFileType(L"argb", L"gv2-img-files"));
    GetDialog().Checkbox(IDC_CHECK22).SetCheck(CSystem::IsRelationFileType(L"cbz", L"gv2-img-files"));
    GetDialog().Checkbox(IDC_CHECK10).SetCheck(CSystem::IsRelationFileType(L"cbr", L"gv2-img-files"));
    GetDialog().Checkbox(IDC_CHECK12).SetCheck(CSystem::IsRelationFileType(L"gvb", L"gv2-bkmk-files"));
    GetDialog().Checkbox(IDC_CHECK13).SetCheck(CSystem::IsRelationCommand(CSystem::GetRelationFileType(L"zip"), L"open-by-gv2"));
    GetDialog().Checkbox(IDC_CHECK14).SetCheck(CSystem::IsRelationCommand(CSystem::GetRelationFileType(L"rar"), L"open-by-gv2"));
    GetDialog().Checkbox(IDC_CHECK5).SetCheck(CSystem::IsRelationCommand(CSystem::GetRelationFileType(L"lzh"), L"open-by-gv2"));
    GetDialog().Checkbox(IDC_CHECK15).SetCheck(CSystem::IsRelationCommand(CSystem::GetRelationFileType(L"gca"), L"open-by-gv2"));
    GetDialog().Checkbox(IDC_CHECK16).SetCheck(CSystem::IsRelationCommand(CSystem::GetRelationFileType(L"cbz"), L"open-by-gv2"));
    GetDialog().Checkbox(IDC_CHECK17).SetCheck(CSystem::IsRelationCommand(CSystem::GetRelationFileType(L"cbr"), L"open-by-gv2"));
    GetDialog().Checkbox(IDC_CHECK19).SetCheck(CSystem::IsRelationCommand(L"Folder", L"open-by-gv2"));
    GetDialog().Checkbox(IDC_CHECK8).SetCheck(CFile(CFileName(CSystem::GetSendToDir() + L"т2.lnk")).ExistsFile());
    m_oConfig.StrData(L"EnvSetOthers") >> SuffixListData(GetDialog(), IDC_LIST1);
    m_oConfig.StrData(L"EnvRClickOthers") >> SuffixListData(GetDialog(), IDC_LIST2);
    m_oConfig.IndirectData(L"EnvDesc") >> CEditboxData(GetDialog(), IDC_EDIT9);
    m_oConfig.IndirectData(L"EnvMenuName") >> CEditboxData(GetDialog(), IDC_EDIT11);
    m_oConfig.IndirectData(L"EnvDescGvb") >> CEditboxData(GetDialog(), IDC_EDIT25);
    UpdateCtrl();
}

void CEnvConfigDialog::SaveToConfig() {
    CConfig2 config; // regrel.exe֓np[^
    config.Str(L"EnvSetOthersOld") << m_oConfig.Str(L"EnvSetOthers");
    config.Str(L"EnvRClickOthersOld") << m_oConfig.Str(L"EnvRClickOthers");

    m_oConfig.StrData(L"EnvSetOthers") << SuffixListData(GetDialog(), IDC_LIST1);
    m_oConfig.StrData(L"EnvRClickOthers") << SuffixListData(GetDialog(), IDC_LIST2);
    m_oConfig.IndirectData(L"EnvMenuName") << CEditboxData(GetDialog(), IDC_EDIT11);
    m_oConfig.IndirectData(L"EnvDesc") << CEditboxData(GetDialog(), IDC_EDIT9);
    m_oConfig.IndirectData(L"EnvDescGvb") << CEditboxData(GetDialog(), IDC_EDIT25);

    // Ƃ
    if (GetDialog().Checkbox(IDC_CHECK8).GetCheck()) {
        CSystem::SShortcutInfo oInfo;
        oInfo.strTarget = CSystem::GetModuleFileName();
     // oInfo.strIconFile = CSystem::GetModuleFileName();
     // oInfo.nIcon = 0;
        CSystem::CreateShortcut(CFileName(CSystem::GetSendToDir() + L"т2.lnk"), oInfo);
    } else {
        CFile oFile(CFileName(CSystem::GetSendToDir() + L"т2.lnk"));
        if (oFile.Exists()) {
            oFile.Delete();
        }
    }

    if (GetDialog().Checkbox(IDC_CHECK18).GetCheck()) {
        config.Line(L"ModuleFileName") << CSystem::GetModuleFileName();
        config.Line(L"EnvMenuName") << m_oConfig.IndirectData(L"EnvMenuName");
        config.Line(L"EnvDesc") << m_oConfig.IndirectData(L"EnvDesc");
        config.Line(L"EnvDescGvb") << m_oConfig.IndirectData(L"EnvDescGvb");
        config.Str(L"EnvSetOthers") << m_oConfig.Str(L"EnvSetOthers");
        config.Str(L"EnvRClickOthers") << m_oConfig.Str(L"EnvRClickOthers");
        config.Bool(L"RelationJPG") << GetDialog().Checkbox(IDC_CHECK1).GetCheck();
        config.Bool(L"RelationPNG") << GetDialog().Checkbox(IDC_CHECK2).GetCheck();
        config.Bool(L"RelationBMP") << GetDialog().Checkbox(IDC_CHECK3).GetCheck();
        config.Bool(L"RelationGIF") << GetDialog().Checkbox(IDC_CHECK6).GetCheck();
        config.Bool(L"RelationARGB") << GetDialog().Checkbox(IDC_CHECK4).GetCheck();
        config.Bool(L"RelationCBZ") << GetDialog().Checkbox(IDC_CHECK22).GetCheck();
        config.Bool(L"RelationCBR") << GetDialog().Checkbox(IDC_CHECK10).GetCheck();
        config.Bool(L"RelationGVB") << GetDialog().Checkbox(IDC_CHECK12).GetCheck();
        config.Bool(L"MenuZIP") << GetDialog().Checkbox(IDC_CHECK13).GetCheck();
        config.Bool(L"MenuRAR") << GetDialog().Checkbox(IDC_CHECK14).GetCheck();
        config.Bool(L"MenuLZH") << GetDialog().Checkbox(IDC_CHECK5).GetCheck();
        config.Bool(L"MenuGCA") << GetDialog().Checkbox(IDC_CHECK15).GetCheck();
        config.Bool(L"MenuCBZ") << GetDialog().Checkbox(IDC_CHECK16).GetCheck();
        config.Bool(L"MenuCBR") << GetDialog().Checkbox(IDC_CHECK17).GetCheck();
        config.Bool(L"MenuFolder") << GetDialog().Checkbox(IDC_CHECK19).GetCheck();

        // ֘At̋N
        CTempFile tempFile(CFileNameModuleDir(), L"rel", L"cfg");
        tempFile.Create(config.GetStorage().SaveToStr());
        ProcessStartInfo info(CFileNameModuleDir(L"regrel.exe").Get(), tempFile.GetName().Get());
        if (!CSystem::IsUserAnAdmin()) info.Verb = L"runas";
        std::tr1::shared_ptr<Process> process = Process::Start(info);
        process->WaitForExit();

        // XVVXeɒʒm(regrel.exełĂ͂AʏoĂȂH)
        CSystem::NotifyRelation();
    }
}

void CEnvConfigDialog::UpdateCtrl() {
    CCtrlEnable(GetDialog().Checkbox(IDC_CHECK18).GetCheck())
    // ֘At
        << GetDialog().GetCtrl(IDC_CHECK1)
        << GetDialog().GetCtrl(IDC_CHECK2)
        << GetDialog().GetCtrl(IDC_CHECK3)
        << GetDialog().GetCtrl(IDC_CHECK6)
        << GetDialog().GetCtrl(IDC_CHECK4)
        << GetDialog().GetCtrl(IDC_CHECK22)
        << GetDialog().GetCtrl(IDC_CHECK10)
        << GetDialog().GetCtrl(IDC_EDIT1)
        << GetDialog().GetCtrl(IDC_LIST1)
        << GetDialog().GetCtrl(IDC_BUTTON1)
        << GetDialog().GetCtrl(IDC_BUTTON2)
        << GetDialog().GetCtrl(IDC_EDIT9)
    // ENbN
        << GetDialog().GetCtrl(IDC_CHECK13)
        << GetDialog().GetCtrl(IDC_CHECK14)
        << GetDialog().GetCtrl(IDC_CHECK5)
        << GetDialog().GetCtrl(IDC_CHECK15)
        << GetDialog().GetCtrl(IDC_CHECK16)
        << GetDialog().GetCtrl(IDC_CHECK17)
        << GetDialog().GetCtrl(IDC_CHECK19)
        << GetDialog().GetCtrl(IDC_EDIT5)
        << GetDialog().GetCtrl(IDC_LIST2)
        << GetDialog().GetCtrl(IDC_BUTTON3)
        << GetDialog().GetCtrl(IDC_BUTTON5)
        << GetDialog().GetCtrl(IDC_EDIT11)
    // gvb
        << GetDialog().GetCtrl(IDC_CHECK12)
        << GetDialog().GetCtrl(IDC_EDIT25)
        ;
}

