#pragma once
#include <Themis/Archive.h>

/**
 * t@CNX
 */
class CFileInfo { // copyable
    // : private boost::noncopyable
    //CFileInfo(const CFileInfo&);
    //CFileInfo& operator=(const CFileInfo&);
public:
    CFileInfo();
    CFileInfo(const CFileName& oViewName, int nSortMode);
    CFileInfo(const string& strViewName, const std::tr1::weak_ptr<CArchive>& pArchive, int nArchiveIndex, int nSortMode);
    ~CFileInfo();

    /// CX^X𐶐ĕԂB
    std::tr1::shared_ptr<CFileInfo> Clone() const;

    /// @w
    void SetSortMode(int nMode);

    //@{ Eړ
    void Copy(const CFileName& oDstName);
    void Move(const CFileName& oDstName);
    //@}
    //@{ t@C̎擾
    const CFileName& GetViewName() const { return m_oViewName; }
    const string& GetSortName() const { return m_strSortName; }
    int GetLoadState() const { return loadState; }
    bool IsMarked() const { return marked; }
    bool IsArchiveFile() const { return archive.lock().get() != NULL; }
    size_t GetFileSize() const;
    string GetLastUpdate() const;
    string GetFileMD5() const;
    CFileName GetExistFileName() const;
    string GetBookmarkDefaultName() const;
    std::tr1::shared_ptr<CFileData> LoadFile() const;
    //@}

    //@{ rZq
    bool operator<(const CFileInfo& r) const {
        Themis_DebugAssert(!string::IsNullOrEmpty(m_strSortName));
        Themis_DebugAssert(!string::IsNullOrEmpty(r.m_strSortName));
        return m_strSortName < r.m_strSortName;
    }
    bool operator==(const CFileInfo& r) const {
     // Themis_DebugAssert(!m_strSortName.empty());
     // Themis_DebugAssert(!r.m_strSortName.empty());
     // return m_strSortName == r.m_strSortName;
        Themis_DebugAssert(!m_oViewName.IsEmpty());
        Themis_DebugAssert(!r.m_oViewName.IsEmpty());
        return m_oViewName.Get() == r.m_oViewName.Get();
            // 啶ɕςĂ鎖͖Ɖ(L`)
    }
    // std::find()p
    bool operator==(const string& r) const { return m_oViewName.Get() == r; }
    //@}

    //@{ ̐ݒ
    void SetArchive(const std::pair<std::tr1::weak_ptr<CArchive>, int>& p) {
        Themis_DebugAssert(!(archive.lock().get() != NULL && p.first.lock().get() == NULL));
        archive = p.first;
        archiveIndex = p.second;
    }
    void SetViewName(const CFileName& oName) { m_oViewName = oName; }
    void SetLoadState(int n) { loadState = n; }
    void SetMark(bool mark) { marked = mark; }
    void ReverseMark() { SetMark(!IsMarked()); }
    //@}

private:
    CFileName m_oViewName;    // \t@C
    string m_strSortName;     // \[gp

    std::tr1::weak_ptr<CArchive> archive; // Rs[̃RXgȋCȂȂ̂ŁBB
    int archiveIndex; // ƃZbgȃf[^Ȃ̂ŁBB

    int loadState; // 0:ǂݍݖsA-1:ǂݍݎsA1:ǂݍݒA2:ǂݍݐBt@CXg̃Xe[^X\pB
    bool marked;
};

