#pragma once
#include "FileInfo.h"
namespace Themis {
class CPlaneEx;
class CFile;
class IQueryArchivePassword;
class PooledWorkList;
};
class CFileListWindow;
class MsgDialog;

/**
    t@CXgBɂ̏ƂB

    CurrentIndex܂߂炽̃XgĖłȂȂC邪A
    폜Ƃxɂs肱s肷̂Ȃ̂ŁcB
*/
class CFileList : private boost::noncopyable {
public:
    CFileList(const ArchiveOwner& owner);
    ~CFileList();

    //@{ ݒ
    void SetWindow(CFileListWindow* pWindow);
    void SetTempDir(const CFileName& o);
    void SetSortMode(int nMode);
    //@}

    struct AddConfig {
        bool followLnk;
        bool ignoreBySuffix;
        mutable vector<string> includeSuffixes;
        mutable vector<string> excludeSuffixes;
        bool openTopDirOnly;
    };
    //@{ ǉES폜
    bool IsEmpty() const { return m_vctFiles.empty(); }
    void Clear();
    void Add(const CFileName& oFileName, const AddConfig& config, MsgDialog* msgDialog);
    void Add(const vector<CFileName>& vct, const AddConfig& config, MsgDialog* msgDialog);
    void InsertDummyFile();
    void InsertExistFile(const CFileName& oFileName, bool bNext);
    //}

    //@{ 폜EEړ
    void Remove();
    void Remove(const CFileName& oViewName);
    void Delete(bool deleteByShell, HWND hwndParent);
    void Copy(const CFileName& oNewName);
    void Rename(const CFileName& oNewName, bool bRemoveOnMove);
    void CopyAllMarks(const CFileName& oDir);
    void RenameAllMarks(const CFileName& oDir, bool bRemoveOnMove);
    void RemoveAllMarks(bool bDelete, bool deleteByShell, HWND hwndParent);
    //@}
    //@{ ёւ
    void Sort(int nSortMode);
    void Shuffle();
    void ShuffleDir();
    //@}
    //@{ CfbNẌړȂ
    bool IsValidIndex() const { return 0 <= m_nCurrentIndex; }
    int GetCurrentIndex() const { return m_nCurrentIndex; }
    void SetCurrentIndex(int n);
    void ToSortedPrior();
    void ToSortedNext();
    void ToPriorDir();
    void ToNextDir();
    void ToPriorMarkFile();
    void ToNextMarkFile();
    //@}
    //@{ ubN}[N
    void SaveBookmark(const CFileName& oFileName) const;
    void LoadBookmark(const CFileName& oFileName);
    //@}

    //@{ í݂jt@C̏擾
    int GetCount() const { return static_cast<int>(m_vctFiles.size()); }
    const CFileName& GetViewName() const { return m_vctFiles[m_nCurrentIndex].GetViewName(); }
    size_t GetFileSize() const { return m_vctFiles[m_nCurrentIndex].GetFileSize(); }
    string GetFileMD5() const { return m_vctFiles[m_nCurrentIndex].GetFileMD5(); }
    string GetLastUpdate() const { return m_vctFiles[m_nCurrentIndex].GetLastUpdate(); }
    CFileName GetExistFileName() const { return m_vctFiles[m_nCurrentIndex].GetExistFileName(); }
    string GetBookmarkDefaultName() const { return m_vctFiles[m_nCurrentIndex].GetBookmarkDefaultName(); }
    bool IsMarked() const { return IsMarked(m_nCurrentIndex); }
    std::tr1::shared_ptr<CFileInfo> GetFileInfoClone(int i) { return m_vctFiles[i].Clone(); }
    //@}

    //@{ CDocument ̓ǂݍݕ CFileListWindow ̕\Ɏgp擾֐
    const CFileName& GetViewName(int i) const { return m_vctFiles[i].GetViewName(); }
    int GetLoadState(int i) const { return m_vctFiles[i].GetLoadState(); }
    size_t GetFileSize(int i) const { return m_vctFiles[i].GetFileSize(); }
    bool IsMarked(int i) const { return m_vctFiles[i].IsMarked(); }
    //@}
    //@{ ݒ֐
    void SetLoadState(int i, int nState);
    void SetMark(bool mark);
    //@}

    /// ǂݍݎsԂNA
    void ClearFailed();

    //@{ }[N֘ȂȂ
    void ReverseAllMarks();
    void ReverseFirstToCurrentMarks();
    void ClearMarks();
    int GetMarkCount() const;
    vector<string> GetMarkedFiles() const;
    //@}

    inline int GetRotatedIndex(int i) { return GetRotatedIndex(i, GetCount()); }
    inline int GetRotatedIndexOnInc(int i) { return GetRotatedIndexOnInc(i, GetCount()); }
    inline int GetRotatedIndexOnDec(int i) { return GetRotatedIndexOnDec(i, GetCount()); }
    inline int GetRotatedIndex(int i, int c) {
        return Themis::GetRotatedIndex(i, c);
    }
    inline int GetRotatedIndexOnInc(int i, int c) {
        return Themis::GetRotatedIndexOnInc(i, c);
    }
    inline int GetRotatedIndexOnDec(int i, int c) {
        return Themis::GetRotatedIndexOnDec(i, c);
    }

private:
    void AddInitialize(const AddConfig& config);
    void InnerAddPP(const vector<CFileName>& vct, const AddConfig& config, bool bOnlySingleFile);
    void InnerAddPP(const vector<CFileName>& vct, int begin, int end, const AddConfig& config, bool bOnlySingleFile) {
        for (int i = begin; i < end; i++) InnerAdd(vct[i], config, bOnlySingleFile);
    }
    void InnerAdd(const CFileName& oFileName, const AddConfig& config, bool bOnlySingleFile);
    void InnerAddArchive(const AddConfig& config, const vector<CArchive::SFileInfo>& vctFiles);
    void InnerAddArchivePP(const AddConfig& config, const vector<CArchive::SFileInfo>& vct, int begin, int end);
    bool ToBeIgnore(const AddConfig& config, const CFileName& fileName);
    void UniqueFiles();

    void InnerSetSortMode(int mode);
    void InnerSetSortModePP(int mode, int begin, int end) {
        for (int i = begin; i < end; i++) {
            m_vctFiles[i].SetSortMode(mode);
        }
    }

    bool LoadBookmark1(const CFileName& oFileName, string& strCurrent);
    bool LoadBookmark2(const CFileName& oFileName, string& strCurrent);
    void LoadBookmarkSetArchive();
    void LoadBookmarkSetArchivePP(int start, int end) {
        for (int i = start; i < end; i++) {
            m_vctFiles[i].SetArchive(m_pArchiveLoader->Find(m_vctFiles[i].GetViewName().Get()));
        }
    }

    int Find(const string& str);

    //typedef vector<CFileInfo> FileListType;
    //typedef boost::ptr_vector<CFileInfo> FileListType;
    typedef boost::ptr_deque<CFileInfo> FileListType;

    void InnerSort() { m_vctFiles.sort(); }
    void InnerSort(FileListType::iterator first, FileListType::iterator last) { m_vctFiles.sort(first, last); }

private:
    CFileListWindow* m_pListWindow;

    FileListType m_vctFiles;

    auto_ptr<CArchiveLoader> m_pArchiveLoader;
    int m_nSortMode;
    int m_nCurrentIndex;

    auto_ptr<std::set<string> > m_pFollowLnkList; // V[gJbgHۂ̖ċAh~pXg

    bool m_bLinkFirstAndLast;
};

