#pragma once
#include <Themis/MsgHook.h>
namespace Themis {
class CListview;
class CWindow;
}
class CDocument;

/**
*/
class CFileListWindow: private IMsgHooker {
public:
    CFileListWindow(CDocument& document);
    ~CFileListWindow();

    void SetInitRect(const CRect& rc) { m_ptWindow = rc.GetPoint(); m_szWindow = rc.GetSize(); }
    CRect GetInitRect() const { return CRect(m_ptWindow, m_szWindow); }

    bool IsVisible();
    void Show(HWND hParent);
    void Hide(bool setParentActive = true);

    void Update(int i);
    void UpdateAll();

private:
    void OnThread(void*);
    bool HookMsg(CMsgHookPrms& rPrms);
    void SetColumns(CListview& rListview);

private:
    CDocument& document;
    HWND                m_hParent;
    auto_ptr<CWindow>   m_pWindow;
    CSize               m_szWindow;
    CPoint              m_ptWindow;
    bool setParentActive;
};

