#pragma once
#include <Themis/Windows/ResourceDialogBase.h>
#include <Themis/Window.h>
#include <Themis/HotKey.h>
namespace Themis {
class CKeyConfig;
}

class CKeyConfigEx: private CResourceDialogBase, private CHotKey::IOwner {
public:
    CKeyConfigEx(CWindow& rWindow, const string& s);
    ~CKeyConfigEx();

    void ShowDialog();

    void UpdateMenubar(HMENU hMenu);

private:
    void LoadFromConfig();
    void LoadDefault();
    void SaveToConfig();

    bool HookMsg(CMsgHookPrms& rPrms);
    void UpdateEnabled();
    void UpdateListview();
    void UpdateListbox();

    void OnHotKey(CHotKey* pHotKey, int nId);

private:
    CWindow& m_rWindow;
    const string m_strConfigPrefix;
    std::tr1::shared_ptr<CHotKey> m_pHotKey;
    std::tr1::shared_ptr<CKeyConfig> m_pKeyConfig;
};

