#pragma once
#include <Themis/Windows/ResourceDialogBase.h>
#include <Themis/NetworkUpdaterBase.h>
#include <Themis/Window.h>

/**
*/
class CNetworkUpdater: public CResourceDialogBase, private CNetworkUpdaterBase {
public:
    CNetworkUpdater(CWindow& w, CConfig& r);
    ~CNetworkUpdater();

    bool IsUpdate() const { return m_bUpdate; }

private:
    // CResourceDialogBase
    bool HookMsg(CMsgHookPrms& rPrms);

    // CNetworkUpdaterBase
    CConfig& GetConfig();
    string GetConfigBaseName();
    string GetUpdateUrl() const;
    void OnOldNotice(const vector<string>& vctOldNotice);
    void OnGetInfoProgress(unsigned nCurrent, unsigned nMax);
    void OnGetInfoNoUpdate();
    void OnGetInfo(const CNetworkUpdateInfo& oInfo);
    void OnUpdateProgress(const string& strFileName, unsigned nCurrent, unsigned nMax, unsigned nCurrentAll, unsigned nMaxAll);
    bool ConfirmUpdate();
    void OnEndBackup();
    void OnError();
    void PostQuit();

    CWindow&                m_rWindow;
    CConfig&                m_rConfig;
    bool                    m_bUpdate;
};

