
#include "stdafx.h"
#include "AppWindow.h"
#include "NetworkUpdater.h"
#include <Themis/File.h>
#include <Themis/Allocator.h>
#include <Themis/CommandLine.h>
#include <Themis/ReuseAllocator.h>
#include <Themis/Thread/ThreadPool.h>

class CAppFrame : public CAppFrameBase {
    int InnerRun() {
        string strConfigPrefix = L"т";
        vector<CFileName> vctFiles;
        {
            CCommandLine oCmdLine(GetCmdLine());
            for (int i = 0, n = oCmdLine.GetCount(); i < n; i++) {
                if (oCmdLine.IsMatch(i, L"/version")) {
                    CFile(CFileNameModuleDir(L"version.txt")).Save(ItoA(CAppWindow::GetVersion()));
                    return 0;
                } else if (oCmdLine.IsMatch(i, L"/cfg:", 5)) {
                    strConfigPrefix = oCmdLine.Get(i).Substring(5); // 󔒓̏ꍇ L"/cfg:t@C O" ݂ɂȂႤǁBB
                } else {
                    vctFiles.push_back(oCmdLine.GetFileName(i));
                }
            }
        }
        return CAppWindow(strConfigPrefix).Run(vctFiles, GetCmdShow());
    }
};

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
    CAppFrame theApp;
    theApp.Initialize(hInstance, hPrevInstance, lpCmdLine, nCmdShow);
    theApp.InitCommonControls();
    int nRet = theApp.Run();

    ThreadPool::Garbage();
    return nRet;
}

//*
namespace {
 #if 0
    #define ALLOC_LOG   , CAllocatorLog
 #else
    #define ALLOC_LOG
 #endif
 // typedef CAllocator<0x80, 0x800 ALLOC_LOG> TAllocator;
    typedef CAllocator2<0x20, 0x2000, 0x40, 0x800 ALLOC_LOG> TAllocator;
 // typedef CAllocator3<0x20, 0x2000, 0x40, 0x400, 0x80, 0x400 ALLOC_LOG> TAllocator;
    TAllocator& GetAllocator() { static TAllocator o; return o; }
}
void* ::operator new(size_t n) {
    return GetAllocator().Alloc(n);
}
void ::operator delete(void* p) {
    GetAllocator().Free(p);
}
//*/
